// -------------------------------------------------------------------------------
// 
// 		cwCu		GraphFilternvO( Direct3D9 )wb_t@C
// 
// 				Ver 3.12e
// 
// -------------------------------------------------------------------------------

#ifndef __DXGRAPHICSFILTERD3D9_H__
#define __DXGRAPHICSFILTERD3D9_H__


// CN[h ------------------------------------------------------------------
#include "../DxCompileConfig.h"
#include "../DxLib.h"
#include "../DxGraphicsFilter.h"
#include "../DxArchive_.h"
#include "DxGraphicsD3D9.h"

#ifndef DX_NON_FILTER

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------


// \̒` --------------------------------------------------------------------

// tB^[p̏\
struct GRAPHFILTER_SYSTEMIFNO_DIRET3D9
{
	int						WorkDrawValidGrHandle[ 2 ][ 16 ][ 2 ] ;	// tB^[Ɨp`\eNX`[ 0:eNX` 1:_eNX` ][ Q̂ ][ ƗpQ ]
} ;


// ϐ錾 --------------------------------------------------------------

extern GRAPHFILTER_SYSTEMIFNO_DIRET3D9 GraphFilterSystemInfoD3D9 ;

// ֐vg^Cv錾-----------------------------------------------------------

// ˑ֌W
extern int	GraphFilter_D3D9_Mono_PF(        GRAPHFILTER_INFO *Info, float Cb, float Cr ) ;
extern int	GraphFilter_D3D9_Gauss_PF(       GRAPHFILTER_INFO *Info, int PixelWidth, float Param, float *Table ) ;
extern int	GraphFilter_D3D9_Down_Scale_PF(  GRAPHFILTER_INFO *Info, int DivNum ) ;
extern int	GraphFilter_D3D9_Bright_Clip_PF( GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor ) ;
extern int	GraphFilter_D3D9_HSB_PF(         GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright ) ;
extern int	GraphFilter_D3D9_Invert_PF(      GRAPHFILTER_INFO *Info ) ;
extern int	GraphFilter_D3D9_Level_PF(       GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax ) ;
extern int	GraphFilter_D3D9_TwoColor_PF(    GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor ) ;
extern int	GraphFilter_D3D9_GradientMap_PF( GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse ) ;
extern int	GraphFilter_D3D9_PremulAlpha_PF( GRAPHFILTER_INFO *Info ) ;
extern int	GraphFilter_D3D9_InterpAlpha_PF( GRAPHFILTER_INFO *Info ) ;
extern int	GraphFilter_D3D9_RectBltBase_PF( int IsBlend, int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int FilterOrBlendType, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int BlendPosEnable, int DestX, int DestY, va_list ParamList ) ;			// 摜̃tB^[t]s( ψt )

extern int	GraphBlend_D3D9_Basic_PF(           GRAPHFILTER_INFO *Info ) ;
extern int	GraphBlend_D3D9_RGBA_Select_Mix_PF( GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA ) ;

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_FILTER

#endif // __DXGRAPHICSFILTERD3D9_H__

