//-----------------------------------------------------------------------------
// 
// 		cwCu		WindowspOvO
// 
//  	Ver 3.12e
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxLogWin.h"

#ifndef DX_NON_LOG

#include "../DxStatic.h"
#include "../DxLib.h"
#include "../DxLog.h"
#include "../DxBaseFunc.h"
#include "../DxMemory.h"
#include "DxWindow.h"
#include "DxWinAPI.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

// ֐錾 -------------------------------------------------------------------

// vO -----------------------------------------------------------------

// G[ot@C鏈̊ˑ
extern int ErrorLogInitialize_Native( void )
{
	HANDLE fp ;
	TCHAR String[ 512 ] ;
	int Len ;

	// Oo͗}tOĂ邩A[U[w̃EChE
	// gpĂꍇ͏o͂sȂ
	if( LogData.NotLogOutFlag == TRUE /* || WinData.UserWindowFlag == TRUE */ ) return 0 ;

	// t̃Oo͂w肳Ăꍇ̓t@C쐬
	if( LogData.UseLogDateName == TRUE )
	{
		DATEDATA Date ;
		TCHAR String[128] ;

		// t擾
		NS_GetDateTime( &Date ) ;

		// ̍쐬
		lstrcpy( LogData.LogFileName, _T( "Log" ) ) ;
		_ITOT( Date.Year, String, 10 ) ;
		lstrcat( LogData.LogFileName, String ) ;
		lstrcat( LogData.LogFileName, _T( "_" ) ) ;
		_ITOT( Date.Mon, String, 10 ) ;
		lstrcat( LogData.LogFileName, String ) ;
		lstrcat( LogData.LogFileName, _T( "_" ) ) ;
		_ITOT( Date.Day, String, 10 ) ;
		lstrcat( LogData.LogFileName, String ) ;
		lstrcat( LogData.LogFileName, _T( "_" ) ) ;
		_ITOT( Date.Hour, String, 10 ) ;
		lstrcat( LogData.LogFileName, String ) ;
		lstrcat( LogData.LogFileName, _T( "_" ) ) ;
		_ITOT( Date.Min, String, 10 ) ;
		lstrcat( LogData.LogFileName, String ) ;
		lstrcat( LogData.LogFileName, _T( "_" ) ) ;
		_ITOT( Date.Sec, String, 10 ) ;
		lstrcat( LogData.LogFileName, String ) ;
		lstrcat( LogData.LogFileName, _T( ".txt" ) ) ;
	}
	else
	{
		// ȊȌꍇ͒ʏ̃t@C
		lstrcpy( LogData.LogFileName, _T( "Log.txt" ) ) ;
	}

	Len = lstrlen( LogData.LogOutDirectory ) ;
	_TSTRNCPY( String, LogData.LogOutDirectory, Len ) ;
	if( String[ Len - 1 ] != _T( '\\' ) )
	{
		String[ Len ] = _T( '\\' ) ;
		Len ++ ;
	}
	lstrcpy( String + Len, LogData.LogFileName ) ;

	// G[Ot@Cč쐬
	DeleteFile( String ) ;
	fp = CreateFile( String, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL ) ;

#ifdef UNICODE
	BYTE BOM[ 2 ] = { 0xff, 0xfe } ;
	DWORD WriteSize ;
	WriteFile( fp, &BOM, 2, &WriteSize, NULL ) ;
#endif

	if( fp != NULL ) CloseHandle( fp ) ;

	// I
	return 0 ;
}

// G[o
extern int NS_ErrorLogAdd( const TCHAR *ErrorStr )
{
	HANDLE fp ;
	DWORD WriteSize, StringLength ;
	TCHAR *Temp, DefaultTemp[256], *d, *AllocTemp = NULL ;
	const TCHAR *p1, *p2 ;

	if( WinAPIData.Win32Func.WinMMDLL == NULL )
		return -1 ;

	StringLength = lstrlen( ErrorStr ) ;
	Temp = DefaultTemp ;

	// 񂪗]ɂe|̈Ŋmۂ
	if( StringLength > 255 )
	{
		Temp = AllocTemp = ( TCHAR * )NS_DxAlloc( StringLength * 2 * sizeof( TCHAR ) ) ;
	}

	// \n  \r\n ɕϊȂRs[
	{
		Temp[0] = _T( '\0' ) ;
		p1 = ErrorStr ;
		d = Temp ;

		p2 = _TSTRCHR( p1, _T( '\n' ) ) ;
		while( p2 != NULL && ( ErrorStr == p2 || p2[-1] != _T( '\r' ) ) )
		{
			_MEMCPY( d, p1, ( p2 - p1 ) * sizeof( TCHAR ) ) ;
			d += p2 - p1 ;
			d[0] = _T( '\r' ) ;
			d[1] = _T( '\n' ) ;
			d[2] = _T( '\0' ) ;
			d += 2 ;
			p1 = p2 + 1 ;

			p2 = _TSTRCHR( p1, _T( '\n' ) ) ;
		}
		lstrcpy( d, p1 ) ;
		ErrorStr = Temp ;
	}

	// cwCu쐬EChEłꍇ̂݃t@Cɏo͂
	if( /*WinData.MainWindow != NULL && WinData.UserWindowFlag == FALSE */ true )
	{
		// Oo͗}tOĂꍇ͏o͂sȂ
		if( LogData.NotLogOutFlag == FALSE && LogData.LogOutDirectory[0] != _T( '\0' ) )
		{
//			TCHAR MotoPath[MAX_PATH] ;
			TCHAR String[ 512 ] ;
			int Len ;

			// G[Ot@CJ
//			FGETDIR( MotoPath ) ;
//			FSETDIR( LogData.LogOutDirectory ) ;
			Len = lstrlen( LogData.LogOutDirectory ) ;
			_TSTRNCPY( String, LogData.LogOutDirectory, Len ) ;
//			lstrcpy( String, LogData.LogOutDirectory ) ;
			if( String[ Len - 1 ] != _T( '\\' ) )
			{
				String[ Len ] = _T( '\\' ) ;
				Len ++ ;
			}
			lstrcpy( String + Len, LogData.LogFileName ) ;
			fp = CreateFile( String, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL ) ;
			if( fp != NULL )
			{
				SetFilePointer( fp, 0, NULL, FILE_END ) ;

				// K蕪^uro
				if( LogData.ErTabStop == FALSE )
				{
					int i ;	

					// ^CX^vo
					if( LogData.NonUseTimeStampFlag == 0 )
					{
						_TSPRINTF( _DXWTP( String ), _DXWTR( "%d:" ), WinAPIData.Win32Func.timeGetTimeFunc() - LogData.LogStartTime ) ;
						WriteFile( fp, String, lstrlen( String ) * sizeof( TCHAR ), &WriteSize, NULL ) ;
						OutputDebugString( String ) ;
					}

					if( LogData.ErTabNum != 0 )
					{
						for( i = 0 ; i < LogData.ErTabNum ; i ++ )
							String[i] = _T( '\t' ) ;
						String[i] = _T( '\0' ) ;
						WriteFile( fp, String, LogData.ErTabNum * sizeof( TCHAR ), &WriteSize, NULL ) ;
						OutputDebugString( String ) ;
					}
				}

				// G[Ot@Cɏo
				WriteFile( fp, ErrorStr, lstrlen( ErrorStr ) * sizeof( TCHAR ), &WriteSize, NULL ) ;

				// G[OAEgvbgɏo
				OutputDebugString( ErrorStr ) ;

				// Ō̕sӊOꍇ̓^uXgbvtO𗧂Ă
				LogData.ErTabStop = ErrorStr[ lstrlen( ErrorStr ) - 1 ] != _T( '\n' ) ;

				CloseHandle( fp ) ;
			}
//			FSETDIR( MotoPath ) ;
		}
	}
	else
	{
		// G[OAEgvbgɏo
		OutputDebugString( ErrorStr ) ;
	}

	// e|̈mۂĂJ
	if( AllocTemp != NULL )
	{
		NS_DxFree( AllocTemp ) ;
	}
	
	// I
	return -1 ;
}


// O@\̏sǂ擾
extern int IsInitializeLog( void )
{
	// cwCuIԂɓĂ珉Ȃ
	return NS_GetUseDDrawObj() == NULL || WinData.MainWindow == NULL ? FALSE : TRUE ;
}


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_LOG

