// -------------------------------------------------------------------------------
// 
// 		cwCu		֌WvOwb_t@C
// 
// 				Ver 3.12e
// 
// -------------------------------------------------------------------------------

#ifndef __DXMEMORY_H__
#define __DXMEMORY_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxThread.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#ifdef _WIN64
#define ALLOCNAMELENGTH			(32)
#define DXALLOC_INFO_SIZE		(64)
#else
#define ALLOCNAMELENGTH			(16)
#define DXALLOC_INFO_SIZE		(32)
#endif

#define DXADDRESS	(DXALLOC_INFO_SIZE * 2)
#define DXADDSIZE	(DXALLOC_INFO_SIZE * 3)

// mیn֐
//#ifdef DX_USE_DXLIB_MEM_DUMP
#if !defined( __BCC ) || defined( _DEBUG )
	#define DXALLOC( size )			NS_DxAlloc( (size), __FILE__, __LINE__ )
	#define DXCALLOC( size )		NS_DxCalloc( (size), __FILE__, __LINE__ )
	#define DXREALLOC( mem, size )	NS_DxRealloc( (mem), (size), __FILE__, __LINE__ )
	#define DXFREE( mem )			NS_DxFree( (mem) )
#else
	#define DXALLOC( size )			NS_DxAlloc( (size), "", 0 )
	#define DXCALLOC( size )		NS_DxCalloc( (size), "", 0 )
	#define DXREALLOC( mem, size )	NS_DxRealloc( (mem), (size), "", 0 )
	#define DXFREE( mem )			NS_DxFree( (mem) )
#endif

//#else
//	#define DXALLOC( size )			AllocWrap( (size) )
//	#define DXCALLOC( size )		CallocWrap( (size) )
//	#define DXREALLOC( mem, size )	ReallocWrap( (mem), (size) )
//	#define DXFREE( mem )			FreeWrap( (mem) )
//	#define DXALLOC( size )			malloc( (size) )
//	#define DXCALLOC( size )		calloc( 1, (size) )
//	#define DXREALLOC( mem, size )	realloc( (mem), (size) )
//	#define DXFREE( mem )			free( (mem) )
//#endif

// \̒` --------------------------------------------------------------------

// mۂ̏
#ifdef _WIN64
struct ALLOCMEM
{
	char					Name[ ALLOCNAMELENGTH ] ;			// t@CpX
	int						ID ;								// hc
	int						Line ;								// sԍ
	size_t					Size ;								// mۃTCY
	struct ALLOCMEM			*Back, *Next ;						// ƑO̊mۃւ̃|C^
} ;
#else
struct ALLOCMEM
{
	char					Name[ ALLOCNAMELENGTH ] ;			// t@CpX
	unsigned short			ID ;								// hc
	unsigned short			Line ;								// sԍ
	size_t					Size ;								// mۃTCY
	struct ALLOCMEM			*Back, *Next ;						// ƑO̊mۃւ̃|C^
} ;
#endif

// ֌W̏\
struct MEMORYDATA
{
	ALLOCMEM				AllocMemoryAnchor ;					// mۏ̍Ō
	char					AllocMemoryAnchorDummy[DXALLOC_INFO_SIZE * 2] ;
	ALLOCMEM				*AllocMemoryFirst ;					// mۏ̐擪
	unsigned short			AllocMemoryID ;						// mۂɊ蓖Ăhc
	size_t					AllocMemorySize ;					// mۂĂ郁̑
	int						AllocMemoryNum ;					// CuŊmۂ̐
	int						AllocMemoryPrintFlag ;				// mۂ鎞ɏo͂邩ǂ̃tO
	int						AllocMemorySizeOutFlag ;			// mۂsxɊmۃ̑ʂOɏo͂邩ǂ̃tO
	int						AllocMemoryErrorCheckFlag ;			// mۂsxɊmۃ̏񂪔jĂȂ`FbN邩ǂ̃tO
	size_t					AllocTrapSize ;						// 񋓑ΏۂɂmۃTCY

#if defined( DX_THREAD_SAFE ) || defined( DX_THREAD_SAFE_NETWORK_ONLY )
	int						InitMemoryAllocCriticalSection ;	// MemoryAllocCriticalSection ̏ςł邩ǂ̃tO
	DX_CRITICAL_SECTION		MemoryAllocCriticalSection ;		// mۏpNeBJZNV
#endif
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֌W̏
extern MEMORYDATA MemData ;

// ֐vg^Cv錾-----------------------------------------------------------

extern void			MemoryDump( void *buffer, int size ) ;
extern int			DxCheckAlloc( ALLOCMEM *Alloc ) ;										// mۏ񂪔j󂳂ĂȂׂ

// bp[֐
extern	void 		*AllocWrap( size_t AllocSize ) ;										// mۂ
extern	void 		*CallocWrap( size_t AllocSize ) ;										// mۂĂOŏ
extern	void		*ReallocWrap( void *Memory, size_t AllocSize ) ;						// ̍Ċmۂs
extern	void		FreeWrap( void *Memory ) ;												// 

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXMEMORY_H__
