// -------------------------------------------------------------------------------
// 
// 		cwCu		TEhvOwb_t@C
// 
// 				Ver 3.12e
// 
// -------------------------------------------------------------------------------

#ifndef __DXSOUND_H__
#define __DXSOUND_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_SOUND

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxRingBuffer.h"
#include "DxSoundConvert.h"
#include "DxHandle.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

#define MAX_SOUNDBUFFER_NUM				(10)			// DIRECTSOUNDBUFFER obt@̍ő吔
#define STS_SETSOUNDNUM					(4)				// Xg[TEhĐɓo^łTEh̐

#define D_X3DAUDIO_INPUTCHANNELS		(8)				// X3DAudio ̌vZŎgpő̓`l
#define SOUNDBUFFER_MAX_CHANNEL_NUM		(8)				// ΉTEh`l̍ő吔

// \̒` --------------------------------------------------------------------

// t@CTEhnh쐬鏈ɕKvȃO[of[^Z߂
struct LOADSOUND_GPARAM
{
	int						Create3DSoundFlag ;						// 3DTEh쐬邩ǂ̃tO( TRUE:RcTEh쐬  FALSE:RcTEh쐬Ȃ )
	int						CreateSoundDataType ;					// 쐬TEhf[^̃f[^^Cv
	int						DisableReadSoundFunctionMask ;			// gpȂǂݍݏ̃}XN
#ifndef DX_NON_OGGVORBIS
	int						OggVorbisBitDepth ;						// nugp̃rbg[x(1:8bit 2:16bit)
	int						OggVorbisFromTheoraFile ;				// Ogg Theora t@C Vorbis f[^QƂ邩ǂ̃tO( TRUE:Theora t@C Vorbis f[^QƂ )
#endif
} ;

// TEhobt@bNۂɎgpf[^^
struct SOUNDBUFFERLOCKDATA
{
	DWORD						StartOffst ;
	BYTE						*WriteP, *WriteP2 ;
	DWORD						Length, Length2 ;
	DWORD						Offset, Offset2 ;
	DWORD						Valid, Valid2 ;
} ;

// g`f[^\
struct WAVEDATA
{
	void						*Buffer ;				// g`f[^
	void						*DoubleSizeBuffer ;		// Q{eʂ̔g`f[^
	int							Bytes ;					// TCY
	int							RefCount ;				// QƐ
} ;

// XAudio2pR[obNp\
struct SOUNDBUFFER_CALLBACK : public D_IXAudio2VoiceCallback
{
	virtual void    __stdcall OnVoiceProcessingPassStart( DWORD BytesRequired ) ;
	virtual void    __stdcall OnVoiceProcessingPassEnd	() ;
	virtual void    __stdcall OnStreamEnd				() ;
	virtual void    __stdcall OnBufferStart				( void* pBufferContext ) ;
	virtual void    __stdcall OnBufferEnd				( void* pBufferContext ) ;
	virtual void    __stdcall OnLoopEnd					( void* pBufferContext ) ;
	virtual void    __stdcall OnVoiceError				( void* pBufferContext, HRESULT Error ) ;

	struct SOUNDBUFFER			*Buffer ;
} ;

// RcTEhf[^̊{Iȏ
struct _3DSOUNDINFO
{
	VECTOR						Position ;				// ʒu
	VECTOR						FrontDirection ;		// O
	VECTOR						UpDirection ;			// 
	VECTOR						Velocity ;				// ړx
	float						InnerAngle ;			// px
	float						OuterAngle ;			// Opx
	float						InnerVolume ;			// pxł̉ʃXP[
	float						OuterVolume ;			// Opxł̉ʃXP[
} ;

// TEhobt@\
struct SOUNDBUFFER
{
	int							Valid ;					// f[^Lۂ(TRUE:L FALSE:)

	union
	{
		D_IDirectSoundBuffer 		*DSBuffer ;				// DirectSoundBuffer
		D_IXAudio2SourceVoice		*XA2SourceVoice ;		// XAudio2SourceVoice
		D_IXAudio2_8SourceVoice		*XA2_8SourceVoice ;		// XAudio2_8SourceVoice
	} ;
	union
	{
		D_IXAudio2SubmixVoice		*XA2SubmixVoice ;		// XAudio2SubmixVoice
		D_IXAudio2_8SubmixVoice		*XA2_8SubmixVoice ;		// XAudio2_8SubmixVoice
	} ;
	IUnknown					*XA2ReverbEffect ;		// o[uGtFNg
	SOUNDBUFFER_CALLBACK		*XA2Callback ;			// XAudio2p̃R[obN

	union
	{
		D_XAUDIO2FX_REVERB_PARAMETERS    XAudio2ReverbParameter ;	// o[uvZpp[^
		D_XAUDIO2FX_REVERB_PARAMETERS2_8 XAudio2_8ReverbParameter ;	// o[uvZpp[^XAudio2.8p
	} ;

	int							Pan ;					// p( 10000:100%E0%  0:E100%  -100000:E100% )
	int							Volume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;	// {[( 10000:0%  0:100% )
	int							Frequency ;				// Đg( -1:ftHg )
	int							SampleNum ;				// Tv̐
	WAVEFORMATEX				Format ;				// obt@̃tH[}bg

	// DirectSound ȊȌꍇɎgp
	WAVEDATA					*Wave ;					// g`f[^obt@
	volatile int				State ;					// Đ( TRUE:Đ  FALSE:~ )
	volatile int				Pos ;					// Đʒu
	volatile int				CompPos ;				// ]ʒu
	int							Loop ;					// [v邩ǂ( TRUE:[v  FALSE:[vȂ )
	int							CalcPan ;				// Lv`pɌvZ̃p( 256:100%E0%  0:E100%  -256:E100% )
	int							CalcVolume ;			// Lv`pɌvZ̃{[( 256:100%  0:0% )
	int							XAudioChannels ;		// XAudio ł̃`l
	volatile int				StopTimeState ;			// StopTime ̏( 0:얳 1:ĐI҂ 2:Ԍoߑ҂ )
	volatile int				StopTime ;				// Đ~

	// RcTEhĐpf[^
	int							Is3DSound ;												// RcTEhǂ
	D_X3DAUDIO_EMITTER			X3DAudioEmitterData ;									// RcTEhp
	D_X3DAUDIO_CONE				X3DAudioEmitterConeData ;								// RcTEhpŎgpR[
	float						X3DAudioEmitterChannelAzimuths[ D_X3DAUDIO_INPUTCHANNELS ] ;	// RcTEhpŎgp`lʒue[u
	_3DSOUNDINFO				EmitterInfo ;											// RcTEhp̏
	float						EmitterRadius ;											// RcTEhp̉͂
	int							EmitterDataChangeFlag ;									// RcTEhp񂪕ύXꂽǂ( TRUE:ύXꂽ  FALSE:ύXĂȂ )
	float						DSound_Calc3DVolume ;									// DirectSoundp̂RcvZ̃{[
	float						DSound_Calc3DPan ;										// DirectSoundp̂RcvZ̃p
} ;

// Xg[TEhvCpt@Cf[^
struct STREAMFILEDATA
{
	char						LoopNum ;					// [v( -1:[v )
	int							DataType ;					// f[^̃^Cv( DX_SOUNDDATATYPE_MEMNOPRESS  )
	void						*FileImage ;				// ɓWJt@CC[W( DX_SOUNDDATATYPE_FILE ȊOŎgp )
	int							FileImageSize ;				// ɓWJt@CC[W̃TCY( DX_SOUNDDATATYPE_FILE ȊOŎgp )
	STREAMDATA					MemStream ;					// Xg[pf[^( DX_SOUNDDATATYPE_FILE ȊOŎgp )
	int							LoopSamplePosition ;		// [v̍Đʒu(TvPʁAOGG  kWAV ̂ݗL )
	int							LoopStartSamplePosition ;	// [vJnĐʒu(TvPʁAOGG  kWAV ̂ݗL )
	
	SOUNDCONV					ConvData ;					// tH[}bgϊpf[^
} ;

// Xg[TEhvCpf[^
struct STREAMPLAYDATA
{
	int							BufferBorrowSoundHandle ;								// DirectSoundBuffer ݂ĂTEhnh(-1:؂ĂȂ)
	int							BufferBorrowSoundHandleCount ;							// DirectSoundBuffer ݂Ă鐔(0:݂ĂȂ)
	int							BufferUseSoundHandle ;									// DirectSoundBuffer ݎgpĂTEhnh(-1:N͎gĂȂ)
	int							DeleteWaitFlag ;										// DirectSoundBuffer ݂Ă邩폜łȂŋ̂AtO
	
	BYTE						*SoundBuffer ;											// TEhobt@( XAudio2p )
	DWORD						SoundBufferSize ;										// DirectSoundBuffer ̃TCY( Pʂ̓oCg )
	int							SoundBufferCompCopyOffset ;								// ÕTEhf[^Rs[œ]TEhf[^̖̈[ItZbg
	int							SoundBufferCopyStartOffset ;							// w܂ł玟̃TEhf[^Rs[JnxƂf[^ItZbg

	STREAMFILEDATA				File[ STS_SETSOUNDNUM ] ;								// Xg[t@Cf[^
	BYTE						FileLibraryLoadFlag[ STS_SETSOUNDNUM ] ;				// Cu[hf[^ǂ
	int							FileNum ;												// Xg[t@Cf[^̐
	int							FileActive ;											// ANeBuȃXg[t@Cf[^ԍ
	int							FileLoopCount ;											// ݃ANeBuȃXg[f[^[v
	int							FileCompCopyLength ;									// ݃ANeBuȃXg[f[^̃TEhobt@ւ̓]oCg
	int							TotalSample ;											// SXg[̃Tv

	DWORD						CompPlayWaveLength ;									// ĐIg`f[^̒
	DWORD						PrevCheckPlayPosition ;									// O`FbNĐʒu

	BYTE						StartSetupCompFlag ;									// ĐtO
	BYTE						EndWaitFlag ;											// I҂tO
	BYTE						LoopPositionValidFlag ;									// [vʒuLtO
	BYTE						AllPlayFlag ;											// ŜʂĈxłŌłĐtO
	DWORD						LoopAfterCompPlayWaveLength ;							// [v CompPlayWaveLength ɉZl
	
	DWORD						EndOffset ;												// IItZbg
	DWORD						EndStartOffset ;										// IJnItZbg
	DWORD						LoopPosition ;											// [vʒu(Đobt@̃AhX)

	HANDLELIST					StreamSoundList ;										// Xg[TEhXgp\
} ;

// m[}TEhvCpf[^
struct NORMALPLAYDATA
{
	int							WaveSize ;												// g`f[^̃TCY
	void						*WaveData ;												// g`f[^
	int							*WaveDataUseCount ;										// g`f[^QƐ
	int							BufferDuplicateFlag[ MAX_SOUNDBUFFER_NUM ] ;			// ꂽTEhobt@ǂ̃tO
	int							BackPlayBufferNo ;										// OɍĐTEhobt@̔ԍ(Đpobt@ꍇp)
} ;

// TEhf[^
struct SOUND
{
	HANDLEINFO					HandleInfo ;											// nhʏ

	HANDLELIST					_3DSoundList ;											// RcTEhXgp\
	int							Is3DSound ;												// RcTEhǂ( TRUE:RcTEh  FALSE:RcTEh )
	int							AddPlay3DSoundList ;									// Play3DSoundList XgɒǉĂ邩ǂ( TRUE:ǉĂ  FALSE:ǉĂȂ )
	HANDLELIST					Play3DSoundList ;										// Đ̂RcTEh̃Xgp\

	int							PlayFinishDeleteFlag ;									// TEh̍ĐI폜邩ǂ( TRUE:폜  FALSE:폜Ȃ )
	HANDLELIST					PlayFinishDeleteSoundList ;								// TEh̍ĐI폜TEh̃Xgp\

//	char						FilePath[ 256 ] ;										// fBNg
//	char						SoundName[ 256 ] ;										// TEht@Cl[

	int							ValidBufferNum ;										// Lȃobt@̐
	int							BufferPlayStateBackupFlagValid[ MAX_SOUNDBUFFER_NUM ] ;	// BufferPlayStateBackupFlag Lǂ̃tO( TRUE:L  FALSE: )
	int							BufferPlayStateBackupFlag[ MAX_SOUNDBUFFER_NUM ] ;		// TEhobt@ꎞ~Ƃ̍ĐԃtO
	SOUNDBUFFER					Buffer[ MAX_SOUNDBUFFER_NUM ] ;							// TEhobt@
	WAVEFORMATEX				BufferFormat ;											// TEhobt@̃tH[}bg

	int							Type ;													// TEh̃^Cv
	int							PlayType ;												// Đ^Cv

	STREAMPLAYDATA				Stream ;												// Xg[TEhvCpf[^
	NORMALPLAYDATA				Normal ;												// m[}TEhvCpf[^

	int							PresetReverbParam ;										// RcTEhɐݒ肷vZbgo[up[^ԍ( DX_REVERB_PRESET_DEFAULT  )
	SOUND3D_REVERB_PARAM		ReverbParam ;											// RcTEhɐݒ肷郊o[up[^( PresetReverbParam  -1 ̍ۂɎgp )

	int							BaseVolume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;				// {{[( -1:ftHg )
	int							BasePan ;												// {p( -1:ftHg )
	int							BaseFrequency ;											// {Đg( -1:ftHg )
	VECTOR						Base3DPosition ;										// {Đʒu
	float						Base3DRadius ;											// {鋗
	VECTOR						Base3DVelocity ;										// {̑x

	BYTE						ValidNextPlayVolume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;	// NextPlayVolume Lǂ( 1:L 0: )
	BYTE						ValidNextPlayPan ;										// NextPlayPan Lǂ( 1:L 0: )
	BYTE						ValidNextPlayFrequency ;								// NextPlayFrequency Lǂ( 1:L 0: )
	BYTE						ValidNextPlay3DPosition ;								// NextPlay3DPosition Lǂ( 1:L 0: )
	BYTE						ValidNextPlay3DRadius ;									// NextPlay3DRadius Lǂ( 1:L 0: )
	BYTE						ValidNextPlay3DVelocity ;								// NextPlay3DVelocity Lǂ( 1:L 0: )
	int							NextPlayVolume[ SOUNDBUFFER_MAX_CHANNEL_NUM ] ;			// ɖ炷̃{[
	int							NextPlayPan ;											// ɖ炷̃p
	int							NextPlayFrequency ;										// ɖ炷̎g
	VECTOR						NextPlay3DPosition ;									// ɖ炷̈ʒu
	float						NextPlay3DRadius ;										// ɖ炷̕鋗
	VECTOR						NextPlay3DVelocity ;									// ɖ炷̈ړx
} ;

// \tgEGAňg`f[^̔g`f[^\
struct SOFTSOUND_WAVE
{
	int							BufferSampleNum ;										// obt@̃TCY( Tv )
	void						*Buffer ;												// f[^obt@
} ;

// \tgEGAňg`f[^̃vC[\
struct SOFTSOUND_PLAYER
{
	HANDLELIST					SoftSoundPlayerList ;									// \tgEGATEhvC[Xgp\

	int							StockSampleNum ;										// XgbNĂTv̐
	RINGBUF						StockSample ;											// TvXgbNpOobt@

	int							SoundBufferPlayStateBackupFlagValid ;					// SoundBufferPlayStateBackupFlag Lǂ̃tO( TRUE:L  FALSE: )
	int							SoundBufferPlayStateBackupFlag ;						// TEhobt@ꎞ~Ƃ̍ĐԃtO
	SOUNDBUFFER					SoundBuffer ;											// ĐpTEhobt@
	int							SoundBufferSize ;										// ĐpTEhobt@̃TCY( oCgP )
//	int							BackCheckPlayOffset ;									// OɃ`FbNĐʒu
	int							DataSetCompOffset ;										// f[^ZbgςłTEhobt@̈ʒu( -1:܂ZbgĂȂ )

	int							NoneDataSetCompOffset ;									// f[^̃ZbgJnTEhobt@̈ʒu( -1:܂ZbgĂȂ )
	int							NoneDataPlayCheckBackPlayOffset ;						// f[^̍ĐJno邽߂̑O`FbN̍Đʒu
	int							NoneDataPlayStartFlag ;									// f[^̍ĐJnĂ邩ǂtO( TRUE:Ă  FALSE:ĂȂ )

	int							MaxDataSetSize ;										// ĐʒuɐsăZbgőf[^TCYAoCgP( săZbgĂf[^̃TCỸTCYȏɂȂȂ悤ɂ )
	int							MinDataSetSize ;										// ĐʒuɐsăZbgŏf[^TCYAoCgP( săZbgĂf[^̃TCỸTCYȉɂȂȂ悤ɂ )

	int							IsPlayFlag ;											// Đǂ̃tO( TRUE:Đ   FALSE:~ )
} ;

// \tgEGAňg`f[^
struct SOFTSOUND
{
	HANDLEINFO					HandleInfo ;											// nhʏ

	int							IsPlayer ;												// vC[ǂ̃tO( TRUE:vC[  FALSE:TEhf[^ )
	WAVEFORMATEX				BufferFormat ;											// TEh̃tH[}bg

	union
	{
		SOFTSOUND_WAVE			Wave ;													// g`f[^
		SOFTSOUND_PLAYER		Player ;												// vC[
	} ;
} ;


// crf[^\̒`
struct DIRECTSOUNDDATA
{
	int							InitializeFlag ;				// tO

	D_IDirectMusicLoader8		*DirectMusicLoaderObject ;		// DirectMusicLoader8 IuWFNg
	D_IDirectMusicPerformance8	*DirectMusicPerformanceObject ;	// DirectMusicPerformance8 IuWFNg

	HMODULE						XAudio2_8DLL ;					// XAudio2_8.dll
	HRESULT						( WINAPI *XAudio2CreateFunc )( D_IXAudio2_8 ** ppXAudio2, DWORD Flags, D_XAUDIO2_PROCESSOR XAudio2Processor );
	HRESULT						( WINAPI *CreateAudioVolumeMeterFunc )( IUnknown** ppApo ) ;
	HRESULT						( WINAPI *CreateAudioReverbFunc )( IUnknown** ppApo ) ;

	HMODULE						X3DAudioDLL ;					// X3DAudio.dll
	void						( __cdecl *X3DAudioInitializeFunc )( DWORD SpeakerChannelMask, float SpeedOfSound, D_X3DAUDIO_HANDLE Instance ) ;
	void						( __cdecl *X3DAudioCalculateFunc )( const D_X3DAUDIO_HANDLE Instance, const D_X3DAUDIO_LISTENER* pListener, const D_X3DAUDIO_EMITTER* pEmitter, DWORD Flags, D_X3DAUDIO_DSP_SETTINGS* pDSPSettings ) ;

	union
	{
		D_IXAudio2				*XAudio2Object ;				// XAudio2IuWFNg
		D_IXAudio2_8			*XAudio2_8Object ;				// XAudio2_8IuWFNg
		D_IDirectSound			*DirectSoundObject ;			// crIuWFNg
	} ;

	D_XAUDIO2FX_REVERB_PARAMETERS    XAudio2ReverbParameters[ D_XAUDIO2FX_PRESET_NUM ] ;	// o[uvZpp[^
	D_XAUDIO2FX_REVERB_PARAMETERS2_8 XAudio2_8ReverbParameters[ D_XAUDIO2FX_PRESET_NUM ] ;	// o[uvZpp[^XAudio2.8p
	D_IXAudio2MasteringVoice	*XAudio2MasteringVoiceObject ;	// XAudio2MasteringVoiceIuWFNg
	D_IXAudio2_8MasteringVoice	*XAudio2_8MasteringVoiceObject ;// XAudio2_8MasteringVoiceIuWFNg
	D_XAUDIO2_EFFECT_CHAIN		XAudio2MasteringEffectChain ;	// }X^[{CXp̃GtFNg`FC

	DWORD						XAudio2OutputChannelMask ;		// o̓`l}XN
	DWORD						OutputChannels ;				// o̓`l
	DWORD						OutputSmaplesPerSec ;			// o̓TvO[g

	int							_3DSoundOneMetreEnable ;		// _3DSoundOneMetre Lǂ( TRUE:L  FALSE: )
	float						_3DSoundOneMetre ;				// RcTEhp̂P[g
	D_X3DAUDIO_HANDLE			X3DAudioInstance ;				// RcTEhvZpCX^Xnh
	D_X3DAUDIO_CONE				X3DAudioListenerConeData ;		// RcTEh̃Xi[ɎgpR[
	D_X3DAUDIO_LISTENER			X3DAudioListenerData ;			// RcTEh̃Xi[
	_3DSOUNDINFO				ListenerInfo ;					// RcTEh̃Xi[̏
	VECTOR						ListenerSideDirection ;			// RcTEh̃Xi[̉

	D_IDirectSoundBuffer		*PrimarySoundBuffer ;			// vC}TEhobt@
	D_IDirectSoundBuffer		*BeepSoundBuffer ;				// r[vpobt@

	HANDLELIST					_3DSoundListFirst ;				// RcTEhnhXg̐擪
	HANDLELIST					_3DSoundListLast ;				// RcTEhnhXg̏I[

	HANDLELIST					StreamSoundListFirst ;			// Xg[TEhnhXg̐擪
	HANDLELIST					StreamSoundListLast ;			// Xg[TEhnhXg̏I[

	HANDLELIST					SoftSoundPlayerListFirst ;		// \tgEGAňg`f[^̃vC[̃nhXg̐擪
	HANDLELIST					SoftSoundPlayerListLast ;		// \tgEGAňg`f[^̃vC[̃nhXg̏I[

	HANDLELIST					PlayFinishDeleteSoundListFirst ; // ĐIɍ폜TEhnhXg̐擪
	HANDLELIST					PlayFinishDeleteSoundListLast ;	 // ĐIɍ폜TEhnhXg̏I[

	HANDLELIST					Play3DSoundListFirst ;			// ĐĂRcTEhXg̐擪
	HANDLELIST					Play3DSoundListLast ;			// ĐĂRcTEhXg̏I[

	int							PlayWavSoundHandle ;			// PlayWav֐Ŗ炳ĂWAVEf[^̃nh
	D_IDirectSoundBuffer		*NoSoundBuffer ;				// obt@

	int							DisableXAudioFlag ;				// XAudiogpȂǂ̃tO( TRUE:gpȂ  FALSE:gp ) 
	int							Create3DSoundFlag ;				// 3DTEh쐬邩ǂ̃tO( TRUE:RcTEh쐬  FALSE:RcTEh쐬Ȃ )
	int							OldVolumeTypeFlag ;				// Ver3.10cȑỎʌvZgp邩ǂ̃tO( TRUE:ÂvZgp  FALSE:VvZgp )
	int							SoundMode ;						// Đ`

	int							MaxVolume ;						// ő剹
	int							UseSoftwareMixing ;				// \tgEGA~LVOsǂ̃tO( TRUE:\tgEGA  FALSE:n[hEGA )

	int							EnableSoundCaptureFlag ;		// TEhLv`OƂ
	int							SoundCaptureFlag ;				// TEhLv`sĂŒǂ̃tO(TRUE:Œ FASLE:Ⴄ)
	int							SoundCaptureSample ;			// Lv`Tv̐(44.1KHzZ)
	HANDLE						SoundCaptureFileHandle ;		// Lv`TEhۑĂt@C

	int							CreateSoundDataType ;			// 쐬TEhf[^̃f[^^Cv
	int							DisableReadSoundFunctionMask ;	// gpȂǂݍݏ̃}XN
#ifndef DX_NON_OGGVORBIS
	int							OggVorbisBitDepth ;				// nugp̃rbg[x(1:8bit 2:16bit)
	int							OggVorbisFromTheoraFile ;		// Ogg Theora t@C Vorbis f[^QƂ邩ǂ̃tO( TRUE:Theora t@C Vorbis f[^QƂ )
#endif

	HANDLE						StreamSoundThreadHandle ;		// Xg[TEhĐ鏈sXbh̃nh
	DWORD						StreamSoundThreadID ;			// Xg[TEhĐ鏈sXbĥhc
	DWORD						StreamSoundThreadEndFlag ;		// Xg[TEhĐ鏈I邩ǂ̃tO
} ;

// lhchf[^
struct MIDIHANDLEDATA
{
	HANDLEINFO					HandleInfo ;					// nhʃf[^

	int							PlayFlag ;						// ĐAtO
	int							PlayStartFlag ;					// ĐJnꂽAtO
	int							Volume ;						// 

	void						*DataImage ;					// lhcht@C̃f[^i[ĂAhX( DSOUND.SoundMode  DX_MIDIMODE_MCI ̎̂ݗL )
	int							DataSize ;						// lhcht@C̃f[^TCY( DSOUND.SoundMode  DX_MIDIMODE_MCI ̎̂ݗL )

	D_IDirectMusicSegment8		*DirectMusicSegmentObject ;		// DirectMusicSegment8 IuWFNg
	int							StartTime ;						// ĐJn
} ;

// lhchǗf[^^
struct MIDIDATA
{
	int							PlayFlag ;						// ttO
	int							PlayHandle ;					// t̃nh

	TCHAR						FileName[ MAX_PATH ] ;			// t@Cl[

	UINT						MidiID ;						// lhcht̂hc
	int							LoopFlag ;						// [vtAtO

	D_IDirectMusicSegment8		*DirectMusicSegmentObject ;		// DirectMusicSegment8 IuWFNg
	int							StartTime ;						// ĐJn

	int							MemImagePlayFlag ;				// ̃C[WgpčĐĂ邩AtO( TRUE:C[W  FALSE:t@C )

	int							DefaultHandle ;					// W̍Đ֐ŎgpMIDInh
	int							DefaultHandleToSoundHandleFlag ;	// W̍Đ֐ōĐĂnh͉nhAtO
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// crf[^
extern DIRECTSOUNDDATA DX_DirectSoundData ;

// ֐vg^Cv錾-----------------------------------------------------------

extern	int		InitializeDirectSound( void ) ;																			// cr
extern	int		TerminateDirectSound( void ) ;																			// cr̎gpI

extern	int		RefreshStreamSoundPlayCompLength( int SoundHandle, int CurrentPosition = -1, int ASyncThread = FALSE ) ;	// TEhnh̍ĐԂXV
extern	int		ST_SoftSoundPlayerProcessAll( void ) ;																	// \tgEGAŐ䂷SẴTEhf[^vC[̒s

extern	int		MidiCallBackProcess( void ) ;																			// lhchtIĂ΂R[obN֐

extern	int		StartSoundCapture( const char *SaveFilePath ) ;															// TEhLv`̊Jn
extern	int		SoundCaptureProcess( int CaptureSample ) ;																// TEhLv`̎I
extern	int		EndSoundCapture( void ) ;																				// TEhLv`̏I

extern	void	InitLoadSoundGParam( LOADSOUND_GPARAM *GParam ) ;														// LOADSOUND_GPARAM ̃f[^Zbg

extern	int		InitializeSoundHandle( HANDLEINFO *HandleInfo ) ;														// TEhnh̏
extern	int		TerminateSoundHandle( HANDLEINFO *HandleInfo ) ;														// TEhnȟn

extern	int		LoadSoundMemBase_UseGParam( LOADSOUND_GPARAM *GParam, const TCHAR *WaveName, int BufferNum, int UnionHandle, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;																					// LoadSoundMemBase ̃O[oϐɃANZXȂo[W
extern	int		LoadSoundMemByMemImageBase_UseGParam( LOADSOUND_GPARAM *GParam, int CreateSoundHandle, int SoundHandle, const void *FileImageBuffer, int ImageSize, int BufferNum, int UnionHandle = -1, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;		// LoadSoundMemByMemImageBase ̃O[oϐɃANZXȂo[W
extern	int		LoadSoundMem2_UseGParam( LOADSOUND_GPARAM *GParam, const TCHAR *WaveName1 , const TCHAR *WaveName2, int ASyncLoadFlag = FALSE ) ;																													// LoadSoundMem2 ̃O[oϐɃANZXȂo[W
extern	int		LoadSoundMem2ByMemImage_UseGParam( LOADSOUND_GPARAM *GParam, const void *FileImageBuffer1, int ImageSize1, const void *FileImageBuffer2, int ImageSize2, int ASyncLoadFlag = FALSE ) ;																			// LoadSoundMem2ByMemImage ̃O[oϐɃANZXȂo[W

extern	int		AddStreamSoundMem_UseGParam( LOADSOUND_GPARAM *GParam, STREAMDATA *Stream, int LoopNum,  int SoundHandle, int StreamDataType, int *CanStreamCloseFlag, int UnionHandle = -1, int ASyncThread = FALSE ) ;											// AddStreamSoundMem ̃O[oϐɃANZXȂo[W
extern	int		AddStreamSoundMemToFile_UseGParam( LOADSOUND_GPARAM *GParam, const TCHAR *WaveFile, int LoopNum,  int SoundHandle, int StreamDataType, int UnionHandle = -1, int ASyncThread = FALSE ) ;															// AddStreamSoundMemToFile ̃O[oϐɃANZXȂo[W
extern	int		AddStreamSoundMemToMem_UseGParam( LOADSOUND_GPARAM *GParam, void *FileImageBuffer, int ImageSize, int LoopNum,  int SoundHandle, int StreamDataType, int UnionHandle = -1, int ASyncThread = FALSE ) ;												// AddStreamSoundMemToMem ̃O[oϐɃANZXȂo[W
extern	int		SetupStreamSoundMem_UseGParam( int SoundHandle, int ASyncThread = FALSE ) ;																																											// SetupStreamSoundMem ̃O[oϐɃANZXȂo[W
extern	int		ProcessStreamSoundMem_UseGParam( int SoundHandle, int ASyncThread = FALSE ) ;																																										// ProcessStreamSoundMem ̃O[oϐɃANZXȂo[W

extern	int		Refresh3DSoundParamAll() ;																				// Đׂ̂Ă̂RcTEh̃p[^XV

extern	int		ProcessPlayFinishDeleteSoundMemAll( void ) ;															// ĐITEhnh폜TEh̏s
extern	int		ProcessPlay3DSoundMemAll( void ) ;																		// RcTEhĐĂTEhnhɑ΂鏈s

extern	int		SetupSoftSoundHandle( int SoftSoundHandle, int IsPlayer, int Channels, int BitsPerSample, int SamplesPerSec, int SampleNum ) ;	// \tgTEhnhZbgAbv

extern	int		InitializeSoftSoundHandle( HANDLEINFO *HandleInfo ) ;													// \tgTEhnh̏
extern	int		TerminateSoftSoundHandle( HANDLEINFO *HandleInfo ) ;													// \tgTEhnȟn

extern	int		DeleteCancelCheckSoftSoundFunction( HANDLEINFO *HandleInfo ) ;											// \tgTEhnh폜邩ǂ`FbN֐
extern	int		DeleteCancelCheckSoftSoundPlayerFunction( HANDLEINFO *HandleInfo ) ;									// \tgTEhv[[nh폜邩ǂ`FbN֐

extern	int		LoadSoftSoundBase_UseGParam( LOADSOUND_GPARAM *GParam, const TCHAR *FileName, const void *FileImage, int FileImageSize, int ASyncLoadFlag = FALSE ) ;		// \tgEGAňg`f[^t@C܂̓ɓWJꂽt@CC[W쐬
extern	int		MakeSoftSoundBase_UseGParam( int IsPlayer, int Channels, int BitsPerSample, int SamplesPerSec, int SampleNum, int UseFormat_SoftSoundHandle = -1, int ASyncLoadFlag = FALSE ) ;	// \tgEGAŐ䂷TEhf[^nh̍쐬

extern	int		AddMusicData( void ) ;																					// Vlhchnh擾

extern	int		InitializeMidiHandle( HANDLEINFO *HandleInfo ) ;														// lhchnh֐
extern	int		TerminateMidiHandle( HANDLEINFO *HandleInfo ) ;															// lhchnȟns֐

extern	int		LoadMusicMemByMemImage_UseGParam( void *FileImage, int FileImageSize, int ASyncLoadFlag = FALSE ) ;		// LoadMusicMemByMemImage ̃O[oϐɃANZXȂo[W
extern	int		LoadMusicMem_UseGParam( const TCHAR *FileName, int ASyncLoadFlag = FALSE ) ;							// LoadMusicMem ̃O[oϐɃANZXȂo[W
extern	int		LoadMusicMemByResource_UseGParam( const TCHAR *ResourceName, const TCHAR *ResourceType, int ASyncLoadFlag = FALSE ) ;	// LoadMusicMemByResource ̃O[oϐɃANZXȂo[W

extern	int		PauseSoundMemAll( int PauseFlag ) ;																		// SẲ̈ꎞ~ԂύX
extern	int		PauseSoftSoundAll( int PauseFlag ) ;																	// SẴ\tgEGATEḧꎞ~ԂύX

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_SOUND

#endif // __DXSOUND_H__
