// -------------------------------------------------------------------------------
// 
// 		cwCu		WbCugpR[h@Ogg֌Wwb_t@C
// 
// 				Ver 3.12e
// 
// -------------------------------------------------------------------------------

#ifndef __DXUSECLIBOGG_H__
#define __DXUSECLIBOGG_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"

#ifndef DX_NON_OGGTHEORA
#include "DxMovie.h"
#endif

#if !defined( DX_NON_OGGVORBIS ) || !defined( DX_NON_MOVIE )
#include "DxSoundConvert.h"
#endif

#include "DxFile.h"
#include "DxBaseFunc.h"

#if defined( DX_NON_OGGVORBIS ) && defined( DX_NON_OGGTHEORA )
#else
    #include "vorbis/codec.h"
    #include "vorbis/vorbisfile.h"
    
    #include "os.h"
    #include "misc.h"
#endif

#ifndef DX_NON_OGGVORBIS
	//#include "codec.h"
	#include "vorbis/vorbisfile.h"
	
    #include "vorbis/codec.h"
#endif

#ifndef DX_NON_OGGTHEORA
	//#include "codec.h"
	#include "vorbis/vorbisfile.h"
	
    #include "theora/theora.h"
#endif

//namespace DxLib
//{

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

#ifndef DX_NON_OGGTHEORA
// Ogg y[Wwb_( wb_̃TCY̋ߕ Segments + 27 )
typedef struct tagOGG_HEADER
{
	char					ID[ 4 ] ;					// ID "OggS"
	BYTE					Version ;					// o[W
	BYTE					HeadType ;					// wb_[^Cv
	BYTE					GranulePosition[ 8 ] ;		// AhX( gGfBA )
	BYTE					SerialNumber[ 4 ] ;			// VAio[
	BYTE					PageNumber[ 4 ] ;			// y[Wio[
	BYTE					CRCCehckSum[ 4 ] ;			// CRC`FbNT
	BYTE					Segments ;					// ZOg
	BYTE					SegmentTable[ 1 ] ;			// ZOge[u
} OGG_HEADER ;

// y[W̏
typedef struct tagTHEORA_PAGEINFO
{
	int						StreamAddres ;				// Xg[̃AhX
	int						FrameAddres ;				// Theora 撆̃t[
	int						KeyFrame ;					// L[t[܂܂Ă邩ǂ
	int						FrameNum ;					// y[WɊ܂܂t[
} THEORA_PAGEINFO ;

// XgbNt[̏
typedef struct tagTHEORA_STOCKFRAME
{
	volatile int			UseFlag ;					// gpĂ邩ǂ( 1:gpĂ  0:gpĂȂ )
	volatile int			FrameNumber ;				// ۑĂ摜̃t[

	void					*YBuffer ;					// xC[Wւ̃AhX
	void					*UBuffer ;					// tC[Wւ̃AhX
	void					*VBuffer ;					// uC[Wւ̃AhX
	int						YWidth, YHeight ;			// xC[W̕ƍ
	int						YStride ;					// xobt@̃sb`
	int						UVWidth, UVHeight ;			// tuC[W̕ƍ
	int						UVStride ;					// tuobt@̃sb`
} THEORA_STOCKFRAME ;

// Ogg Theora fR[hpf[^\
typedef struct tagDECODE_THEORA
{
	DX_CRITICAL_SECTION		CriticalSection ;			// Xbhł̋h~p̃NeBJZNV

	volatile int			ThreadState ;				// Xbh̏( THEORAT_STATE_IDLE  )
	volatile int			ThreadStopRequest ;			// XbhɎ~܂ĂقƂ 1 ɂ
	volatile int			ThreadExitRequest ;			// XbhɏIĂقƂ 1 ɂ
	volatile int			ThreadSeekRequest ;			// XbhɃV[Nė~Ƃ 1 ɂ
	volatile int			ThreadSeekFrame  ;			// XbhɃV[NĖႤƂ̃V[Nt[
	volatile int			ThreadPacketEnd ;			// f[^SēǂݏItO
	volatile int			ThreadStandbyTime ;			// ҋ@ԂێڈƂ鎞
	HANDLE					DecodeThreadHandle ;		// fR[hXbh
	DWORD					DecodeThreadID ;			// fR[hXbĥhc 

	STREAMDATASHREDTYPE2	StreamShred ;				// Xg[֐
	DWORD_PTR				StreamData ;				// Xg[f[^

	ogg_sync_state			OggSyncState ;				// Ogg x[Xf[^
	ogg_page				OggPage ;					// Ogg y[W
	ogg_stream_state		OggTheoraStream ;			// Ogg Xg[
	ogg_packet				OggPacket ;					// Ogg pPbg

	theora_info				TheoraInfo ;				// Theora 
	theora_comment			TheoraComment ;				// Theora Comment
	theora_state			TheoraState ;				// Theora State
	int						TheoraSerialNo ;			// Theora f[^̃VAio[

	THEORA_PAGEINFO			*TheoraPageInfo ;			// y[W̏
	int						TheoraPageInfoNum ;			// y[W̏̐
	int						*TheoraTimeFrameToDataFrame ;	// Đԃt[ɑΉf[^t[Ƃ̑Ήz( Đԃt[̉ӏɃf[^t[ԍĂ )
	unsigned char			*TheoraKeyFrameInfo ;		// L[t[z( L[t[̔zvf 1 ɂȂĂ )
	ogg_int64_t				TheoraTotalDataFrame ;		// f[^t[
	int						TheoraTotalTimeFrame ;		// Đԃt[
	volatile int			TheoraCurrentTimeFrame ;	// ΊOIȃJg^Ct[
	volatile int			TheoraCurrentDataFrame ;	// ΊOIȃJgf[^t[
	volatile int			TheoraInCurrentDataFrame ;	// ۂ̃Jgf[^t[

	int						NumOfTheoraHeader ;			// Theora ̃wb_̐

	volatile THEORA_STOCKFRAME *StockFrame ;			// XgbNt[
	volatile int			StockFrameMaxNum ;			// XgbNt[̍ő吔

	BASEIMAGE				BaseImage ;					// Jgt[i[ꂽt[X^bÑC[W̃Rs[
	int						BaseImageSetup ;			// Jgt[ RGB C[W\zĂ邩ǂ( 1:Ă  0:ĂȂ )
	int						NotUseYUVFormatSurface ;	// xtutH[}bg̃T[tFXgpȂǂ
	int						ValidYUVSurface ;			// xtuT[tFXLǂ( TRUE:L  FALSE: )
	int						YUVSurfaceReleaseRequest ;	// xtutH[}bgT[tFX̉˗tO
	DWORD					YUVImageFourCC ;			// xtuT[tFXɎgpĂ FourCC tH[}bg
	int						YUVImageSetup ;				// Jgt[ YUV C[W\zĂ邩ǂ( 1:Ă  0:ĂȂ )

	struct DECODE_THEORA_PF *PF ;						// ˑf[^
} DECODE_THEORA ;

#endif

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------


#ifndef DX_NON_OGGTHEORA

extern	void	TheoraDecode_CreateSurface( DECODE_THEORA *DT, int ASyncThread ) ;

// ˑ֐
extern	int		TheoraDecode_CreateSurface_PF(  DECODE_THEORA *DT ) ;																// n[hEGA@\Lȏꍇ YUV tH[}bg̈ꎞۑpeNX`쐬
extern	void	TheoraDecode_ReleaseSurface_PF(	DECODE_THEORA *DT ) ;
extern	int		TheoraDecode_SetupImage_PF( DECODE_THEORA *DT, volatile THEORA_STOCKFRAME *Stock, int ASyncThread ) ;				// Jgt[RGB摜쐬( ߂l  1:쐬ꂽ  0:Ȃ )
extern	const D_IDirect3DSurface9 *TheoraDecode_GetYUVImage_PF( DECODE_THEORA *DT ) ;												// ꎞobt@ YUV tH[}bg̃eNX`𓾂

#endif

//}

#endif // __DXUSECLIBOGG_H__
