// ----------------------------------------------------------------------------
// 
// 		cwCu		``ohvO
// 
// 				Ver 3.12e
// 
// ----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h----------------------------------------------------------------
#include "DxGraphicsAPIWin.h"
#include "DxGraphicsWin.h"
#include "DxGraphicsD3D9.h"
#include "DxWinAPI.h"
#include "DxWindow.h"
#include "DxGuid.h"
#include "../DxGraphics.h"
#include "../DxASyncLoad.h"
#include "../DxLog.h"
#include "../DxBaseFunc.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// ^C}[hc
#define SCREENFLIPTIMER_ID		(32767)

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

GRAPHICSAPIINFO_WIN GAPIWin ;

// ֐錾 -------------------------------------------------------------------

#if _MSC_VER > 1200
static  VOID CALLBACK ScreenFlipTimerProc( HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime );							// e|vC}obt@̓evC}obt@ɓ]R[obN֐
#else
static  VOID CALLBACK ScreenFlipTimerProc( HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime );								// e|vC}obt@̓evC}obt@ɓ]R[obN֐
#endif

// vO -----------------------------------------------------------------

#ifndef DX_NON_ASYNCLOAD
extern int Direct3D9_ObjectRelease_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3D9_ObjectRelease_ASync(
				( void * )Info->Data[ 0 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3D9_ObjectRelease_ASync( void *pObject, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3D9_ObjectRelease_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pObject ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3D9_ObjectRelease( pObject ) ;
}






#ifndef DX_NON_ASYNCLOAD
int Direct3DDevice9_CreateRenderTarget_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateRenderTarget_ASync(
				( UINT )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( D_D3DFORMAT )Info->Data[ 2 ],
				( D_D3DMULTISAMPLE_TYPE )Info->Data[ 3 ],
				( DWORD )Info->Data[ 4 ],
				( BOOL )Info->Data[ 5 ],
				( D_IDirect3DSurface9** )Info->Data[ 6 ],
				( HANDLE* )Info->Data[ 7 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_CreateRenderTarget_ASync( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateRenderTarget_ASyncCallback ;
		AInfo.Data[ 0 ] = Width ;
		AInfo.Data[ 1 ] = Height ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Format ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )MultiSample ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )MultisampleQuality ;
		AInfo.Data[ 5 ] = ( DWORD_PTR )Lockable ;
		AInfo.Data[ 6 ] = ( DWORD_PTR )ppSurface ;
		AInfo.Data[ 7 ] = ( DWORD_PTR )pSharedHandle ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_CreateRenderTarget(
					Width,					// 
					Height,					// 
					Format,					// tH[}bg
					MultiSample,			// }`TvO^Cv
					MultisampleQuality,		// }`TvONIeB
					Lockable,				// bN͂łȂ
					ppSurface,				// D_IDirect3DSurface9 ̃|C^󂯎AhX
					pSharedHandle			//  NULL
				) ;
}

#ifndef DX_NON_ASYNCLOAD
int Direct3DDevice9_CreateDepthStencilSurface_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateDepthStencilSurface_ASync(
				( UINT )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( D_D3DFORMAT )Info->Data[ 2 ],
				( D_D3DMULTISAMPLE_TYPE )Info->Data[ 3 ],
				( DWORD )Info->Data[ 4 ],
				( BOOL )Info->Data[ 5 ],
				( D_IDirect3DSurface9** )Info->Data[ 6 ],
				( HANDLE* )Info->Data[ 7 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_CreateDepthStencilSurface_ASync( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateDepthStencilSurface_ASyncCallback ;
		AInfo.Data[ 0 ] = Width ;
		AInfo.Data[ 1 ] = Height ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Format ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )MultiSample ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )MultisampleQuality ;
		AInfo.Data[ 5 ] = ( DWORD_PTR )Discard ;
		AInfo.Data[ 6 ] = ( DWORD_PTR )ppSurface ;
		AInfo.Data[ 7 ] = ( DWORD_PTR )pSharedHandle ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_CreateDepthStencilSurface(
					Width,					// 
					Height,					// 
					Format,					// tH[}bg
					MultiSample,			// }`TvO^Cv
					MultisampleQuality,		// }`TvONIeB
					Discard,				// bN͂łȂ
					ppSurface,				// D_IDirect3DSurface9 ̃|C^󂯎AhX
					pSharedHandle			//  NULL
				) ;
}

#ifndef DX_NON_ASYNCLOAD
int Direct3DDevice9_CreateTexture_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateTexture_ASync(
				( UINT )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( UINT )Info->Data[ 2 ],
				( DWORD )Info->Data[ 3 ],
				( D_D3DFORMAT )Info->Data[ 4 ],
				( D_D3DPOOL )Info->Data[ 5 ],
				( D_IDirect3DTexture9** )Info->Data[ 6 ],
				( HANDLE* )Info->Data[ 7 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_CreateTexture_ASync( UINT Width, UINT Height, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DTexture9** ppTexture, HANDLE* pSharedHandle, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateTexture_ASyncCallback ;
		AInfo.Data[ 0 ] = Width ;
		AInfo.Data[ 1 ] = Height ;
		AInfo.Data[ 2 ] = Levels ;
		AInfo.Data[ 3 ] = Usage ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )Format ;
		AInfo.Data[ 5 ] = ( DWORD_PTR )Pool ;
		AInfo.Data[ 6 ] = ( DWORD_PTR )ppTexture ;
		AInfo.Data[ 7 ] = ( DWORD_PTR )pSharedHandle ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_CreateTexture(
				Width,				// 
				Height,				// 
				Levels,				// MipMap x
				Usage,				// tO
				Format,				// tH[}bg
				Pool,				// eNX` DirectX Ǘ邩ǂ
				ppTexture,			// D_IDirect3DTexture9 ̃|C^󂯎AhX
				pSharedHandle		//  NULL
			) ;
}

#ifndef DX_NON_ASYNCLOAD
int Direct3DDevice9_CreateCubeTexture_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateCubeTexture_ASync(
				( UINT )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( DWORD )Info->Data[ 2 ],
				( D_D3DFORMAT )Info->Data[ 3 ],
				( D_D3DPOOL )Info->Data[ 4 ],
				( D_IDirect3DCubeTexture9** )Info->Data[ 5 ],
				( HANDLE* )Info->Data[ 6 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_CreateCubeTexture_ASync( UINT EdgeLength, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DCubeTexture9** ppCubeTexture, HANDLE* pSharedHandle, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateCubeTexture_ASyncCallback ;
		AInfo.Data[ 0 ] = EdgeLength ;
		AInfo.Data[ 1 ] = Levels ;
		AInfo.Data[ 2 ] = Usage ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )Format ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )Pool ;
		AInfo.Data[ 5 ] = ( DWORD_PTR )ppCubeTexture ;
		AInfo.Data[ 6 ] = ( DWORD_PTR )pSharedHandle ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_CreateCubeTexture(
				EdgeLength,			// GbWTCY
				Levels,				// MipMap x
				Usage,				// tO
				Format,				// tH[}bg
				Pool,				// eNX` DirectX Ǘ邩ǂ
				ppCubeTexture,		// D_IDirect3DCubeTexture9 ̃|C^󂯎AhX
				pSharedHandle		//  NULL
			) ;
}

#ifndef DX_NON_ASYNCLOAD
int Direct3DDevice9_ColorFill_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_ColorFill_ASync(
				( D_IDirect3DSurface9* )Info->Data[ 0 ],
				( RECT* )Info->Data[ 1 ],
				( D_D3DCOLOR )Info->Data[ 2 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_ColorFill_ASync( D_IDirect3DSurface9* pSurface, CONST RECT* pRect, D_D3DCOLOR color, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_ColorFill_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pSurface ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )pRect ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )color ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_ColorFill( pSurface, pRect, color ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DDevice9_CreateOffscreenPlainSurface_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateOffscreenPlainSurface_ASync(
				( UINT )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( D_D3DFORMAT )Info->Data[ 2 ],
				( D_D3DPOOL )Info->Data[ 3 ],
				( D_IDirect3DSurface9** )Info->Data[ 4 ],
				( HANDLE* )Info->Data[ 5 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_CreateOffscreenPlainSurface_ASync( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateOffscreenPlainSurface_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Width ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Height ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Format ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )Pool ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )ppSurface ;
		AInfo.Data[ 5 ] = ( DWORD_PTR )pSharedHandle ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_CreateOffscreenPlainSurface( Width, Height, Format, Pool, ppSurface, pSharedHandle ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DDevice9_UpdateSurface_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_UpdateSurface_ASync(
				( D_IDirect3DSurface9* )Info->Data[ 0 ],
				( CONST RECT* )Info->Data[ 1 ],
				( D_IDirect3DSurface9* )Info->Data[ 2 ],
				( CONST POINT* )Info->Data[ 3 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_UpdateSurface_ASync( D_IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, D_IDirect3DSurface9* pDestinationSurface, CONST POINT* pDestPoint, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_UpdateSurface_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pSourceSurface ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )pSourceRect ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )pDestinationSurface ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )pDestPoint ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_UpdateSurface( pSourceSurface, pSourceRect, pDestinationSurface, pDestPoint ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DDevice9_UpdateTexture_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_UpdateTexture_ASync(
				( D_IDirect3DBaseTexture9* )Info->Data[ 0 ],
				( D_IDirect3DBaseTexture9* )Info->Data[ 1 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_UpdateTexture_ASync( D_IDirect3DBaseTexture9* pSourceTexture, D_IDirect3DBaseTexture9* pDestinationTexture, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_UpdateTexture_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pSourceTexture ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )pDestinationTexture ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_UpdateTexture( pSourceTexture, pDestinationTexture ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DDevice9_CreateVertexShader_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateVertexShader_ASync(
				( CONST DWORD* )Info->Data[ 0 ],
				( D_IDirect3DVertexShader9** )Info->Data[ 1 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_CreateVertexShader_ASync( CONST DWORD* pFunction, D_IDirect3DVertexShader9** ppShader, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateVertexShader_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pFunction ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )ppShader ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_CreateVertexShader( pFunction, ppShader ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DDevice9_CreatePixelShader_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreatePixelShader_ASync(
				( CONST DWORD* )Info->Data[ 0 ],
				( D_IDirect3DPixelShader9** )Info->Data[ 1 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DDevice9_CreatePixelShader_ASync( CONST DWORD* pFunction, D_IDirect3DPixelShader9** ppShader, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreatePixelShader_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pFunction ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )ppShader ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DDevice9_CreatePixelShader( pFunction, ppShader ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DDevice9_CreateVertexBuffer_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateVertexBuffer_ASync(
				( DWORD )Info->Data[ 0 ],
				( DWORD )Info->Data[ 1 ],
				( DWORD )Info->Data[ 2 ],
				( D_D3DPOOL )Info->Data[ 3 ],
				( D_IDirect3DVertexBuffer9 ** )Info->Data[ 4 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

// _obt@쐬
extern int Direct3DDevice9_CreateVertexBuffer_ASync( DWORD Length, DWORD Usage, DWORD FVFFlag, D_D3DPOOL Pool, D_IDirect3DVertexBuffer9 **BufferP, int ASyncThread )
{
	HRESULT Result ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateVertexBuffer_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Length ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Usage ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )FVFFlag ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )Pool ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )BufferP ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	if( Direct3DDevice9_IsValid() == 0 ) return -1 ;
	
	Result = Direct3DDevice9_CreateVertexBuffer( Length, Usage, FVFFlag, Pool, BufferP, NULL ) ;

	return Result == D_D3D_OK ? 0 : -1 ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DDevice9_CreateIndexBuffer_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DDevice9_CreateIndexBuffer_ASync(
				( DWORD )Info->Data[ 0 ],
				( DWORD )Info->Data[ 1 ],
				( D_D3DFORMAT )Info->Data[ 2 ],
				( D_D3DPOOL )Info->Data[ 3 ],
				( D_IDirect3DIndexBuffer9 ** )Info->Data[ 4 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

// CfbNXobt@쐬
extern int Direct3DDevice9_CreateIndexBuffer_ASync( DWORD Length, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DIndexBuffer9 **BufferP, int ASyncThread )
{
	HRESULT Result ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DDevice9_CreateIndexBuffer_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Length ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Usage ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Format ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )Pool ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )BufferP ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	if( Direct3DDevice9_IsValid() == 0 ) return -1 ;

	Result = Direct3DDevice9_CreateIndexBuffer( Length, Usage, Format, Pool, BufferP, NULL ) ;

	return Result == D_D3D_OK ? 0 : -1 ;
}









#ifndef DX_NON_ASYNCLOAD
int Direct3DTexture9_GetSurfaceLevel_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DTexture9_GetSurfaceLevel_ASync(
				( D_IDirect3DTexture9 * )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( D_IDirect3DSurface9** )Info->Data[ 2 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DTexture9_GetSurfaceLevel_ASync( D_IDirect3DTexture9 *Texture, UINT Level,  D_IDirect3DSurface9** ppSurfaceLevel, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DTexture9_GetSurfaceLevel_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Texture ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Level ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )ppSurfaceLevel ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DTexture9_GetSurfaceLevel( Texture, Level, ppSurfaceLevel ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DTexture9_LockRect_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DTexture9_LockRect_ASync(
				( D_IDirect3DTexture9 * )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( D_D3DLOCKED_RECT* )Info->Data[ 2 ],
				( CONST RECT* )Info->Data[ 3 ],
				( DWORD )Info->Data[ 4 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DTexture9_LockRect_ASync( D_IDirect3DTexture9 *Texture, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DTexture9_LockRect_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Texture ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Level ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )pLockedRect ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )pRect ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )Flags ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DTexture9_LockRect( Texture, Level, pLockedRect, pRect, Flags ) ;
}

#ifndef DX_NON_ASYNCLOAD

extern int Direct3DTexture9_UnlockRect_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DTexture9_UnlockRect_ASync(
				( D_IDirect3DTexture9 * )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DTexture9_UnlockRect_ASync( D_IDirect3DTexture9 *Texture, UINT Level, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DTexture9_UnlockRect_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Texture ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Level ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DTexture9_UnlockRect( Texture, Level ) ;
}









#ifndef DX_NON_ASYNCLOAD
int Direct3DCubeTexture9_GetCubeMapSurface_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DCubeTexture9_GetCubeMapSurface_ASync(
				( D_IDirect3DCubeTexture9 * )Info->Data[ 0 ],
				( D_D3DCUBEMAP_FACES )Info->Data[ 1 ],
				( UINT )Info->Data[ 2 ],
				( D_IDirect3DSurface9** )Info->Data[ 3 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DCubeTexture9_GetCubeMapSurface_ASync( D_IDirect3DCubeTexture9 *CubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_IDirect3DSurface9** ppCubeMapSurface, int ASyncThread)
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DCubeTexture9_GetCubeMapSurface_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )CubeTexture ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )FaceType ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Level ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )ppCubeMapSurface ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DCubeTexture9_GetCubeMapSurface( CubeTexture, FaceType, Level, ppCubeMapSurface ) ;
}










#ifndef DX_NON_ASYNCLOAD
extern int Direct3DCubeTexture9_LockRect_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DCubeTexture9_LockRect_ASync(
				( D_IDirect3DCubeTexture9 * )Info->Data[ 0 ],
				( D_D3DCUBEMAP_FACES )Info->Data[ 1 ],
				( UINT )Info->Data[ 2 ],
				( D_D3DLOCKED_RECT* )Info->Data[ 3 ],
				( CONST RECT* )Info->Data[ 4 ],
				( DWORD )Info->Data[ 5 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DCubeTexture9_LockRect_ASync( D_IDirect3DCubeTexture9 *CubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DCubeTexture9_LockRect_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )CubeTexture ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )FaceType ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Level ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )pLockedRect ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )pRect ;
		AInfo.Data[ 5 ] = ( DWORD_PTR )Flags ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DCubeTexture9_LockRect( CubeTexture, FaceType, Level, pLockedRect, pRect, Flags ) ;
}

#ifndef DX_NON_ASYNCLOAD

extern int Direct3DCubeTexture9_UnlockRect_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DCubeTexture9_UnlockRect_ASync(
				( D_IDirect3DCubeTexture9 * )Info->Data[ 0 ],
				( D_D3DCUBEMAP_FACES )Info->Data[ 1 ],
				( UINT )Info->Data[ 2 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DCubeTexture9_UnlockRect_ASync( D_IDirect3DCubeTexture9 *CubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, int ASyncThread)
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DCubeTexture9_UnlockRect_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )CubeTexture ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )FaceType ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Level ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DCubeTexture9_UnlockRect( CubeTexture, FaceType, Level ) ;
}














#ifndef DX_NON_ASYNCLOAD
extern int Direct3DSurface9_LockRect_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DSurface9_LockRect_ASync(
				( D_IDirect3DSurface9* )Info->Data[ 0 ],
				( D_D3DLOCKED_RECT* )Info->Data[ 1 ],
				( CONST RECT* )Info->Data[ 2 ],
				( DWORD )Info->Data[ 3 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DSurface9_LockRect_ASync( D_IDirect3DSurface9* pSurface, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DSurface9_LockRect_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pSurface ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )pLockedRect ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )pRect ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )Flags ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DSurface9_LockRect( pSurface, pLockedRect, pRect, Flags ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DSurface9_UnlockRect_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DSurface9_UnlockRect_ASync(
				( D_IDirect3DSurface9* )Info->Data[ 0 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern HRESULT Direct3DSurface9_UnlockRect_ASync( D_IDirect3DSurface9* pSurface, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DSurface9_UnlockRect_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )pSurface ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DSurface9_UnlockRect( pSurface ) ;
}








#ifndef DX_NON_ASYNCLOAD
extern int Direct3DVertexBuffer9_Lock_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DVertexBuffer9_Lock_ASync(
				( D_IDirect3DVertexBuffer9 * )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( UINT )Info->Data[ 2 ],
				( void ** )Info->Data[ 3 ],
				( DWORD )Info->Data[ 4 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern	HRESULT	Direct3DVertexBuffer9_Lock_ASync( D_IDirect3DVertexBuffer9 *Buffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DVertexBuffer9_Lock_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Buffer ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )OffsetToLock ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )SizeToLock ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )ppbData ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )Flags ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DVertexBuffer9_Lock( Buffer, OffsetToLock, SizeToLock, ppbData, Flags ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DVertexBuffer9_Unlock_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DVertexBuffer9_Unlock_ASync(
				( D_IDirect3DVertexBuffer9 * )Info->Data[ 0 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern	HRESULT Direct3DVertexBuffer9_Unlock_ASync( D_IDirect3DVertexBuffer9 *Buffer, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DVertexBuffer9_Unlock_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Buffer ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DVertexBuffer9_Unlock( Buffer ) ;
}










#ifndef DX_NON_ASYNCLOAD
extern int Direct3DIndexBuffer9_Lock_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DIndexBuffer9_Lock_ASync(
				( D_IDirect3DIndexBuffer9 * )Info->Data[ 0 ],
				( UINT )Info->Data[ 1 ],
				( UINT )Info->Data[ 2 ],
				( void ** )Info->Data[ 3 ],
				( DWORD )Info->Data[ 4 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern	HRESULT	Direct3DIndexBuffer9_Lock_ASync( D_IDirect3DIndexBuffer9 *Buffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DIndexBuffer9_Lock_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Buffer ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )OffsetToLock ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )SizeToLock ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )ppbData ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )Flags ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DIndexBuffer9_Lock( Buffer, OffsetToLock, SizeToLock, ppbData, Flags ) ;
}

#ifndef DX_NON_ASYNCLOAD
extern int Direct3DIndexBuffer9_Unlock_ASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return Direct3DIndexBuffer9_Unlock_ASync(
				( D_IDirect3DIndexBuffer9 * )Info->Data[ 0 ],
				FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

extern	HRESULT Direct3DIndexBuffer9_Unlock_ASync( D_IDirect3DIndexBuffer9 *Buffer, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = Direct3DIndexBuffer9_Unlock_ASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Buffer ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Direct3DIndexBuffer9_Unlock( Buffer ) ;
}







extern int DirectDraw7_Create( void )
{
	HRESULT hr ;

	// ɍ쐬ς݂̏ꍇ͈x폜
	if( GAPIWin.DirectDraw7Object )
	{
		GAPIWin.DirectDraw7Object->Release() ;
		GAPIWin.DirectDraw7Object = NULL ;
	}

	// ccIuWFNg̍쐬
	DXST_ERRORLOG_ADD( _T( "DirectDraw IuWFNg̎擾s܂....  " ) ) ;
	hr = WinAPIData.Win32Func.CoCreateInstanceFunc( CLSID_DIRECTDRAW7, NULL, CLSCTX_ALL, IID_IDIRECTDRAW7, ( LPVOID *)&GAPIWin.DirectDraw7Object );
	if( !FAILED( hr ) )
	{
		DXST_ERRORLOG_ADD( _T( "\n" )) ;
		DXST_ERRORLOG_ADD( _T( "... " ) ) ; 
		hr = GAPIWin.DirectDraw7Object->Initialize( NULL ) ;
		if( FAILED( hr ) ) 
		{
			DXST_ERRORLOG_ADD( _T( "DirectDrawIuWFNg̏Ɏs܂\n" ) );
			GAPIWin.DirectDraw7Object->Release() ;
			return -1 ;
		}
		DXST_ERRORLOG_ADD( _T( "ɐ܂\n" ) ) ;
	}
	else
	{
		DXST_ERRORLOG_ADD( _T( "IuWFNg̎擾Ɏs܂\n" ) );
		return -1 ;
	}

	// xKɃZbg
	GAPIWin.DirectDraw7Object->SetCooperativeLevel( NS_GetMainWindowHandle(), D_DDSCL_NORMAL | ( WinData.UseFPUPreserve ? D_DDSCL_FPUPRESERVE : 0 ) ) ;

	// Aero 𖳌ɂ鏈
	if( GD3D9.Setting.DisableAeroFlag == 2 )
	{
		// DWM 𖳌ɂ
		SetEnableAero( FALSE ) ;
#if 0
		D_DDSURFACEDESC2 ddsd ;
		D_IDirectDrawSurface7 *prmsuf ;
		HDC prmdc ;
		HRESULT hr ;

		//  쐬p[^̃Zbg	
		_MEMSET( &ddsd, 0, sizeof( ddsd ) ) ; 
		ddsd.dwSize				= sizeof( ddsd ) ;
		ddsd.dwFlags			= D_DDSD_CAPS ;	
		ddsd.ddsCaps.dwCaps		= D_DDSCAPS_PRIMARYSURFACE | D_DDSCAPS_3DDEVICE ;

		// vC}T[tFX̍쐬
		hr = GAPIWin.DirectDraw7Object->CreateSurface( &ddsd, &prmsuf, NULL ) ;
		if( hr == D_DD_OK )
		{
			// GetDC  Aero 
			hr = prmsuf->GetDC( &prmdc ) ;
			if( hr == D_DD_OK )
			{
				prmsuf->ReleaseDC( prmdc ) ;
				prmdc = NULL ;
			}
			prmsuf->Release() ;
			prmsuf = NULL ;
		}
#endif
	}

	// I
	return 0 ;
}

extern int DirectDraw7_Release( void )
{
	if( GAPIWin.DirectDraw7Object )
	{
		GAPIWin.DirectDraw7Object->Release() ;
		GAPIWin.DirectDraw7Object = NULL ;
	}

	// I
	return 0 ;
}

extern void *DirectDraw7_GetObject( void )
{
	return GAPIWin.DirectDraw7Object ;
}

extern int DirectDraw7_GetVideoMemorySize( int *TotalSize, int *FreeSize )
{
	D_DDSCAPS2 caps ;
	DWORD TotalMem, FreeMem ;

	if( GAPIWin.DirectDraw7Object == NULL ) return -1 ;

	_MEMSET( &caps, 0, sizeof( caps ) );
	caps.dwCaps = D_DDSCAPS_VIDEOMEMORY | D_DDSCAPS_LOCALVIDMEM ;
	GAPIWin.DirectDraw7Object->GetAvailableVidMem( &caps, &TotalMem, &FreeMem ) ;

	if( TotalSize ) *TotalSize = TotalMem ;
	if( FreeSize ) *FreeSize = FreeMem ;

	// I
	return 0 ;
}








extern ULONG Direct3D9_ObjectRelease( void *pObject )
{
	return ( ( IUnknown * )pObject )->Release() ;
}






extern int Direct3D9_Create( void )
{
	D_IDirect3D9 * ( WINAPI *DF_Direct3DCreate9 )( UINT SDKVersion ) ;
	HRESULT ( WINAPI * DF_Direct3DCreate9Ex )(  UINT SDKVersion, D_IDirect3D9Ex **ppD3D ) ;

	// ɍ쐬ς݂̏ꍇ͈x폜
	if( GAPIWin.Direct3D9Object )
	{
		Direct3D9_Release() ;
	}
	GAPIWin.Direct3D9ExObject = NULL ;

	//  Direct3DCreate9Ex ̃AhX擾݂
	if( GD3D9.Setting.NotUseDirect3D9Ex == FALSE )
	{
		DXST_ERRORLOG_ADD( _T( "IDirect3D9Ex IuWFNg擾܂.... " ) ) ;

		DF_Direct3DCreate9Ex = ( HRESULT ( WINAPI * )( UINT SDKVersion, D_IDirect3D9Ex ** ) )GetProcAddress( GAPIWin.Direct3D9DLL, "Direct3DCreate9Ex" ) ;
		if( DF_Direct3DCreate9Ex != NULL )
		{
			// IDirect3D9Ex IuWFNg̍쐬
			if( DF_Direct3DCreate9Ex( 32, &GAPIWin.Direct3D9ExObject ) == S_OK )
			{
				GAPIWin.Direct3D9Object = GAPIWin.Direct3D9ExObject ;
			}
		}
	}

	// IDirect3D9Ex 쐬łȂ IDirect3D9 쐬
	if( GAPIWin.Direct3D9Object == NULL )
	{
		DXST_ERRORLOG_ADD( _T( "IDirect3D9 IuWFNg擾܂.... " ) ) ;

		// Direct3DCreate9 API ̃AhX擾
		DF_Direct3DCreate9 = ( D_IDirect3D9 * ( WINAPI * )( UINT SDKVersion ) )GetProcAddress( GAPIWin.Direct3D9DLL, "Direct3DCreate9" ) ;
		if( DF_Direct3DCreate9 == NULL )
		{
			return DXST_ERRORLOG_ADD( _T( "Direct3DCreate9 APĨAhX擾Ɏs܂\n" ) ) ;
		}

		// IDirect3D9 IuWFNg̍쐬
		GAPIWin.Direct3D9Object = DF_Direct3DCreate9( 32 ) ;
		if( GAPIWin.Direct3D9Object == NULL )
		{
			return DXST_ERRORLOG_ADD( _T( "IDirect3D9 IuWFNg̎擾Ɏs܂\n" ) ) ;
		}
	}

	DXST_ERRORLOG_ADD( _T( "\n" )) ;

	// I
	return 0 ;
}

extern int Direct3D9_LoadDLL( void )
{
	// Direct3D9.DLL ̓ǂݍ
	GAPIWin.Direct3D9DLL = LoadLibrary( _T( "d3d9.dll" ) ) ;
	if( GAPIWin.Direct3D9DLL == NULL )
	{
		return DXST_ERRORLOG_ADD( _T( "d3d9.dll ̓ǂݍ݂Ɏs܂\n" ) ) ;
	}

	// I
	return 0 ;
}

extern int Direct3D9_FreeDLL( void )
{
	// d3d9.dll ̉
	if( GAPIWin.Direct3D9DLL )
	{
		DXST_ERRORLOG_ADD( _T( "d3d9.dll ̉ 1\n" ) ) ;
		FreeLibrary( GAPIWin.Direct3D9DLL ) ;
		GAPIWin.Direct3D9DLL = NULL ;
	}

	// d3d1.dll ̉
	if( GAPIWin.Direct3D11DLL )
	{
		DXST_ERRORLOG_ADD( _T( "d3d11.dll ̉ 1\n" ) ) ;
		FreeLibrary( GAPIWin.Direct3D11DLL ) ;
		GAPIWin.Direct3D11DLL = NULL ;
	}

	// I
	return 0 ;
}

extern ULONG Direct3D9_Release( void )
{
	ULONG Result ;

	if( GAPIWin.Direct3D9Object == NULL )
	{
		return 0 ;
	}
	Result = GAPIWin.Direct3D9Object->Release() ;
	GAPIWin.Direct3D9Object = NULL ;

	return Result ;
}

extern UINT Direct3D9_GetAdapterCount( void )
{
	return GAPIWin.Direct3D9Object->GetAdapterCount() ;
}

extern long Direct3D9_GetAdapterIdentifier( DWORD Adapter, DWORD Flags, D_D3DADAPTER_IDENTIFIER9* pIdentifier)
{
	return GAPIWin.Direct3D9Object->GetAdapterIdentifier( Adapter, Flags, pIdentifier) ;
}

extern UINT Direct3D9_GetAdapterModeCount( DWORD Adapter, D_D3DFORMAT Format)
{
	return GAPIWin.Direct3D9Object->GetAdapterModeCount( Adapter, Format) ;
}

extern long Direct3D9_EnumAdapterModes( DWORD Adapter, D_D3DFORMAT Format, DWORD Mode,D_D3DDISPLAYMODE* pMode)
{
	return GAPIWin.Direct3D9Object->EnumAdapterModes( Adapter, Format, Mode,pMode) ;
}

extern long Direct3D9_GetAdapterDisplayMode( DWORD Adapter, D_D3DDISPLAYMODE* pMode)
{
	return GAPIWin.Direct3D9Object->GetAdapterDisplayMode( Adapter, pMode) ;
}

extern long Direct3D9_CheckDeviceFormat( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DFORMAT AdapterFormat, DWORD Usage, D_D3DRESOURCETYPE RType, D_D3DFORMAT CheckFormat)
{
	return GAPIWin.Direct3D9Object->CheckDeviceFormat( Adapter, DeviceType, AdapterFormat, Usage, RType, CheckFormat) ;
}

extern long Direct3D9_CheckDeviceMultiSampleType( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DFORMAT SurfaceFormat, BOOL Windowed, D_D3DMULTISAMPLE_TYPE MultiSampleType, DWORD* pQualityLevels)
{
	return GAPIWin.Direct3D9Object->CheckDeviceMultiSampleType( Adapter, DeviceType, SurfaceFormat, Windowed, MultiSampleType, pQualityLevels) ;
}

extern long Direct3D9_CheckDepthStencilMatch( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DFORMAT AdapterFormat, D_D3DFORMAT RenderTargetFormat, D_D3DFORMAT DepthStencilFormat)
{
	return GAPIWin.Direct3D9Object->CheckDepthStencilMatch( Adapter, DeviceType, AdapterFormat, RenderTargetFormat, DepthStencilFormat) ;
}

extern long Direct3D9_GetDeviceCaps( DWORD Adapter, D_D3DDEVTYPE DeviceType, D_D3DCAPS9* pCaps)
{
	return GAPIWin.Direct3D9Object->GetDeviceCaps( Adapter, DeviceType, pCaps) ;
}

extern int Direct3D9_CreateDevice( void )
{
	D_D3DCAPS9              DevCaps ;
	D_D3DPRESENT_PARAMETERS param ;
	HRESULT                 hr ;
	int                     ModeCount ;
	D_D3DDISPLAYMODE        DisplayMode ;
	D_D3DDISPLAYMODEEX      DisplayModeEx ;
	int                     ErrorRet = -1 ;

	// p[^̃Zbg
	_MEMSET( &param, 0, sizeof( D_D3DPRESENT_PARAMETERS ) ) ;
	param.BackBufferWidth  = GSYS.Screen.MainScreenSizeX ;
	param.BackBufferHeight = GSYS.Screen.MainScreenSizeY ;
	if( NS_GetWindowModeFlag() == TRUE )
	{
		// EChE[h
		Direct3D9_GetAdapterDisplayMode( 0, &DisplayMode ) ;
		param.BackBufferFormat = DisplayMode.Format ;
		param.BackBufferCount  = 1 ;
		param.Windowed         = TRUE ;
		param.SwapEffect       = GD3D9.Setting.FSAAMultiSampleType == D_D3DMULTISAMPLE_NONE ? D_D3DSWAPEFFECT_COPY : D_D3DSWAPEFFECT_DISCARD ;

		switch( DisplayMode.Format )
		{
		case D_D3DFMT_X8R8G8B8 :
			GSYS.Screen.MainScreenColorBitDepth = 32 ;
			SetMemImgDefaultColorType( 1 ) ;
			break ;

		case D_D3DFMT_X1R5G5B5 :
		case D_D3DFMT_A1R5G5B5 :
		case D_D3DFMT_R5G6B5 :
			GSYS.Screen.MainScreenColorBitDepth = 16 ;
			SetMemImgDefaultColorType( 0 ) ;
			break ;
		}

		// Aero ̗LEݒ肷
		SetEnableAero( GD3D9.Setting.DisableAeroFlag == 2 ? FALSE : TRUE ) ;
	}
	else
	{
		// tXN[[h

		switch( GSYS.Screen.MainScreenColorBitDepth )
		{
		case 16 :
			ModeCount = Direct3D9_GetAdapterModeCount( GD3D9.Adapter.ValidUseAdapterNumber ? GD3D9.Adapter.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DFMT_R5G6B5 ) ;
			param.BackBufferFormat = ModeCount != 0 ? D_D3DFMT_R5G6B5 : D_D3DFMT_X1R5G5B5 ;
			break ;

		case 32 :
			param.BackBufferFormat = D_D3DFMT_X8R8G8B8 ;
			break ;

		default :
			DXST_ERRORLOG_ADD( _T( "Ή̃obNobt@[rbg[xw肳܂\n" ) ) ;
			goto ERR ;
		}
		param.BackBufferCount            = 1 ;
		param.Windowed                   = FALSE ;
		param.FullScreen_RefreshRateInHz = GSYS.Screen.MainScreenRefreshRate ;
//		param.SwapEffect                 = GSYS.Screen.Emulation320x240Flag ? D_D3DSWAPEFFECT_COPY : D_D3DSWAPEFFECT_DISCARD ;
//		param.SwapEffect                 = GD3D9.Setting.FSAAMultiSampleType == D_D3DMULTISAMPLE_NONE ? D_D3DSWAPEFFECT_COPY : D_D3DSWAPEFFECT_DISCARD ;
		param.SwapEffect                 = D_D3DSWAPEFFECT_DISCARD ;

		// fBXvC[h̐ݒ
		{
			DisplayModeEx.Size             = sizeof( DisplayModeEx ) ;
			DisplayModeEx.Format           = param.BackBufferFormat ;
			DisplayModeEx.RefreshRate      = param.FullScreen_RefreshRateInHz ;
			DisplayModeEx.ScanLineOrdering = D_D3DSCANLINEORDERING_PROGRESSIVE ;

			// tXN[[h̏ZbgAbv
			Graphics_Screen_SetupFullScreenModeInfo() ;

			// obNobt@ƃfBXvC[h̉𑜓xZbg
			param.BackBufferWidth  = GSYS.Screen.FullScreenUseDispModeData.Width ;
			param.BackBufferHeight = GSYS.Screen.FullScreenUseDispModeData.Height ;
			DisplayModeEx.Width    = param.BackBufferWidth ;
			DisplayModeEx.Height   = param.BackBufferHeight ;
		}

		// tXN[̏ꍇŖI Aero ̂nmݒ肵ĂȂꍇ͕K DWM 𖳌ɂ
		if( GD3D9.Setting.DisableAeroFlag != 1 )
		{
			SetEnableAero( FALSE ) ;
		}
		if( WinAPIData.DF_DwmEnableComposition )
		{
			DXST_ERRORLOG_ADD( _T( "Desktop Window Manager 𖳌ɂ܂\n" ) ) ;
		}
	}
	param.MultiSampleType    = GD3D9.Setting.FSAAMultiSampleType ;
	param.MultiSampleQuality = GD3D9.Setting.FSAAMultiSampleQuality ;
	param.hDeviceWindow      = GetDisplayWindowHandle() ;

//	param.PresentationInterval   = GSYS.Screen.PreSetWaitVSyncFlag ? D_D3DPRESENT_INTERVAL_ONE       : D_D3DPRESENT_INTERVAL_IMMEDIATE ;
	param.PresentationInterval   = GSYS.Screen.NotWaitVSyncFlag    ? D_D3DPRESENT_INTERVAL_IMMEDIATE : D_D3DPRESENT_INTERVAL_ONE ;
	param.EnableAutoDepthStencil = FALSE ;
	param.Flags                  = GD3D9.Setting.FSAAMultiSampleType == D_D3DMULTISAMPLE_NONE ? D_D3DPRESENTFLAG_LOCKABLE_BACKBUFFER/* D_D3DPRESENTFLAG_DEVICECLIP */ : 0 ;

	// FSAA̐ݒl𒲂ׂ
	if( GD3D9.Setting.FSAAMultiSampleType != 0 )
	{
		param.MultiSampleType                = GD3D9.Setting.FSAAMultiSampleType ;
		param.MultiSampleQuality             = GD3D9.Setting.FSAAMultiSampleQuality ;
		Direct3D9_CheckMultiSampleParam( param.BackBufferFormat, &param.MultiSampleType, &param.MultiSampleQuality, FALSE ) ;
		GD3D9.Setting.FSAAMultiSampleType    = param.MultiSampleType ;
		GD3D9.Setting.FSAAMultiSampleQuality = param.MultiSampleQuality ;
	}
	else
	{
		GD3D9.Setting.FSAAMultiSampleQuality = 0 ;
		param.MultiSampleQuality             = 0 ;
	}

	if( GD3D9.Setting.NonUseVertexHardwareProcess == TRUE )
	{
		if( GAPIWin.Direct3D9ExObject )
		{
			goto NOTUSEHARDWARE_VERTEXPROCESSINGEX ;
		}
		else
		{
			goto NOTUSEHARDWARE_VERTEXPROCESSING ;
		}
	}

	// VF[_[o[WQDOgpłȂꍇ
	// _ׂ͂ă\tgEGAōs
	Direct3D9_GetDeviceCaps( GD3D9.Adapter.ValidUseAdapterNumber ? GD3D9.Adapter.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, &DevCaps ) ;
	if( ( DevCaps.VertexShaderVersion & 0xffff ) < 0x200 || 
		( DevCaps.PixelShaderVersion  & 0xffff ) < 0x200 )
	{
		GD3D9.Device.Caps.VertexHardwareProcess = FALSE ;
	}
	else
	{
		GD3D9.Device.Caps.VertexHardwareProcess = TRUE ;
	}
	GD3D9.Device.Shader.NativeVertexShaderVersion = DevCaps.VertexShaderVersion ;
	if( GAPIWin.Direct3D9ExObject )
	{
		DXST_ERRORLOG_ADD( _T( "IDirect3DDevice9Ex IuWFNg擾܂.... " ) ) ;

		hr = GAPIWin.Direct3D9ExObject->CreateDeviceEx(
			GD3D9.Adapter.ValidUseAdapterNumber ? GD3D9.Adapter.UseAdapterNumber : D_D3DADAPTER_DEFAULT,
			D_D3DDEVTYPE_HAL,
			NS_GetMainWindowHandle(),
//			D_D3DCREATE_MIXED_VERTEXPROCESSING
			( GD3D9.Device.Caps.VertexHardwareProcess ? D_D3DCREATE_MIXED_VERTEXPROCESSING : D_D3DCREATE_SOFTWARE_VERTEXPROCESSING )
			| ( WinData.UseFPUPreserve ? D_D3DCREATE_FPU_PRESERVE : 0 )
			| ( GD3D9.Setting.UseMultiThread ? D_D3DCREATE_MULTITHREADED : 0 ),
			&param,
			param.Windowed ? NULL : &DisplayModeEx,
			&GAPIWin.Direct3DDevice9ExObject
		) ;
		if( FAILED( hr ) )
		{
NOTUSEHARDWARE_VERTEXPROCESSINGEX:
			GD3D9.Device.Caps.VertexHardwareProcess = FALSE ;

			// ߂ꍇ̓\tgEGAvZbVO
			hr = GAPIWin.Direct3D9ExObject->CreateDeviceEx(
				GD3D9.Adapter.ValidUseAdapterNumber ? GD3D9.Adapter.UseAdapterNumber : D_D3DADAPTER_DEFAULT,
				D_D3DDEVTYPE_HAL,
				NS_GetMainWindowHandle(),
				D_D3DCREATE_SOFTWARE_VERTEXPROCESSING
				| ( WinData.UseFPUPreserve ? D_D3DCREATE_FPU_PRESERVE  : 0 )
				| ( GD3D9.Setting.UseMultiThread     ? D_D3DCREATE_MULTITHREADED : 0 ),
				&param,
				param.Windowed ? NULL : &DisplayModeEx,
				&GAPIWin.Direct3DDevice9ExObject
			) ;
			if( FAILED( hr ) )
			{
				GD3D9.Setting.NotUseDirect3D9Ex = TRUE ;

				DXST_ERRORLOG_ADD( _T( "Direct3DDevice9Ex ̍쐬Ɏs܂\n" ) ) ;
				ErrorRet = -2 ;
				goto ERR ;
			}
			else
			{
				DXST_ERRORLOG_ADD( _T( "\tgEGA_Zgp܂\n" ) ) ;
			}
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "n[hEGA_Zgp܂\n" ) ) ;
		}
		GAPIWin.Direct3DDevice9Object = GAPIWin.Direct3DDevice9ExObject ;

		// _Oێłt[ŏɂ
		GAPIWin.Direct3DDevice9ExObject->SetMaximumFrameLatency( 1 ) ;
	}
	else
	{
		DXST_ERRORLOG_ADD( _T( "IDirect3DDevice9 IuWFNg擾܂.... " ) ) ;

		hr = GAPIWin.Direct3D9Object->CreateDevice(
			GD3D9.Adapter.ValidUseAdapterNumber ? GD3D9.Adapter.UseAdapterNumber : D_D3DADAPTER_DEFAULT,
			D_D3DDEVTYPE_HAL,
			NS_GetMainWindowHandle(),
//			D_D3DCREATE_MIXED_VERTEXPROCESSING/*D_D3DCREATE_HARDWARE_VERTEXPROCESSING*/
			( GD3D9.Device.Caps.VertexHardwareProcess ? D_D3DCREATE_MIXED_VERTEXPROCESSING : D_D3DCREATE_SOFTWARE_VERTEXPROCESSING )
			| ( WinData.UseFPUPreserve ? D_D3DCREATE_FPU_PRESERVE : 0 )
			| ( GD3D9.Setting.UseMultiThread ? D_D3DCREATE_MULTITHREADED : 0 ),
			&param,
			&GAPIWin.Direct3DDevice9Object
		) ;
		if( FAILED( hr ) )
		{
NOTUSEHARDWARE_VERTEXPROCESSING:
			GD3D9.Device.Caps.VertexHardwareProcess = FALSE ;

			// ߂ꍇ̓\tgEGAvZbVO
			hr = GAPIWin.Direct3D9Object->CreateDevice(
				GD3D9.Adapter.ValidUseAdapterNumber ? GD3D9.Adapter.UseAdapterNumber : D_D3DADAPTER_DEFAULT,
				D_D3DDEVTYPE_HAL,
				NS_GetMainWindowHandle(),
				D_D3DCREATE_SOFTWARE_VERTEXPROCESSING
				| ( WinData.UseFPUPreserve ? D_D3DCREATE_FPU_PRESERVE : 0 )
				| ( GD3D9.Setting.UseMultiThread ? D_D3DCREATE_MULTITHREADED : 0 ),
				&param,
				&GAPIWin.Direct3DDevice9Object
			) ;
			if( FAILED( hr ) )
			{
				DXST_ERRORLOG_ADD( _T( "Direct3DDevice9 ̍쐬Ɏs܂\n" ) ) ;
				goto ERR ;
			}
			else
			{
				DXST_ERRORLOG_ADD( _T( "\tgEGA_Zgp܂\n" ) ) ;
			}
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "n[hEGA_Zgp܂\n" ) ) ;
		}
	}

	// obNobt@̏
	{
		DWORD ClearColor ;

		// tXN[[htXN[𑜓x[h DX_FSRESOLUTIONMODE_NATIVE ȊȌꍇ͕K^ŏ
		if( NS_GetWindowModeFlag() == FALSE && GSYS.Screen.FullScreenResolutionModeAct != DX_FSRESOLUTIONMODE_NATIVE )
		{
			ClearColor = 0 ;
		}
		else
		{
			ClearColor = ( GSYS.Screen.BackgroundRed << 16 ) | ( GSYS.Screen.BackgroundGreen << 8 ) | GSYS.Screen.BackgroundBlue ;
		}

		Direct3DDevice9_SetRenderState( D_D3DRS_ZENABLE, D_D3DZB_TRUE ) ;
		Direct3DDevice9_Clear( 0, NULL, D_D3DCLEAR_TARGET, ClearColor, 1.0f, 0 ) ;
		GAPIWin.Direct3DDevice9Object->Present( NULL, NULL, GetDisplayWindowHandle(), NULL ) ;
		Direct3DDevice9_Clear( 0, NULL, D_D3DCLEAR_TARGET, ClearColor, 1.0f, 0 ) ;
		GAPIWin.Direct3DDevice9Object->Present( NULL, NULL, GetDisplayWindowHandle(), NULL ) ;
		Direct3DDevice9_Clear( 0, NULL, D_D3DCLEAR_TARGET, ClearColor, 1.0f, 0 ) ;
		GAPIWin.Direct3DDevice9Object->Present( NULL, NULL, GetDisplayWindowHandle(), NULL ) ;
		Direct3DDevice9_Clear( 0, NULL, D_D3DCLEAR_TARGET, ClearColor, 1.0f, 0 ) ;
	}

	// Xbv`FC̃AhX擾
	GAPIWin.Direct3DDevice9Object->GetSwapChain( 0, &GAPIWin.Direct3DSwapChain9Object ) ;

	// I
	return 0 ;

	// G[
ERR:
	return ErrorRet ;
}

// }`Tv_ÕTvƃNIeB`FbN
extern int Direct3D9_CheckMultiSampleParam( D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE *Samples, DWORD *Quality, int SamplesFailedBreak )
{
	DWORD ColorBufferQuality, ZBufferQuality, MaxQuality ;

	// J[obt@Ŏgpł}`Tv^CvƂ̍ۂ̃NIeB擾
	ColorBufferQuality = 0 ;
	for(;;)
	{
		if( Direct3D9_CheckDeviceMultiSampleType( 0, D_D3DDEVTYPE_HAL, Format, NS_GetWindowModeFlag(), *Samples, &ColorBufferQuality ) == D_D3D_OK )
			break ;

		if( SamplesFailedBreak )
		{
			*Quality = 0 ;
			return -1 ;
		}

		*Samples = ( D_D3DMULTISAMPLE_TYPE )( ( int )*Samples - 1 ) ;
		if( *Samples == D_D3DMULTISAMPLE_NONE ) break ;
	}

	// gpł}`Tv^CvI
	if( *Samples == D_D3DMULTISAMPLE_NONE )
	{
		*Quality = 0 ;
		return 0 ;
	}

	// yobt@Ŏgpł}`Tv^CvƂ̍ۂ̃NIeB擾
	ZBufferQuality = 0 ;
	for(;;)
	{
		if( Direct3D9_CheckDeviceMultiSampleType( 0, D_D3DDEVTYPE_HAL, D_D3DFMT_D16, NS_GetWindowModeFlag(), *Samples, &ZBufferQuality ) == D_D3D_OK )
			break ;

		if( SamplesFailedBreak )
		{
			*Quality = 0 ;
			return -1 ;
		}

		*Samples = ( D_D3DMULTISAMPLE_TYPE )( ( int )*Samples - 1 ) ;
		if( *Samples == D_D3DMULTISAMPLE_NONE ) break ;
	}

	// gpł}`Tv^CvI
	if( *Samples == D_D3DMULTISAMPLE_NONE )
	{
		*Quality = 0 ;
		return 0 ;
	}

	// NIeB͒Ⴂقɍ킹
	MaxQuality = ( ZBufferQuality < ColorBufferQuality ? ZBufferQuality : ColorBufferQuality ) - 1 ;
	if( *Quality > MaxQuality ) *Quality = MaxQuality ;

	// I
	return 0 ;
}

extern int Direct3D9_IsValid( void )
{
	return GAPIWin.Direct3D9Object != NULL ? 1 : 0 ;
}

extern int Direct3D9_IsExObject( void )
{
	return GAPIWin.Direct3D9ExObject != NULL ? 1 : 0 ;
}






extern long Direct3DDevice9_SetDialogBoxMode( BOOL bEnableDialogs )
{
	return GAPIWin.Direct3DDevice9Object->SetDialogBoxMode( bEnableDialogs ) ;
}



extern int Direct3DDevice9_Release( void )
{
	// Xbv`FC̉
	if( GAPIWin.Direct3DSwapChain9Object )
	{
		GAPIWin.Direct3DSwapChain9Object->Release() ;
		GAPIWin.Direct3DSwapChain9Object = NULL ;
	}

	if( GAPIWin.Direct3DDevice9Object )
	{
		DXST_ERRORLOG_ADD( _T( "Direct3DDevice9 ̉ 2\n" ) ) ;

		GAPIWin.Direct3DDevice9Object->Release() ;
		GAPIWin.Direct3DDevice9Object = NULL ;
	}

	// I
	return 0 ;
}

extern UINT Direct3DDevice9_GetAvailableTextureMem( void )
{
	return GAPIWin.Direct3DDevice9Object->GetAvailableTextureMem();
}

extern long Direct3DDevice9_GetDeviceCaps( D_D3DCAPS9* pCaps)
{
	return GAPIWin.Direct3DDevice9Object->GetDeviceCaps( pCaps );
}

extern long Direct3DDevice9_GetBackBuffer( UINT iSwapChain, UINT iBackBuffer, D_D3DBACKBUFFER_TYPE Type, D_IDirect3DSurface9** ppBackBuffer )
{
	return GAPIWin.Direct3DDevice9Object->GetBackBuffer( iSwapChain, iBackBuffer, Type, ppBackBuffer ) ;
}

extern long Direct3DDevice9_CreateTexture( UINT Width, UINT Height, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DTexture9** ppTexture, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateTexture( Width, Height, Levels, Usage, Format, Pool, ppTexture, pSharedHandle) ;
}

extern long Direct3DDevice9_CreateVolumeTexture( UINT Width, UINT Height, UINT Depth, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DVolumeTexture9** ppVolumeTexture, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateVolumeTexture( Width, Height, Depth, Levels, Usage, Format, Pool, ppVolumeTexture, pSharedHandle) ;
}

extern long Direct3DDevice9_CreateCubeTexture( UINT EdgeLength, UINT Levels, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DCubeTexture9** ppCubeTexture, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateCubeTexture( EdgeLength, Levels, Usage, Format, Pool, ppCubeTexture, pSharedHandle) ;
}

extern long Direct3DDevice9_CreateVertexBuffer( UINT Length, DWORD Usage, DWORD FVF, D_D3DPOOL Pool, D_IDirect3DVertexBuffer9** ppVertexBuffer, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateVertexBuffer( Length, Usage, FVF, Pool, ppVertexBuffer, pSharedHandle) ;
}

extern long Direct3DDevice9_CreateIndexBuffer( UINT Length, DWORD Usage, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DIndexBuffer9** ppIndexBuffer, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateIndexBuffer( Length, Usage, Format, Pool, ppIndexBuffer, pSharedHandle) ;
}

extern long Direct3DDevice9_CreateRenderTarget( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateRenderTarget( Width, Height, Format, MultiSample, MultisampleQuality, Lockable, ppSurface, pSharedHandle) ;
}

extern long Direct3DDevice9_CreateDepthStencilSurface( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateDepthStencilSurface( Width, Height, Format, MultiSample, MultisampleQuality, Discard, ppSurface, pSharedHandle) ;
}

extern long Direct3DDevice9_UpdateSurface( D_IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, D_IDirect3DSurface9* pDestinationSurface, CONST POINT* pDestPoint)
{
	return GAPIWin.Direct3DDevice9Object->UpdateSurface( pSourceSurface, pSourceRect, pDestinationSurface, pDestPoint) ;
}

extern long Direct3DDevice9_UpdateTexture( D_IDirect3DBaseTexture9* pSourceTexture, D_IDirect3DBaseTexture9* pDestinationTexture)
{
	return GAPIWin.Direct3DDevice9Object->UpdateTexture( pSourceTexture, pDestinationTexture) ;
}

extern long Direct3DDevice9_GetRenderTargetData( D_IDirect3DSurface9* pRenderTarget, D_IDirect3DSurface9* pDestSurface)
{
	return GAPIWin.Direct3DDevice9Object->GetRenderTargetData( pRenderTarget, pDestSurface) ;
}

extern long Direct3DDevice9_StretchRect( D_IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, D_IDirect3DSurface9* pDestSurface, CONST RECT* pDestRect, D_D3DTEXTUREFILTERTYPE Filter)
{
	return GAPIWin.Direct3DDevice9Object->StretchRect( pSourceSurface, pSourceRect, pDestSurface, pDestRect, Filter) ;
}

extern long Direct3DDevice9_ColorFill( D_IDirect3DSurface9* pSurface, CONST RECT* pRect, D_D3DCOLOR color)
{
	return GAPIWin.Direct3DDevice9Object->ColorFill( pSurface, pRect, color) ;
}

extern long Direct3DDevice9_CreateOffscreenPlainSurface( UINT Width, UINT Height, D_D3DFORMAT Format, D_D3DPOOL Pool, D_IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle)
{
	return GAPIWin.Direct3DDevice9Object->CreateOffscreenPlainSurface( Width, Height, Format, Pool, ppSurface, pSharedHandle) ;
}

extern long Direct3DDevice9_SetRenderTarget( DWORD RenderTargetIndex, D_IDirect3DSurface9* pRenderTarget)
{
	return GAPIWin.Direct3DDevice9Object->SetRenderTarget( RenderTargetIndex, pRenderTarget) ;
}

extern long Direct3DDevice9_SetDepthStencilSurface( D_IDirect3DSurface9* pNewZStencil)
{
	return GAPIWin.Direct3DDevice9Object->SetDepthStencilSurface( pNewZStencil) ;
}

extern long Direct3DDevice9_GetDepthStencilSurface( D_IDirect3DSurface9** ppZStencilSurface)
{
	return GAPIWin.Direct3DDevice9Object->GetDepthStencilSurface( ppZStencilSurface) ;
}

extern long Direct3DDevice9_BeginScene( void )
{
	return GAPIWin.Direct3DDevice9Object->BeginScene() ;
}

extern long Direct3DDevice9_EndScene( void )
{
	return GAPIWin.Direct3DDevice9Object->EndScene() ;
}

extern long Direct3DDevice9_Clear( DWORD Count, CONST D_D3DRECT* pRects, DWORD Flags, D_D3DCOLOR Color, float Z, DWORD Stencil)
{
	return GAPIWin.Direct3DDevice9Object->Clear( Count, pRects, Flags, Color, Z, Stencil) ;
}

extern long Direct3DDevice9_SetTransform( D_D3DTRANSFORMSTATETYPE State, CONST D_D3DMATRIX* pMatrix)
{
	return GAPIWin.Direct3DDevice9Object->SetTransform( State, pMatrix) ;
}

extern long Direct3DDevice9_SetViewport( CONST D_D3DVIEWPORT9* pViewport)
{
	return GAPIWin.Direct3DDevice9Object->SetViewport( pViewport) ;
}

extern long Direct3DDevice9_SetMaterial( CONST D_D3DMATERIAL9* pMaterial)
{
	return GAPIWin.Direct3DDevice9Object->SetMaterial( pMaterial) ;
}

extern long Direct3DDevice9_GetMaterial( D_D3DMATERIAL9* pMaterial)
{
	return GAPIWin.Direct3DDevice9Object->GetMaterial( pMaterial) ;
}

extern long Direct3DDevice9_SetLight( DWORD Index, CONST D_D3DLIGHT9* Param )
{
	return GAPIWin.Direct3DDevice9Object->SetLight( Index, Param ) ;
}

extern long Direct3DDevice9_LightEnable( DWORD Index, BOOL Enable)
{
	return GAPIWin.Direct3DDevice9Object->LightEnable( Index, Enable) ;
}

extern long Direct3DDevice9_SetRenderState( D_D3DRENDERSTATETYPE State, DWORD Value )
{
	return GAPIWin.Direct3DDevice9Object->SetRenderState( State, Value ) ;
}

extern long Direct3DDevice9_SetTexture( DWORD Stage, D_IDirect3DBaseTexture9* pTexture)
{
	return GAPIWin.Direct3DDevice9Object->SetTexture( Stage, pTexture) ;
}

extern long Direct3DDevice9_SetTextureStageState( DWORD Stage, D_D3DTEXTURESTAGESTATETYPE Type, DWORD Value)
{
	return GAPIWin.Direct3DDevice9Object->SetTextureStageState( Stage, Type, Value) ;
}

extern long Direct3DDevice9_SetSamplerState( DWORD Sampler, D_D3DSAMPLERSTATETYPE Type, DWORD Value )
{
	return GAPIWin.Direct3DDevice9Object->SetSamplerState( Sampler, Type, Value ) ;
}

extern long Direct3DDevice9_SetScissorRect( CONST RECT* pRect)
{
	return GAPIWin.Direct3DDevice9Object->SetScissorRect( pRect) ;
}

extern long Direct3DDevice9_DrawPrimitive( D_D3DPRIMITIVETYPE PrimitiveType, UINT StartVertex, UINT PrimitiveCount )
{
	return GAPIWin.Direct3DDevice9Object->DrawPrimitive( PrimitiveType,  StartVertex,  PrimitiveCount ) ;
}

extern long Direct3DDevice9_DrawIndexedPrimitive( D_D3DPRIMITIVETYPE PrimitiveType, INT BaseVertexIndex, UINT MinVertexIndex, UINT NumVertices, UINT startIndex, UINT primCount )
{
	return GAPIWin.Direct3DDevice9Object->DrawIndexedPrimitive( PrimitiveType,  BaseVertexIndex,  MinVertexIndex,  NumVertices,  startIndex,  primCount ) ;
}

extern long Direct3DDevice9_DrawPrimitiveUP( D_D3DPRIMITIVETYPE PrimitiveType, UINT PrimitiveCount, CONST void* pVertexStreamZeroData, UINT VertexStreamZeroStride )
{
	return GAPIWin.Direct3DDevice9Object->DrawPrimitiveUP( PrimitiveType, PrimitiveCount, pVertexStreamZeroData, VertexStreamZeroStride ) ;
}

extern long Direct3DDevice9_DrawIndexedPrimitiveUP( D_D3DPRIMITIVETYPE PrimitiveType, UINT MinVertexIndex, UINT NumVertices, UINT PrimitiveCount, CONST void* pIndexData, D_D3DFORMAT IndexDataFormat, CONST void* pVertexStreamZeroData, UINT VertexStreamZeroStride )
{
	return GAPIWin.Direct3DDevice9Object->DrawIndexedPrimitiveUP( PrimitiveType, MinVertexIndex, NumVertices, PrimitiveCount, pIndexData, IndexDataFormat, pVertexStreamZeroData, VertexStreamZeroStride ) ;
}

extern long Direct3DDevice9_CreateVertexDeclaration( CONST D_D3DVERTEXELEMENT9* pVertexElements, D_IDirect3DVertexDeclaration9** ppDecl)
{
	return GAPIWin.Direct3DDevice9Object->CreateVertexDeclaration( pVertexElements, ppDecl) ;
}

extern long Direct3DDevice9_SetVertexDeclaration( D_IDirect3DVertexDeclaration9* pDecl )
{
	return GAPIWin.Direct3DDevice9Object->SetVertexDeclaration( pDecl ) ;
}

extern long Direct3DDevice9_SetFVF( DWORD FVF)
{
	return GAPIWin.Direct3DDevice9Object->SetFVF( FVF ) ;
}

extern long Direct3DDevice9_CreateVertexShader( CONST DWORD* pFunction, D_IDirect3DVertexShader9** ppShader)
{
	return GAPIWin.Direct3DDevice9Object->CreateVertexShader( pFunction, ppShader) ;
}

extern long Direct3DDevice9_SetVertexShader( D_IDirect3DVertexShader9* pShader)
{
	return GAPIWin.Direct3DDevice9Object->SetVertexShader( pShader) ;
}

extern long Direct3DDevice9_SetVertexShaderConstantF( UINT StartRegister, CONST float* pConstantData, UINT Vector4fCount)
{
	return GAPIWin.Direct3DDevice9Object->SetVertexShaderConstantF( StartRegister, pConstantData, Vector4fCount) ;
}

extern long Direct3DDevice9_SetVertexShaderConstantI( UINT StartRegister, CONST int* pConstantData, UINT Vector4iCount)
{
	return GAPIWin.Direct3DDevice9Object->SetVertexShaderConstantI( StartRegister, pConstantData, Vector4iCount) ;
}

extern long Direct3DDevice9_SetVertexShaderConstantB( UINT StartRegister, CONST BOOL* pConstantData, UINT  BoolCount)
{
	return GAPIWin.Direct3DDevice9Object->SetVertexShaderConstantB( StartRegister, pConstantData,  BoolCount) ;
}

extern long Direct3DDevice9_SetStreamSource( UINT StreamNumber, D_IDirect3DVertexBuffer9* pStreamData, UINT OffsetInBytes, UINT Stride )
{
	return GAPIWin.Direct3DDevice9Object->SetStreamSource( StreamNumber, pStreamData, OffsetInBytes, Stride ) ;
}

extern long Direct3DDevice9_SetIndices( D_IDirect3DIndexBuffer9* pIndexData )
{
	return GAPIWin.Direct3DDevice9Object->SetIndices( pIndexData ) ;
}

extern long Direct3DDevice9_CreatePixelShader( CONST DWORD* pFunction, D_IDirect3DPixelShader9** ppShader)
{
	return GAPIWin.Direct3DDevice9Object->CreatePixelShader( pFunction, ppShader) ;
}

extern long Direct3DDevice9_SetPixelShader( D_IDirect3DPixelShader9* pShader)
{
	return GAPIWin.Direct3DDevice9Object->SetPixelShader( pShader) ;
}

extern long Direct3DDevice9_SetPixelShaderConstantF( UINT StartRegister, CONST float* pConstantData, UINT Vector4fCount)
{
	return GAPIWin.Direct3DDevice9Object->SetPixelShaderConstantF( StartRegister, pConstantData, Vector4fCount) ;
}

extern long Direct3DDevice9_SetPixelShaderConstantI( UINT StartRegister, CONST int* pConstantData, UINT Vector4iCount)
{
	return GAPIWin.Direct3DDevice9Object->SetPixelShaderConstantI( StartRegister, pConstantData, Vector4iCount) ;
}

extern long Direct3DDevice9_SetPixelShaderConstantB( UINT StartRegister, CONST BOOL* pConstantData, UINT  BoolCount)
{
	return GAPIWin.Direct3DDevice9Object->SetPixelShaderConstantB( StartRegister, pConstantData,  BoolCount) ;
}

// e|vC}obt@̓evC}obt@ɓ]R[obN֐
#if _MSC_VER > 1200
static VOID CALLBACK ScreenFlipTimerProc( HWND /*hwnd*/, UINT /*uMsg*/, UINT_PTR /*idEvent*/, DWORD /*dwTime*/ )
#else
static VOID CALLBACK ScreenFlipTimerProc( HWND /*hwnd*/, UINT /*uMsg*/, UINT /*idEvent*/, DWORD /*dwTime*/ )
#endif
{
	KillTimer( NS_GetMainWindowHandle(), SCREENFLIPTIMER_ID );
	if( GSYS.DrawSetting.TargetScreen[ 0 ] == DX_SCREEN_FRONT &&
		GSYS.DrawSetting.TargetScreenSurface[ 0 ] == 0 &&
		WinData.BackBufferTransColorFlag == FALSE &&
		WinData.UseUpdateLayerdWindowFlag == FALSE )
	{
		if( NS_GetActiveFlag() == TRUE )
		{
			NS_ScreenCopy() ;
		}
//		BltTempPrimaryToPrimary();
		SetTimer( NS_GetMainWindowHandle(), SCREENFLIPTIMER_ID, 32, ScreenFlipTimerProc );
	}
}

extern int Direct3DDevice9_Present( void )
{
	RECT WindRect ;
	RECT ScreenRect ;
	int  DrawScreenWidth ;
	int  DrawScreenHeight ;

	// ]ƂȂʂ̋`Zbg
	{
		NS_GetDrawScreenSize( &DrawScreenWidth, &DrawScreenHeight ) ;
		ScreenRect.left   = 0 ;
		ScreenRect.top    = 0 ;
		ScreenRect.right  = GSYS.Screen.MainScreenSizeX ;
		ScreenRect.bottom = GSYS.Screen.MainScreenSizeY ;
	}

	// EChE[h̏ꍇ͓]EChẼfXNgbv̍Wo
	if( NS_GetWindowModeFlag() == TRUE )
	{
		int    ClientHeight ;
		double ExRateX ;
		double ExRateY ;

		WindRect.left   = 0 ;
		WindRect.top    = 0 ;

		// ݂̃EChẼNCAg̈̃TCY𓾂
		NS_GetWindowSizeExtendRate( &ExRateX, &ExRateY ) ;
		WindRect.right  = _DTOL( DrawScreenWidth  * ExRateX ) ;
		WindRect.bottom = _DTOL( DrawScreenHeight * ExRateY ) ;

		if( WinData.ToolBarUseFlag )
		{
			ClientHeight    = WinData.WindowRect.bottom - WinData.WindowRect.top ;
			WindRect.top    = ClientHeight - DrawScreenHeight ;
			WindRect.bottom = ClientHeight ;
		}
	}
	else
	{
		WindRect.left   = 0 ;
		WindRect.top    = 0 ;
		WindRect.right  = GSYS.Screen.MainScreenSizeX ;
		WindRect.bottom = GSYS.Screen.MainScreenSizeY ;
	}

	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware )
	{
		// gĂꍇ
		Graphics_D3D9_RenderVertex() ;
		Graphics_D3D9_EndScene();

		// obNobt@̓ߐF̕𓧉߂tOAUpdateLayerdWindow gptOĂꍇ͏𕪊
		if( WinData.BackBufferTransColorFlag && WinData.UseUpdateLayerdWindowFlag )
		{
			BASEIMAGE BackBufferImage ;
			RECT      LockRect ;
			int       OldTargetScreen ;
			int       OldTargetScreenSurfaceIndex ;

			// urxmb҂	
			if( GSYS.Screen.NotWaitVSyncFlag == FALSE ) Direct3DDevice9_LocalWaitVSync() ;

			// Graphics_Screen_LockDrawScreen g@
			OldTargetScreen                           = GSYS.DrawSetting.TargetScreen[ 0 ] ;
			OldTargetScreenSurfaceIndex               = GSYS.DrawSetting.TargetScreenSurface [ 0 ] ;
			GSYS.DrawSetting.TargetScreen[ 0 ]        = DX_SCREEN_BACK ;
			GSYS.DrawSetting.TargetScreenSurface[ 0 ] = 0 ;
			LockRect.left                             = 0 ;
			LockRect.top                              = 0 ;
			LockRect.right                            = GSYS.Screen.MainScreenSizeX ;
			LockRect.bottom                           = GSYS.Screen.MainScreenSizeY ;
			if( Graphics_Screen_LockDrawScreen( &LockRect, &BackBufferImage, -1, -1, TRUE, 0 ) < 0 )
				goto ERR ;
			UpdateBackBufferTransColorWindow( &BackBufferImage ) ;
			Graphics_Screen_UnlockDrawScreen() ;
			GSYS.DrawSetting.TargetScreen[ 0 ]        = OldTargetScreen ;
			GSYS.DrawSetting.TargetScreenSurface[ 0 ] = OldTargetScreenSurfaceIndex ;
		}
		else
		{
			// 320x240ʃG~[V[h̏ꍇ͓]Ɠ]̋`͌Œ
			if( GSYS.Screen.Emulation320x240Flag )
			{
				WindRect.left     = 0 ;
				WindRect.top      = 0 ;
				WindRect.right    = 640 ;
				WindRect.bottom   = 480 ;

				ScreenRect.left   = 0 ;
				ScreenRect.top    = 0 ;
				ScreenRect.right  = 320 ;
				ScreenRect.bottom = 240 ;
			}

			// TuobNobt@gpĂꍇ͓eCobNobt@ɓ]
			if( GD3D9.Device.Screen.SubBackBufferSurface != NULL )
			{
				RECT SubBackBufferSrcRect ;

				// TuobNobt@ɓ]̈ݒ肷
				if( GSYS.Screen.ValidGraphDisplayArea )
				{
					RECT ClipRect ;

					ClipRect.left   = 0 ;
					ClipRect.top    = 0 ;
					ClipRect.right  = GSYS.Screen.MainScreenSizeX ;
					ClipRect.bottom = GSYS.Screen.MainScreenSizeY ;

					SubBackBufferSrcRect = GSYS.Screen.GraphDisplayArea ;
					RectClipping( &SubBackBufferSrcRect, &ClipRect ) ;
					if( SubBackBufferSrcRect.right  - SubBackBufferSrcRect.left <= 0 ||
						SubBackBufferSrcRect.bottom - SubBackBufferSrcRect.top  <= 0 )
					{
						goto ERR ;
					}
				}
				else
				{
					SubBackBufferSrcRect.left   = 0 ;
					SubBackBufferSrcRect.top    = 0 ;
					SubBackBufferSrcRect.right  = GSYS.Screen.MainScreenSizeX ;
					SubBackBufferSrcRect.bottom = GSYS.Screen.MainScreenSizeY ;
				}

				// EChE[h̏ꍇƃtXN[[h̏ꍇŏ𕪊
				if( NS_GetWindowModeFlag() )
				{
					// EChE[h̏ꍇ͂̂܂ܓ]
					if( Direct3DDevice9_StretchRect(
							GD3D9.Device.Screen.SubBackBufferSurface,
							&SubBackBufferSrcRect,
							GD3D9.Device.Screen.BackBufferSurface,
							NULL,
							GSYS.Screen.ValidGraphDisplayArea ? D_D3DTEXF_POINT : D_D3DTEXF_NONE
						) != D_D3D_OK )
					{
						goto ERR ;
					}
				}
				else
				{
					// tXN[[h̏ꍇ̓tXN[𑜓x[hɂď𕪊
					switch( GSYS.Screen.FullScreenResolutionModeAct )
					{
					case DX_FSRESOLUTIONMODE_NATIVE :
						// ̂܂ܓ]
						if( Direct3DDevice9_StretchRect(
								GD3D9.Device.Screen.SubBackBufferSurface,
								&SubBackBufferSrcRect,
								GD3D9.Device.Screen.BackBufferSurface,
								NULL,
								GSYS.Screen.ValidGraphDisplayArea ? D_D3DTEXF_POINT : D_D3DTEXF_NONE
							) != D_D3D_OK )
						{
							goto ERR ;
						}
						break ;

					case DX_FSRESOLUTIONMODE_MAXIMUM :
					case DX_FSRESOLUTIONMODE_DESKTOP :
						// TuobNobt@̓esNZ̏cPFPɕۂő܂Ŋg債ē]
						{
							D_D3DTEXTUREFILTERTYPE StretchType ;

							// ]`̃ZbgAbv
							Graphics_Screen_SetupFullScreenScalingDestRect() ;

							// ]̊g
							StretchType = D_D3DTEXF_NONE ;
							switch( GSYS.Screen.FullScreenScalingMode )
							{
							default :
							case DX_FSSCALINGMODE_BILINEAR :
								if( GD3D9.Device.Caps.DeviceCaps.StretchRectFilterCaps & D_D3DPTFILTERCAPS_MAGFLINEAR )
								{
									StretchType = D_D3DTEXF_LINEAR ;
								}
								else
								if( GD3D9.Device.Caps.DeviceCaps.StretchRectFilterCaps & D_D3DPTFILTERCAPS_MAGFPOINT )
								{
									StretchType = D_D3DTEXF_POINT ;
								}
								break ;

							case DX_FSSCALINGMODE_NEAREST :
								if( GD3D9.Device.Caps.DeviceCaps.StretchRectFilterCaps & D_D3DPTFILTERCAPS_MAGFPOINT )
								{
									StretchType = D_D3DTEXF_POINT ;
								}
								break ;
							}

							// TuobNobt@̓eobNobt@ɓ]
							if( Direct3DDevice9_StretchRect(
									GD3D9.Device.Screen.SubBackBufferSurface,
									&SubBackBufferSrcRect,
									GD3D9.Device.Screen.BackBufferSurface,
									&GSYS.Screen.FullScreenScalingDestRect,
									StretchType
								) != D_D3D_OK )
							{
								goto ERR ;
							}
						}
						break ;
					}
				}
			}

			// tbv
			if( GAPIWin.Direct3DSwapChain9Object )
			{
				LONGLONG Time ;

				// oߎԂv
				Time = NS_GetNowHiPerformanceCount() ;

				// ŏĂȂƂ Present s
				if( WinData.WindowMinSizeFlag == FALSE )
				{
					// EChE[hǂŏ𕪊
					if( NS_GetWindowModeFlag() )
					{
						if( GAPIWin.Direct3DSwapChain9Object->Present(
								&ScreenRect,
								&WindRect,
								GetDisplayWindowHandle(),
								NULL,
								0 ) != D_D3D_OK )
						{
							goto ERR ;
						}
					}
					else
					{
						// tXN[[h̏ꍇ͕KʑŜ]
						if( GAPIWin.Direct3DSwapChain9Object->Present(
								NULL,
								NULL,
								GetDisplayWindowHandle(),
								NULL,
								0 ) != D_D3D_OK )
						{
							goto ERR ;
						}
					}
				}

				// VSYNC҂wĂ̂ɖwǎԂo߂ĂȂVSYNC҂
				Time = NS_GetNowHiPerformanceCount() - Time ;
				if( NS_GetAlwaysRunFlag() &&
					GSYS.Screen.NotWaitVSyncFlag == FALSE &&
					Time < 500 )
				{
					Direct3DDevice9_LocalWaitVSync() ;
				}
			}
		}
	}
	else
	{
		// \tgEGA_Ȍꍇ
		char        Buffer[ sizeof( BITMAPINFOHEADER ) + sizeof( DWORD ) * 3 + 4 ] ;
		BITMAPINFO *pBmpInfo ;
		HDC         Dc ;

		if( CheckValidMemImg( &GSYS.SoftRender.MainBufferMemImg ) == FALSE ||
			CheckValidMemImg( &GSYS.SoftRender.SubBufferMemImg ) == FALSE )
		{
			goto END ;
		}

		// urxmb҂	
		if( GSYS.Screen.NotWaitVSyncFlag == FALSE ) Direct3DDevice9_LocalWaitVSync() ;

		// obNobt@̓ߐF̕𓧉߂tOAUpdateLayerdWindow gptOĂꍇ͏𕪊
		if( WinData.BackBufferTransColorFlag && WinData.UseUpdateLayerdWindowFlag )
		{
			BASEIMAGE BackBufferImage ;
			RECT      LockRect ;
			int       OldTargetScreen ;
			int       OldTargetScreenSurface ;

			// urxmb҂	
			if( GSYS.Screen.NotWaitVSyncFlag == FALSE ) Direct3DDevice9_LocalWaitVSync() ;

			// Graphics_Screen_LockDrawScreen g@
			OldTargetScreen                           = GSYS.DrawSetting.TargetScreen[ 0 ] ;
			OldTargetScreenSurface                    = GSYS.DrawSetting.TargetScreenSurface[ 0 ] ;
			GSYS.DrawSetting.TargetScreen[ 0 ]        = DX_SCREEN_BACK ;
			GSYS.DrawSetting.TargetScreenSurface[ 0 ] = 0 ;
			LockRect.left                             = 0 ;
			LockRect.top                              = 0 ;
			LockRect.right                            = GSYS.Screen.MainScreenSizeX ;
			LockRect.bottom                           = GSYS.Screen.MainScreenSizeY ;
			if( Graphics_Screen_LockDrawScreen( &LockRect, &BackBufferImage, -1, -1, TRUE, 0 ) < 0 )
				goto ERR ;
			UpdateBackBufferTransColorWindow( &BackBufferImage ) ;
			Graphics_Screen_UnlockDrawScreen() ;
			GSYS.DrawSetting.TargetScreen[ 0 ]        = OldTargetScreen ;
			GSYS.DrawSetting.TargetScreenSurface[ 0 ] = OldTargetScreenSurface ;
		}
		else
		{
			MEMIMG *UseScreenMemImg ;

			// ʂɓ]̈肷ꍇ͍ŏɃTuobt@ɓ]
			if( GSYS.Screen.ValidGraphDisplayArea )
			{
				RECT   SrcRect ;
				RECT   ClipRect ;
				MEMIMG BltSrcMemImg ;

				// Tuobt@ɓ]̈ݒ肷
				ClipRect.left   = 0 ;
				ClipRect.top    = 0 ;
				ClipRect.right  = GSYS.Screen.MainScreenSizeX ;
				ClipRect.bottom = GSYS.Screen.MainScreenSizeY ;

				SrcRect = GSYS.Screen.GraphDisplayArea ;
				RectClipping( &SrcRect, &ClipRect ) ;
				if( SrcRect.right  - SrcRect.left <= 0 ||
					SrcRect.bottom - SrcRect.top  <= 0 )
				{
					goto ERR ;
				}

				// ô݂ MEMIMG 쐬
				DerivationMemImg(
					&BltSrcMemImg,
					&GSYS.SoftRender.MainBufferMemImg,
					SrcRect.left,
					SrcRect.top,
					SrcRect.right  - SrcRect.left,
					SrcRect.bottom - SrcRect.top
				) ;

				// Tuobt@Ŝɓ]
				DrawEnlargeMemImg(
					&GSYS.SoftRender.SubBufferMemImg,
					&BltSrcMemImg,
					&ClipRect,
					FALSE,
					NULL
				) ;

				UseScreenMemImg = &GSYS.SoftRender.SubBufferMemImg ;
			}
			else
			{
				UseScreenMemImg = &GSYS.SoftRender.MainBufferMemImg ;
			}

			// CEChÊcb擾ē]
			pBmpInfo = ( BITMAPINFO * )Buffer ;
			_MEMSET( Buffer, 0, sizeof( Buffer ) ) ;
			pBmpInfo->bmiHeader.biSize               = sizeof( pBmpInfo->bmiHeader ) ;
			pBmpInfo->bmiHeader.biWidth              =  GSYS.Screen.MainScreenSizeX ;
			pBmpInfo->bmiHeader.biHeight             = -GSYS.Screen.MainScreenSizeY ;
			pBmpInfo->bmiHeader.biPlanes             = 1 ;
			pBmpInfo->bmiHeader.biBitCount           = UseScreenMemImg->Base->ColorDataP->ColorBitDepth ;
			pBmpInfo->bmiHeader.biCompression        = BI_BITFIELDS ;
			( ( DWORD * )&pBmpInfo->bmiColors )[ 0 ] = UseScreenMemImg->Base->ColorDataP->RedMask ;
			( ( DWORD * )&pBmpInfo->bmiColors )[ 1 ] = UseScreenMemImg->Base->ColorDataP->GreenMask ;
			( ( DWORD * )&pBmpInfo->bmiColors )[ 2 ] = UseScreenMemImg->Base->ColorDataP->BlueMask ;

			// sb`PUoCg̔{Ȃ̂ŕ␳
			if( UseScreenMemImg->Base->ColorDataP->ColorBitDepth == 16 )
			{
				// 16bit
				pBmpInfo->bmiHeader.biWidth = ( pBmpInfo->bmiHeader.biWidth + 16 / 2 - 1 ) / ( 16 / 2 ) * ( 16 / 2 ) ;
			}
			else
			{
				// 32bit
				pBmpInfo->bmiHeader.biWidth = ( pBmpInfo->bmiHeader.biWidth + 16 / 4 - 1 ) / ( 16 / 4 ) * ( 16 / 4 ) ;
			}

			Dc = GetDC( GetDisplayWindowHandle() ) ;
			if( Dc )
			{
				// EChE[hłRQO~QSOG~[V[h̏ꍇ͓]Ɠ]̃p[^͌Œ
				if( NS_GetWindowModeFlag() && GSYS.Screen.Emulation320x240Flag )
				{
					StretchDIBits(
						Dc,
						0,
						0,
						640,
						480, 
						0,
						0,
						320,
						240,
						UseScreenMemImg->UseImage, pBmpInfo, DIB_RGB_COLORS, SRCCOPY );
				}
				else
				{
					if( NS_GetWindowModeFlag() == FALSE )
					{
						// tXN[[h̏ꍇ

						// ʑŜhԂw肪s
						if( GRAWIN.FullScreenBlackFillCounter > 0 )
						{
							GRAWIN.FullScreenBlackFillCounter -- ;

							// EChE̍W[Ɉړ
							NS_SetWindowPosition( 0, 0 ) ;

							// ʑŜœhԂ
							{
								HBRUSH OldBrush;

								OldBrush = ( HBRUSH )SelectObject( Dc, GetStockObject( BLACK_BRUSH ) ) ;
								Rectangle(
									Dc,
									0,
									0,
									GSYS.Screen.FullScreenUseDispModeData.Width,
									GSYS.Screen.FullScreenUseDispModeData.Height
								) ;
								SelectObject( Dc, OldBrush) ;
							}
						}

						switch( GSYS.Screen.FullScreenResolutionModeAct )
						{
						case DX_FSRESOLUTIONMODE_NATIVE :
							SetDIBitsToDevice(
								Dc,
								0, 0,
								GSYS.Screen.MainScreenSizeX, GSYS.Screen.MainScreenSizeY,
								0, 0,
								0, GSYS.Screen.MainScreenSizeY, 
								UseScreenMemImg->UseImage, pBmpInfo, DIB_RGB_COLORS );
							break ;

						case DX_FSRESOLUTIONMODE_MAXIMUM :
						case DX_FSRESOLUTIONMODE_DESKTOP :
							// ]`̃ZbgAbv
							Graphics_Screen_SetupFullScreenScalingDestRect() ;

//							DXST_ERRORLOGFMT_ADD(( _T( "GSYS.Screen.FullScreenScalingDestRect %d %d %d %d" ),
//								GSYS.Screen.FullScreenScalingDestRect.left,
//								GSYS.Screen.FullScreenScalingDestRect.top,
//								GSYS.Screen.FullScreenScalingDestRect.right,
//								GSYS.Screen.FullScreenScalingDestRect.bottom
//							)) ;

							StretchDIBits(
								Dc,
								GSYS.Screen.FullScreenScalingDestRect.left,
								GSYS.Screen.FullScreenScalingDestRect.top,
								GSYS.Screen.FullScreenScalingDestRect.right  - GSYS.Screen.FullScreenScalingDestRect.left,
								GSYS.Screen.FullScreenScalingDestRect.bottom - GSYS.Screen.FullScreenScalingDestRect.top,
								0,
								0,
								GSYS.Screen.MainScreenSizeX,
								GSYS.Screen.MainScreenSizeY,
								UseScreenMemImg->UseImage, pBmpInfo, DIB_RGB_COLORS, SRCCOPY );
							break ;
						}
					}
					else
					{
						int WindowSizeX ;
						int WindowSizeY ;

						WindowSizeX = WindRect.right  - WindRect.left ;
						WindowSizeY = WindRect.bottom - WindRect.top ;

						// EChE[h̏ꍇ
						if( GSYS.Screen.MainScreenSizeX == WindowSizeX && GSYS.Screen.MainScreenSizeY == WindowSizeY )
						{
							SetDIBitsToDevice(
								Dc,
								0, 0,
								WindowSizeX, WindowSizeY,
								0, 0,
								0, WindowSizeY, 
								UseScreenMemImg->UseImage, pBmpInfo, DIB_RGB_COLORS );
						}
						else
						{
							StretchDIBits(
								Dc,
								0, 0,
								WindowSizeX, WindowSizeY, 
								0, 0,
								GSYS.Screen.MainScreenSizeX, GSYS.Screen.MainScreenSizeY,
								UseScreenMemImg->UseImage, pBmpInfo, DIB_RGB_COLORS, SRCCOPY );
						}
					}
				}

				ReleaseDC( GetDisplayWindowHandle(), Dc );
			}
		}
	}

END:
	// I
	return 0 ;

ERR:
	// G[I
	return -1;
}

extern int Direct3DDevice9_BltRectBackScreenToWindow( HWND Window, RECT BackScreenRect, RECT WindowClientRect )
{
	// ``FbN
	if( BackScreenRect.left   == BackScreenRect.right    ||
		BackScreenRect.top    == BackScreenRect.bottom   ||
		WindowClientRect.left == WindowClientRect.right  ||
		WindowClientRect.top  == WindowClientRect.bottom ) return -1 ;

	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware )
	{
		// gĂꍇ
		Graphics_D3D9_RenderVertex() ;
		Graphics_D3D9_EndScene();

		// TuobNobt@gpĂꍇ͓eCobNobt@ɓ]
		if( GD3D9.Device.Screen.SubBackBufferSurface != NULL )
		{
			// gĂꍇ
			if( Direct3DDevice9_StretchRect( GD3D9.Device.Screen.SubBackBufferSurface, NULL, GD3D9.Device.Screen.BackBufferSurface, NULL, D_D3DTEXF_NONE ) != D_D3D_OK )
				return -1 ;
		}

		// tbv
		if( GAPIWin.Direct3DSwapChain9Object )
		{
			if( GAPIWin.Direct3DSwapChain9Object->Present( &BackScreenRect, &WindowClientRect, Window, NULL, 0 ) != D_D3D_OK )
				return -1 ;
		}
	}
	else
	{
		// \tgEGA_Ȍꍇ
		char Buffer[ sizeof( BITMAPINFOHEADER ) + sizeof( DWORD ) * 3 + 4 ];
		BITMAPINFO *pBmpInfo;
		HDC Dc;

		if( CheckValidMemImg( &GSYS.SoftRender.MainBufferMemImg ) == FALSE ) return 0 ;

		// urxmb҂	
		if( GSYS.Screen.NotWaitVSyncFlag == FALSE ) Direct3DDevice9_LocalWaitVSync() ;

		// EChÊcb擾ē]
		pBmpInfo = (BITMAPINFO *)Buffer ;
		_MEMSET( Buffer, 0, sizeof( Buffer ) ) ;
		pBmpInfo->bmiHeader.biSize        = sizeof( pBmpInfo->bmiHeader ) ;
		pBmpInfo->bmiHeader.biWidth       =  GSYS.Screen.MainScreenSizeX ;
		pBmpInfo->bmiHeader.biHeight      = -GSYS.Screen.MainScreenSizeY ;
		pBmpInfo->bmiHeader.biPlanes      = 1;
		pBmpInfo->bmiHeader.biBitCount    = GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP->ColorBitDepth ;
		pBmpInfo->bmiHeader.biCompression = BI_BITFIELDS ;
		( ( DWORD * )&pBmpInfo->bmiColors )[ 0 ] = GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP->RedMask ;
		( ( DWORD * )&pBmpInfo->bmiColors )[ 1 ] = GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP->GreenMask ;
		( ( DWORD * )&pBmpInfo->bmiColors )[ 2 ] = GSYS.SoftRender.MainBufferMemImg.Base->ColorDataP->BlueMask ;
		Dc = GetDC( Window );
		if( Dc )
		{
			StretchDIBits(
				Dc,
				WindowClientRect.left, WindowClientRect.top,
				WindowClientRect.right - WindowClientRect.left,
				WindowClientRect.bottom - WindowClientRect.top,
				BackScreenRect.left, GSYS.Screen.MainScreenSizeY - BackScreenRect.bottom,
				BackScreenRect.right  - BackScreenRect.left,
				BackScreenRect.bottom - BackScreenRect.top,
				( BYTE * )GSYS.SoftRender.MainBufferMemImg.UseImage, pBmpInfo, DIB_RGB_COLORS, SRCCOPY );
			ReleaseDC( Window, Dc );
		}
	}

	// I
	return 0 ;
}

// urxmb̑OSleep鎞Ԃ擾
extern void Direct3DDevice9_WaitVSyncInitialize( void )
{
	GD3D9.Device.Screen.VSyncWaitTime = -1 ;
	if( GAPIWin.DirectDraw7Object )
	{
//		D_DDSURFACEDESC2 Desc2 ;

//		GAPIWin.DirectDraw7Object->GetDisplayMode( &Desc2 ) ;
//		if( Desc2.dwRefreshRate == 0 )
		{
			LONGLONG Time1, Time2, DeltaTime1, DeltaTime2, DeltaTimeTotal, DeltaTimeSize ;
			int Count, LoopCount ;

			DeltaTime1 = 0 ;
			DeltaTime2 = 0 ;
			DeltaTimeTotal = 0 ;
			Count = 0 ;
			LoopCount = 0 ;
			GAPIWin.DirectDraw7Object->WaitForVerticalBlank( D_DDWAITVB_BLOCKBEGIN, 0 ) ;
			Time1 = NS_GetNowHiPerformanceCount() ;
			while( Count < 10 && LoopCount < 60 )
			{
				GAPIWin.DirectDraw7Object->WaitForVerticalBlank( D_DDWAITVB_BLOCKBEGIN, 0 ) ;
				Time2 = NS_GetNowHiPerformanceCount() ;
				DeltaTime2 = Time2 - Time1 ;
				DeltaTimeSize = DeltaTime1 - DeltaTime2 ;
				if( DeltaTimeSize < 0 ) DeltaTimeSize = -DeltaTimeSize ;
				if( DeltaTimeSize < 1000 )
				{
					DeltaTimeTotal += DeltaTime2 ;
					Count ++ ;
				}
				else
				{
					DeltaTimeTotal = 0 ;
					Count = 0 ;
				}
				Time1 = Time2 ;
				DeltaTime1 = DeltaTime2 ;
				LoopCount ++ ;
				if( Count >= 10 )
				{
					GD3D9.Device.Screen.VSyncWaitTime = ( LONGLONG )( ( int )DeltaTimeTotal / Count ) ;
				}
				Sleep( 5 ) ;
			}
		}
//		else
//		{
//		}
	}

	// Pt[҂
	Direct3DDevice9_LocalWaitVSync() ;
}

extern void Direct3DDevice9_LocalWaitVSync( void )
{
//	BOOL flag ;
	LONGLONG WaitTime ;

	// Ourxmb҂ĂŒ҂Ԃ߂Ă邩ǂŏ𕪊
	WaitTime = GD3D9.Device.Screen.VSyncWaitTime != -1 ? GD3D9.Device.Screen.VSyncWaitTime - 3000 : 4000 ; 
	if( NS_GetNowHiPerformanceCount() - GD3D9.Device.Screen.VSyncTime < WaitTime )
	{
		Sleep( 0 ) ;
		while( NS_GetNowHiPerformanceCount() - GD3D9.Device.Screen.VSyncTime < WaitTime ) Sleep( 1 ) ;
		GAPIWin.DirectDraw7Object->WaitForVerticalBlank( D_DDWAITVB_BLOCKBEGIN, 0 ) ;
		GD3D9.Device.Screen.VSyncTime = NS_GetNowHiPerformanceCount() ;
	}
	else
	{
//		GAPIWin.DirectDraw7Object->GetVerticalBlankStatus( &flag ) ;
//		if( flag == FALSE )
		GAPIWin.DirectDraw7Object->WaitForVerticalBlank( D_DDWAITVB_BLOCKBEGIN, 0 ) ;
		GD3D9.Device.Screen.VSyncTime = NS_GetNowHiPerformanceCount() ;
		Sleep( 0 ) ;
	}
}

extern int Direct3DDevice9_WaitVSync( int SyncNum )
{
	int i ;
	BOOL vsync ;

	if( WinData.ActiveFlag == FALSE )
		DxActiveWait() ;

	if( GAPIWin.DirectDraw7Object == NULL ) return -1 ;
//	if( GSYS.NotDrawFlag ) return 0 ;
	
	if( SyncNum == 0 )
	{
		vsync = FALSE ;
		while( NS_ProcessMessage() == 0 && vsync == FALSE && GAPIWin.DirectDraw7Object != NULL )
			GAPIWin.DirectDraw7Object->GetVerticalBlankStatus( &vsync ) ;
	}
	else
	{
		for( i = 0 ; i < SyncNum ; i ++ )
		{
			vsync = TRUE ;
			while( NS_ProcessMessage() == 0 && vsync == TRUE && GAPIWin.DirectDraw7Object != NULL )
			{
				GAPIWin.DirectDraw7Object->GetVerticalBlankStatus( &vsync ) ;
			}
		
	//		GAPIWin.DirectDraw7Object->WaitForVerticalBlank( DDWAITVB_BLOCKBEGIN, 0 ) ;
			vsync = FALSE ;
			while( NS_ProcessMessage() == 0 && vsync == FALSE && GAPIWin.DirectDraw7Object != NULL )
				GAPIWin.DirectDraw7Object->GetVerticalBlankStatus( &vsync ) ;
			if( NS_ProcessMessage() < 0 )
			{
				return -1 ; 
			}
		}
	}

	// I
	return 0 ;
}

extern int Direct3DDevice9_IsValid( void )
{
	return GAPIWin.Direct3DDevice9Object != NULL ? 1 : 0 ;
}

extern void *Direct3DDevice9_GetObject( void )
{
	return GAPIWin.Direct3DDevice9Object ;
}

extern int Direct3DDevice9_IsLost( void )
{
	return GAPIWin.Direct3DDevice9Object->TestCooperativeLevel() != D_D3D_OK ? 1 : 0 ;
}

extern int Direct3DDevice9_SetupTimerPresent( int EnableFlag )
{
	if( EnableFlag == FALSE )
		return 0 ;

	SetTimer( NS_GetMainWindowHandle(), SCREENFLIPTIMER_ID, 32, ScreenFlipTimerProc ) ;

	// I
	return 0 ;
}















extern long Direct3DTexture9_GetSurfaceLevel( D_IDirect3DTexture9 *pTexture, UINT Level, D_IDirect3DSurface9** ppSurfaceLevel)
{
	return pTexture->GetSurfaceLevel( Level, ppSurfaceLevel) ;
}

extern long Direct3DTexture9_LockRect( D_IDirect3DTexture9 *pTexture, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags)
{
	return pTexture->LockRect( Level, pLockedRect, pRect, Flags) ;
}

extern long Direct3DTexture9_UnlockRect( D_IDirect3DTexture9 *pTexture, UINT Level)
{
	return pTexture->UnlockRect( Level) ;
}











extern long Direct3DCubeTexture9_GetCubeMapSurface( D_IDirect3DCubeTexture9 *pCubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_IDirect3DSurface9** ppCubeMapSurface)
{
	return pCubeTexture->GetCubeMapSurface( FaceType, Level, ppCubeMapSurface ) ;
}

extern long Direct3DCubeTexture9_LockRect( D_IDirect3DCubeTexture9 *pCubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags)
{
	return pCubeTexture->LockRect( FaceType, Level, pLockedRect, pRect, Flags) ;
}

extern long Direct3DCubeTexture9_UnlockRect( D_IDirect3DCubeTexture9 *pCubeTexture, D_D3DCUBEMAP_FACES FaceType, UINT Level)
{
	return pCubeTexture->UnlockRect( FaceType, Level) ;
}













extern long Direct3DSurface9_GetDesc( D_IDirect3DSurface9 *pSurface, D_D3DSURFACE_DESC *pDesc)
{
	return pSurface->GetDesc( pDesc) ;
}

extern long Direct3DSurface9_LockRect( D_IDirect3DSurface9 *pSurface, D_D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags)
{
	return pSurface->LockRect( pLockedRect, pRect, Flags) ;
}

extern long Direct3DSurface9_UnlockRect( D_IDirect3DSurface9 *pSurface )
{
	return pSurface->UnlockRect() ;
}






extern long Direct3DVertexBuffer9_Lock( D_IDirect3DVertexBuffer9 *pVertexBuffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags )
{
	return pVertexBuffer->Lock( OffsetToLock, SizeToLock, ppbData, Flags ) ;
}

extern long Direct3DVertexBuffer9_Unlock( D_IDirect3DVertexBuffer9 *pVertexBuffer )
{
	return pVertexBuffer->Unlock() ;
}



extern long Direct3DIndexBuffer9_Lock( D_IDirect3DIndexBuffer9 *pIndexBuffer, UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags)
{
	return pIndexBuffer->Lock( OffsetToLock, SizeToLock, ppbData, Flags) ;
}

extern long Direct3DIndexBuffer9_Unlock( D_IDirect3DIndexBuffer9 *pIndexBuffer )
{
	return pIndexBuffer->Unlock() ;
}






#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE


