//-----------------------------------------------------------------------------
// 
// 		cwCu		`揈vO( Direct3D11 )
// 
//  	Ver 3.12e
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxGraphicsD3D11.h"
#include "DxGraphicsWin.h"
#include "DxMaskD3D11.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "../DxSystem.h"
#include "../DxLog.h"
#include "../DxModel.h"
#include "../DxMovie.h"
#include "../DxMask.h"
#include "../DxBaseFunc.h"
#include "../DxGraphics.h"
#include "../DxInput.h"
#include "../DxASyncLoad.h"
#include "../DxPixelShader.h"
#include "../DxVertexShader.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

// Direct3D11 gOtBbNX̍\
GRAPHICS_HARDDATA_DIRECT3D11 GraphicsHardDataDirect3D11 ;

// ֐錾 -------------------------------------------------------------------


// vO -----------------------------------------------------------------


// Direct3D11 g`֌W

// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_D3D11_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_D3D11_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_D3D11_DrawGraph( int x, int y, float xf, float yf, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_D3D11_DrawExtendGraph( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_D3D11_DrawRotaGraph( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_D3D11_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraphF
extern	int		Graphics_D3D11_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	// I
	return 0 ;
}

// QzIɔzuꂽ_f[^𒸓_obt@ɒǉ
static int SetPlaneVertexHardware( VERTEX_2D *GraphVert, int xnum, int ynum )
{
	// I
	return 0 ;
}

// eNX`ό`ĕ`悷
extern	void	Graphics_D3D11_DrawModiTex( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA_HARD_DRAW *DrawTex, bool SimpleDrawFlag )
{
}

// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_D3D11_DrawFillBox( int x1, int y1, int x2, int y2, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLineBox
extern	int		Graphics_D3D11_DrawLineBox( int x1, int y1, int x2, int y2, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_D3D11_DrawLine( int x1, int y1, int x2, int y2, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_D3D11_DrawLine3D( VECTOR Pos1, VECTOR Pos2, int Color, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}



#define CIRCLE_VERTEX_NUM			(2000)

#define DX_3D_CIRCLE_THICKNESS												\
	if( x1 < DrawRect.left      ) x1 = DrawRect.left ;						\
	if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																			\
	VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
	VectBuf[ VectNum ].pos.y  = y1f ;										\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum ++ ;															\
																			\
	VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 ) ;						\
	VectBuf[ VectNum ].pos.y =  y1f ;										\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum  ++ ;															\
																			\
	if( VectNum >= CIRCLE_VERTEX_NUM )										\
	{																		\
		/*if( GRH.UseAlphaChDrawShader )*/										\
		/*{*/																	\
		/*	for( j = 0 ; j < VectNum ; j ++ )	*/							\
		/*	{	*/															\
		/*		VectBuf[ j ].sc_u = ( VectBuf[ j ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ; */ \
		/*		VectBuf[ j ].sc_v = ( VectBuf[ j ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ; */ \
		/*	}	*/															\
		/*}*/																	\
		Direct3DDevice9_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
		VectNum = 0 ;														\
	}																		

// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_D3D11_DrawCircle_Thickness( int x, int y, int r, int Color, int Thickness )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_D3D11_DrawOval_Thickness( int x, int y, int rx, int ry, int Color, int Thickness )
{
	// I
	return 0 ;
}




#define DX_3D_CIRCLE																\
			if( !( ( x2 < DrawRect.left ) || ( x1 >= DrawRect.right  ) ||				\
			       ( y1 < DrawRect.top  ) || ( y1 >= DrawRect.bottom ) || LineDrawBuf[ y1 ] ) )			\
			{																			\
				if( x1 < DrawRect.left ) x1 = DrawRect.left ;							\
				if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																						\
				VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
				VectBuf[ VectNum ].pos.y  = ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
				LineDrawBuf[y1] = TRUE ;												\
																						\
				VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 );						\
				VectBuf[ VectNum ].pos.y =  ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum  ++ ;															\
																						\
				if( VectNum >= CIRCLE_VERTEX_NUM )										\
				{																		\
					/*if( GRH.UseAlphaChDrawShader )	*/									\
					/*{	*/																\
					/*	for( i = 0 ; i < VectNum ; i ++ )*/								\
					/*	{*/																\
					/*		VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;*/\
					/*		VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;*/\
					/*	}*/																\
					/*}*/																	\
					Direct3DDevice9_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
					VectNum = 0 ;														\
				}																		\
			}

#define DX_3D_CIRCLE_PSET															\
			if( !( ( ( unsigned int )( x1 ) >= ( unsigned int )( DrawRect.right ) ) ||	\
				( y1 < DrawRect.top ) || ( y1 >= DrawRect.bottom ) ) )					\
			{																			\
				VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
				VectBuf[ VectNum ].pos.y  = ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
																						\
				if( VectNum >= CIRCLE_VERTEX_NUM )										\
				{																		\
					/*if( GRH.UseAlphaChDrawShader )	*/									\
					/*{	*/																\
					/*	for( i = 0 ; i < VectNum ; i ++ )*/								\
					/*	{*/																\
					/*		VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;*/\
					/*		VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;*/\
					/*	}*/																\
					/*}*/																	\
					Direct3DDevice9_DrawPrimitiveUP( D_D3DPT_POINTLIST, VectNum, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
					VectNum = 0 ;														\
				}																		\
			}

// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_D3D11_DrawCircle( int x, int y, int r, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_D3D11_DrawOval( int x, int y, int rx, int ry, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_D3D11_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_D3D11_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_D3D11_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_D3D11_DrawPixel( int x, int y, int Color )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_D3D11_DrawPixel3D( VECTOR Pos, int Color, int DrawFlag, RECT *DrawArea )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_D3D11_DrawPixelSet( const POINTDATA *PointData, int Num )
{
	// I
	return 0;
}

// n[hEGAANZ[^gp DrawLineSet
extern	int		Graphics_D3D11_DrawLineSet( const LINEDATA *LineData, int Num )
{
	// I
	return 0;
}
















extern	int		Graphics_D3D11_DrawPrimitive( const VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive( const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitiveLight( const VERTEX3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight( const VERTEX3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitiveLight_UseVertexBuffer( 
	VERTEXBUFFERHANDLEDATA *VertexBuffer,
	int						PrimitiveType,
	int						StartVertex,
	int						UseVertexNum,
	IMAGEDATA *			Image,
	int						TransFlag 
)
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitiveLight_UseVertexBuffer(
	VERTEXBUFFERHANDLEDATA *	VertexBuffer,
	INDEXBUFFERHANDLEDATA *		IndexBuffer,
	int							PrimitiveType,
	int							BaseVertex,
	int							StartVertex,
	int							UseVertexNum,
	int							StartIndex,
	int							UseIndexNum,
	IMAGEDATA *				Image,
	int							TransFlag
)
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2D( VERTEX_2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive2D( VERTEX_2D *Vertex, int VertexNum, WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2DUser( const VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawPrimitive2DUser_Billboard( VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	// I
	return 0 ;
}

extern	int		Graphics_D3D11_DrawIndexedPrimitive2DUser( const VERTEX2D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	// I
	return 0 ;
}












// VF[_[`p`OZbgAbv֐
extern void Graphics_D3D11_DrawPreparationToShader( int ParamFlag, int UseVertexShaderNo, int Is2D, int UseLibSubShaderConst )
{
}


// VF[_[gĂQc|S`悷
extern	int		Graphics_D3D11_DrawPolygon2DToShader(          const VERTEX2DSHADER *Vertex, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷
extern	int		Graphics_D3D11_DrawPolygon3DToShader(          const VERTEX3DSHADER *Vertex, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂQc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPolygonIndexed2DToShader(   const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPolygonIndexed3DToShader(   const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive2DToShader(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_D3D11_DrawPrimitive3DToShader(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer(         int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	return NS_DrawPrimitive3DToShader_UseVertexBuffer2( VertexBufHandle, PrimitiveType, 0, VertexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer(  int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	return NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( VertexBufHandle, IndexBufHandle, PrimitiveType, 0, 0, VertexBuffer->Num, 0, IndexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_D3D11_DrawPrimitive3DToShader_UseVertexBuffer2(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum )
{
	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_D3D11_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum )
{
	// I
	return 0 ;
}
















// Direct3D ̃A_v^񋓂
static int EnumDirect3DAdapter()
{
	// I
	return 0 ;
}





















// ˑ֌W

// `揈̊ˑ̏s֐( sӏʂO )
extern	int		Graphics_D3D11_Initialize_Timing0_PF( void )
{
	// I
	return 0 ;
}

// `揈̊ˑ̏s֐( sӏʂQ )
extern	int		Graphics_D3D11_Initialize_Timing1_PF( void )
{
	// I
	return 0 ;
}

// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_D3D11_Hardware_Initialize_PF( void )
{
	return 0 ;
}

// `揈̊ˑ̌ns֐
extern	int		Graphics_D3D11_Terminate_PF( void )
{
	// I
	return 0 ;
}

// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern	int		Graphics_D3D11_RestoreOrChangeSetupGraphSystem_PF( int Change, int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int RefreshRate )
{
	// I
	return 0 ;
}

// `pfoCXLǂ擾( ߂l  TRUE:L  FALSE: )
extern	int		Graphics_D3D11_Hardware_CheckValid_PF( void )
{
	return 0 ;
}

// DirectX ̃IuWFNg
extern	void	Graphics_D3D11_ReleaseDirectXObject_PF( void )
{
}























// ˑ`ݒ֌W

// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_D3D11_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex )
{
	// I
	return 0 ;
}

// SetDrawBright ̈
extern	int		Graphics_Hardware_D3D11_SetDrawBrightToOneParam_PF( DWORD Bright )
{
	// I
	return 0 ;
}

// `uh[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBlendMode_PF( int BlendMode, int BlendParam )
{
	// I
	return 0 ;
}

// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_D3D11_SetDrawAlphaTest_PF( int TestMode, int TestParam )
{
	// I
	return 0 ;
}

// `惂[hZbg
extern	int		Graphics_Hardware_D3D11_SetDrawMode_PF( int DrawMode )
{
	// I
	return 0 ;
}

// `PxZbg
extern	int		Graphics_Hardware_D3D11_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright )
{
	// I
	return 0 ;
}

// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_D3D11_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param )
{
	// I
	return 0 ;
}

// őٕ̒lZbg
extern	int		Graphics_Hardware_D3D11_SetMaxAnisotropy_PF( int MaxAnisotropy )
{
	// I
	return 0 ;
}

// [hϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToWorld_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// r[ϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToView_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// eϊpsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToProjection_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// r[|[gsZbg
extern	int		Graphics_Hardware_D3D11_SetTransformToViewport_PF( const MATRIX *Matrix )
{
	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage )
{
	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage )
{
	// I
	return 0 ;
}

// eNX`WϊsZbg
extern	int		Graphics_Hardware_D3D11_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler )
{
	// I
	return 0 ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_D3D11_SetFogEnable_PF( int Flag )
{
	// I
	return 0 ;
}

// tHO[hݒ肷
extern	int		Graphics_Hardware_D3D11_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ )
{
	// I
	return 0 ;
}

// tHOJ[ύX
extern	int		Graphics_Hardware_D3D11_SetFogColor_PF( DWORD FogColor )
{
	// I
	return 0 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogStartEnd_PF( float start, float end )
{
	// I
	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_D3D11_SetFogDensity_PF( float density )
{
	// I
	return 0 ;
}

// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_D3D11_ApplyLigFogToHardware_PF( void )
{
	// I
	return 0 ;
}

// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_D3D11_SetUseOldDrawModiGraphCodeFlag_PF( int Flag )
{
	// I
	return 0 ;
}

// `ɐlނǂ̃tOXV
extern	int		Graphics_Hardware_D3D11_RefreshAlphaChDrawMode_PF( void )
{
	// I
	return 0 ;
}

























// ˑݒ֌W

// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int		Graphics_Hardware_D3D11_SetUseHardwareVertexProcessing_PF( int Flag )
{
	// I
	return 0 ;
}

// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_D3D11_SetUsePixelLighting_PF( int Flag )
{
	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_D3D11_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	// I
	return 0 ;
}

// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_Hardware_D3D11_SetUseNormalDrawShader_PF( int Flag )
{
	// I
	return 0 ;
}

// DirectDraw  Direct3D ̋x}`XbhΉɂ邩ǂZbg
extern	int		Graphics_Hardware_D3D11_SetMultiThreadFlag_PF( int Flag )
{
	// I
	return 0 ;
}

// rfI̗eʂ𓾂
extern	int		Graphics_Hardware_D3D11_GetVideoMemorySize_PF( int *AllSize, int *FreeSize )
{
	return 0 ;
}

// gp̂cRccXIuWFNg𓾂
extern	const D_IDirect3DDevice9 * Graphics_Hardware_D3D11_GetUseDirect3DDevice9_PF( void )
{
	return 0 ;
}

// gp̃obNobt@Direct3DSurface9IuWFNg擾
extern	const D_IDirect3DSurface9* Graphics_Hardware_D3D11_GetUseDirect3D11BackBufferSurface_PF( void )
{
	return 0 ;
}

// cwCûcRcݒȂ
extern	int		Graphics_Hardware_D3D11_RefreshDxLibDirect3DSetting_PF( void )
{
	// I
	return 0 ;
}

// Vistaȍ~ Windows Aero 𖳌ɂ邩ǂZbgATRUE:ɂ  FALSE:Lɂ( DxLib_Init ̑OɌĂԕKv܂ )
extern	int		Graphics_D3D11_SetAeroDisableFlag_PF( int Flag )
{
	// I
	return 0 ;
}

// ccgpftchݒ肷
extern	int		Graphics_D3D11_SetDDrawUseGuid_PF( const GUID FAR *Guid )
{
	// I
	return 0 ;
}

// L DirectDraw foCX GUID 擾
extern	const GUID *Graphics_D3D11_GetDirectDrawDeviceGUID_PF( int Number )
{
	return 0 ;
}

// L DirectDraw foCX̖O𓾂
extern	int		Graphics_D3D11_GetDirectDrawDeviceDescription_PF( int Number, char *StringBuffer )
{
	// I
	return 0 ;
}

// L DirectDraw foCX̐擾
extern	int		Graphics_D3D11_GetDirectDrawDeviceNum_PF( void )
{
	return 0 ;
}

// gp DirectDraw foCX̃CfbNXݒ肷
extern	int		Graphics_D3D11_SetUseDirectDrawDeviceIndex_PF( int Index )
{
	// I
	return 0 ;
}

// Vistaȍ~̊ Direct3D11Ex gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_D3D11_SetUseDirect3D11Ex_PF( int Flag )
{
	// I
	return 0 ;
}
































// ˑʊ֌W

// ݒɊÂĎgpyobt@Zbg
extern	int		Graphics_Hardware_D3D11_SetupUseZBuffer_PF( void )
{
	// I
	return 0 ;
}

// ʂ̂yobt@̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreenZBuffer_PF( const RECT *ClearRect )
{
	// I
	return 0 ;
}

// ʂ̏Ԃ
extern	int		Graphics_Hardware_D3D11_ClearDrawScreen_PF( const RECT *ClearRect )
{
	// I
	return 0 ;
}

// `ʂ̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap )
{
	// I
	return 0 ;
}

// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_D3D11_SetDrawScreen_Post_PF( int DrawScreen )
{
	// I
	return 0 ;
}

// `\̈̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawArea_PF( int x1, int y1, int x2, int y2 )
{
	// I
	return 0 ;
}

// `obt@bN
extern	int		Graphics_Hardware_D3D11_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo )
{
	// I
	return 0 ;
}

// `obt@AbN
extern	int		Graphics_Hardware_D3D11_UnlockDrawScreenBuffer_PF( void )
{
	// I
	return 0 ;
}

// ʂ̓e\ʂɕ`悷
extern	int		Graphics_Hardware_D3D11_ScreenCopy_PF( void )
{
	// I
	return 0 ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Begin_PF( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage )
{
	// I
	return 0 ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_D3D11_SaveDrawScreen_Post_PF( void )
{
	// I
	return 0 ;
}

// M҂
extern	int		Graphics_Hardware_D3D11_WaitVSync_PF( int SyncNum )
{
	return 0 ;
}

// ʂƕ\ʂ
extern	int		Graphics_Hardware_D3D11_ScreenFlipBase_PF( RECT *CopyRect )
{
	return 0 ;
}

// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_Hardware_D3D11_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect )
{
	return 0 ;
}

// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_D3D11_SetZBufferMode( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth )
{
	// I
	return 0 ;
}

// ʂ̃tV[A`GCAX[h̐ݒ
extern	int		Graphics_Hardware_D3D11_SetFullSceneAntiAliasingMode( int Samples, int Quality )
{
	// I
	return 0 ;
}

// `yobt@̃Zbg
extern	int		Graphics_Hardware_D3D11_SetDrawZBuffer( int DrawScreen, IMAGEDATA *Image )
{
	// I
	return 0 ;
}
























// ˑ擾֌W

// GetColor  GetColor2 ŎgpJ[f[^擾
extern const COLORDATA *Graphics_Hardware_D3D11_GetMainColorData_PF( void )
{
	return 0 ;
}

// fBXv[̃J[f[^|C^𓾂
extern	const COLORDATA *Graphics_Hardware_D3D11_GetDispColorData_PF( void )
{
	return 0 ;
}

// wW̐F擾
extern	int Graphics_Hardware_D3D11_GetPixel_PF( int x, int y )
{
	return 0 ;
}


























// ˑ摜֌W

// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_D3D11_UpdateGraphMovie_TheoraYUV_PF( MOVIEGRAPH *Movie, IMAGEDATA *Image )
{
	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP )
{
	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_D3D11_GraphUnlock_PF( IMAGEDATA *Image )
{
	// I
	return 0 ;
}

// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_D3D11_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage )
{
	// I
	return 0 ;
}

// 摜f[^̏
extern	int		Graphics_Hardware_D3D11_InitGraph_PF( void )
{
	// I
	return 0 ;
}

// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_D3D11_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread )
{
	// I
	return 0 ;
}

// `\摜obNobt@ẅ̃OtBbN擾
extern	int		Graphics_Hardware_D3D11_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY )
{
	// I
	return 0 ;
}

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_MipMapBlt(
	      IMAGEDATA_ORIG			*Orig,
	const RECT						*SrcRect,
	const RECT						*DestRect,
	      int						UseSysMemSurface,
	      D_IDirect3DBaseTexture9	*UseTex,
	      int						TexWidth,
	      int						TexHeight,
	const BASEIMAGE					*RgbBaseImage,
	const BASEIMAGE					*AlphaBaseImage,
	const COLORDATA					*DestColor,
	      int						RedIsAlphaFlag,
	      int						UseTransColorConvAlpha,
	      int						ASyncThread
)
{
	// I
	return 0 ;
}

static int Graphics_D3D11_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
	      IMAGEDATA_ORIG			*Orig,
	const RECT						*SrcRect,
	const RECT						*DestRect,
	      int						UseSysMemSurface,
	      D_IDirect3DBaseTexture9	*UseTex,
	      int						TexWidth,
	      int						TexHeight,
	      int						TexUseWidth,
	      int						TexUseHeight,
	const BASEIMAGE					*RgbBaseImage,
	const BASEIMAGE					*AlphaBaseImage,
	const COLORDATA					*DestColor,
	      int						RedIsAlphaFlag,
	      int						UseTransColorConvAlpha,
	      int						ASyncThread
)
{
	// I
	return 0 ;
}

// Direct3D11 ̃OtBbNnhɉ摜f[^]邽߂̊֐
extern	int		Graphics_Hardware_D3D11_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
)
{
	return -1 ;
}

// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern	int		Graphics_Hardware_D3D11_CreateOrigTexture_PF(  IMAGEDATA_ORIG *Orig, int ASyncThread )
{
	// I
	return 0 ;
}

// IWi摜񒆂̃eNX`
extern	int		Graphics_Hardware_D3D11_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig )
{
	// I
	return 0 ;
}

// w̃}`TvŎgpłőNIeBl擾
extern	int		Graphics_Hardware_D3D11_GetMultiSampleQuality_PF( int Samples )
{
	return 0 ;
}




























// ˑ_obt@ECfbNXobt@֌W

// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Create_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int VertexSize, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	// I
	return 0 ;
}

// _obt@nȟn
extern	int		Graphics_Hardware_D3D11_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer )
{
	// I
	return 0 ;
}

// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_D3D11_VertexBuffer_SetData_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum )
{
	// I
	return 0 ;
}

// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Create_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int IndexSize, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ )
{
	// I
	return 0 ;
}

// CfbNXobt@nȟn
extern	int		Graphics_Hardware_D3D11_IndexBuffer_Terminate_PF( INDEXBUFFERHANDLEDATA *IndexBuffer )
{
	// I
	return 0 ;
}

// CfbNXobt@ɃCfbNXf[^]
extern	int		Graphics_Hardware_D3D11_IndexBuffer_SetData_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum )
{
	// I
	return 0 ;
}























// ˑCg֌W

// CeBOsǂݒ肷
extern	int		Graphics_Hardware_D3D11_Light_SetUse_PF( int Flag )
{
	return 0 ;
}

// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_D3D11_Light_GlobalAmbient_PF( COLOR_F *Color )
{
	return 0 ;
}

// Cgp[^Zbg
extern	int		Graphics_Hardware_D3D11_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam )
{
	return 0 ;
}

// Cg̗LAύX
extern	int		Graphics_Hardware_D3D11_Light_SetEnable_PF( int LightNumber, int EnableState )
{
	return 0 ;
}




























// ˑVhE}bv֌W

// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_D3D11_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread )
{
	// I
	return 0 ;
}

// VhE}bvf[^ɕKvȃeNX`
extern	int		Graphics_Hardware_D3D11_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshVSParam_PF( void )
{
}

// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_D3D11_ShadowMap_RefreshPSParam_PF( void )
{
}

// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// VhE}bvւ̕`I
extern	int		Graphics_Hardware_D3D11_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}

// `ŎgpVhE}bvw肷( Xbg͂OPw\ )
extern	int		Graphics_Hardware_D3D11_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap )
{
	// I
	return 0 ;
}































// ˑVF[_[֌W

// VF[_[nh
extern	int		Graphics_Hardware_D3D11_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread )
{
	// I
	return 0 ;
}

// VF[_[nȟn
extern	int		Graphics_Hardware_D3D11_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader )
{
	// I
	return 0 ;
}

// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_D3D11_Shader_GetValidShaderVersion_PF( void )
{
	return 0 ;
}

// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstIndex_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// w̖O萔gpVF[_[萔̐擾
extern	int		Graphics_Hardware_D3D11_Shader_GetConstCount_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	const FLOAT4 *Graphics_Hardware_D3D11_Shader_GetConstDefaultParamF_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return 0 ;
}

// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_D3D11_Shader_SetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea )
{
	// I
	return 0 ;
}

// ẅ̃VF[_[萔Zbg
extern	int		Graphics_Hardware_D3D11_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum )
{
	// I
	return 0 ;
}

// Rcfp̃VF[_[R[h̏s
extern	int		Graphics_Hardware_D3D11_Shader_ModelCode_Init_PF( void )
{
	// I
	return 0 ;
}




































// ˑ`֌W

// w_狫EFƂ܂œhԂ
extern	int		Graphics_Hardware_D3D11_Paint_PF( int x, int y, int FillColor, int BoundaryColor )
{
	// I
	return 0 ;
}


























#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE




