//-----------------------------------------------------------------------------
// 
// 		cwCu		WindowsOSp`揈vO
// 
//  	Ver 3.12e
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxGraphicsWin.h"
#include "DxGraphicsD3D9.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "../DxSystem.h"
#include "../DxLog.h"
#include "../DxModel.h"
#include "../DxBaseFunc.h"
#include "../DxGraphics.h"
#include "../DxASyncLoad.h"
#include "../DxPixelShader.h"
#include "../DxMask.h"
#include "../DxInput.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

static int UseGDIFlag ;							// GDI gp邩ǂ

GRAPHICSMANAGE_WIN GraphicsManage_Win ; 

// ֐錾 -------------------------------------------------------------------

// vO -----------------------------------------------------------------

// DirectX ̃IuWFNg
extern void Graphics_ReleaseDirectXObject( void )
{
	Graphics_D3D9_ReleaseDirectXObject_PF() ;
}

// bZ[W[vɍsׂs
extern void Graphics_Win_MessageLoop_Process_PF( void )
{
	// ǗeNX`ւ̓]p̃VXeeNX`̒s
	Graphics_D3D9_SysMemTextureProcess() ;

	// ǗeNX`ւ̓]p̃VXeT[tFX̒s
	Graphics_D3D9_SysMemSurfaceProcess() ;
}


// ʂ̓ew̃EChEɓ]
extern int NS_BltBackScreenToWindow( HWND Window, int ClientX, int ClientY )
{
	RECT SrcRect, DestRect, WinRect ;

	GetClientRect( Window, &WinRect ) ;

	SrcRect.left   = 0 ;
	SrcRect.top    = 0 ;
	SrcRect.right  = GSYS.Screen.MainScreenSizeX ;
	SrcRect.bottom = GSYS.Screen.MainScreenSizeY ;

	DestRect.left   = WinRect.left + ClientX ;
	DestRect.top    = WinRect.top  + ClientY ;
	DestRect.right  = WinRect.left + ClientX + GSYS.Screen.MainScreenSizeX ;
	DestRect.bottom = WinRect.top  + ClientY + GSYS.Screen.MainScreenSizeY ;

	if( DestRect.left < WinRect.left )
	{
		SrcRect.left += WinRect.left - DestRect.left ;
		DestRect.left = WinRect.left ;
	}

	if( DestRect.top < WinRect.top )
	{
		SrcRect.top += WinRect.top - DestRect.top ;
		DestRect.top = WinRect.top ;
	}

	if( DestRect.right > WinRect.right )
	{
		SrcRect.right -= DestRect.right - WinRect.right ;
		DestRect.right = WinRect.right ;
	}

	if( DestRect.bottom > WinRect.bottom )
	{
		SrcRect.bottom -= DestRect.bottom - WinRect.bottom ;
		DestRect.bottom = WinRect.bottom ;
	}

	return NS_BltRectBackScreenToWindow( Window, SrcRect, DestRect ) ;
}

// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern int NS_BltRectBackScreenToWindow( HWND Window, RECT BackScreenRect, RECT WindowClientRect )
{
	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE || DxLib_GetEndRequest() ) return -1 ;

	// tXN[[hł͎gpłȂ
	if( NS_GetWindowModeFlag() == FALSE ) return -1 ;

	// s
	return Graphics_BltRectBackScreenToWindow_PF( Window, BackScreenRect, WindowClientRect ) ;
}

// gp DirectDraw foCX̃CfbNXݒ肷
extern int NS_SetUseDirectDrawDeviceIndex( int Index )
{
	return Graphics_D3D9_SetUseDirectDrawDeviceIndex_PF( Index ) ;
}

// DirectDraw  Direct3D ̋x}`XbhΉɂ邩ǂZbg
extern	int		NS_SetMultiThreadFlag( int Flag )
{
	return Graphics_Hardware_D3D9_SetMultiThreadFlag_PF( Flag ) ;
}

// Vistaȍ~ Windows Aero 𖳌ɂ邩ǂZbgATRUE:ɂ  FALSE:Lɂ( DxLib_Init ̑OɌĂԕKv܂ )
extern int NS_SetAeroDisableFlag( int Flag )
{
	return Graphics_SetAeroDisableFlag_PF( Flag ) ;
}

// Vistaȍ~̊ Direct3D9Ex gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern int NS_SetUseDirect3D9Ex( int Flag )
{
	return Graphics_D3D9_SetUseDirect3D9Ex_PF( Flag ) ;
}

// ccgp邩ǂZbg
extern int NS_SetUseDirectDrawFlag( int Flag )
{
	// Ôݎgp\
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GSYS.Setting.NotUseHardware = !Flag ;

	// I
	return 0 ;
}

// fch`KvƂ邩AύX
extern	int		NS_SetUseGDIFlag( int Flag )
{
	// tOۑ
	UseGDIFlag = Flag ;

	// n[hEGAgpĂ邩ǂŏ𕪊
	if( GSYS.Setting.ValidHardware )
	{
		// n[hEGA_O[h̏ꍇ
		if( Direct3DDevice9_IsValid() == 0 ) return 0 ;

		// foCX̐ݒ
		if( Flag == FALSE )
		{
			Direct3DDevice9_SetDialogBoxMode( FALSE ) ;
		}
		else
		{
			Direct3DDevice9_SetDialogBoxMode( FALSE ) ;
			Direct3DDevice9_SetDialogBoxMode( TRUE ) ;
		}
	}
	else
	{
		// \tgEGA_O[hł͓ɂ邱Ɩ
	}

	// I
	return 0 ;
}

// fch`KvƂ邩̏Ԃ擾
extern int NS_GetUseGDIFlag( void )
{
	return UseGDIFlag ;
}

// ccgpftchݒ肷
extern	int		NS_SetDDrawUseGuid( const GUID FAR *Guid )
{
	return Graphics_D3D9_SetDDrawUseGuid_PF( Guid ) ;
}

/*߂l IDirectDraw7 * ɃLXgĉ*/			// ݎgpĂccIuWFNg̃AhX擾
extern	const void *NS_GetUseDDrawObj( void )
{
	// I
	return DirectDraw7_GetObject() ;
}

// L DirectDraw foCX GUID 擾
extern	const GUID *				NS_GetDirectDrawDeviceGUID( int Number )
{
	return Graphics_D3D9_GetDirectDrawDeviceGUID_PF( Number ) ;
}

// L DirectDraw foCX̖O𓾂
extern	int						NS_GetDirectDrawDeviceDescription( int Number, char *StringBuffer )
{
	return Graphics_D3D9_GetDirectDrawDeviceDescription_PF( Number, StringBuffer ) ;
}

// L DirectDraw foCX̐擾
extern	int						NS_GetDirectDrawDeviceNum( void )
{
	return Graphics_D3D9_GetDirectDrawDeviceNum_PF() ;
}

// gp̂cRccXIuWFNg𓾂
extern	const D_IDirect3DDevice9* NS_GetUseDirect3DDevice9( void )
{
	return Graphics_Hardware_D3D9_GetUseDirect3DDevice9_PF(  ) ;
}

// gp̃obNobt@Direct3DSurface9IuWFNg擾
extern const D_IDirect3DSurface9* NS_GetUseDirect3D9BackBufferSurface( void )
{
	return Graphics_Hardware_D3D9_GetUseDirect3D9BackBufferSurface_PF(  ) ;
}

// cwCûcRcݒȂ
extern int NS_RefreshDxLibDirect3DSetting( void )
{
	return Graphics_Hardware_D3D9_RefreshDxLibDirect3DSetting_PF(  ) ;
}























// ˑ֌W

// `揈̊ˑ̏s֐( sӏʂO )
extern int Graphics_Initialize_Timing0_PF( void )
{
	if( Graphics_D3D9_Initialize_Timing0_PF() < 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// `揈̊ˑ̏s֐( sӏʂP )
extern int Graphics_Initialize_Timing1_PF( void )
{
	if( Graphics_D3D9_Initialize_Timing1_PF() < 0 )
	{
		return -1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gpꍇ̊ˑ̏s
extern	int		Graphics_Hardware_Initialize_PF( void )
{
	return Graphics_D3D9_Hardware_Initialize_PF() ;
}

// `揈̊ˑ̌ns֐
extern	int		Graphics_Terminate_PF( void )
{
	return Graphics_D3D9_Terminate_PF() ;
}

// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
extern int Graphics_RestoreOrChangeSetupGraphSystem_PF(
	int Change,
	int ScreenSizeX,
	int ScreenSizeY,
	int ColorBitDepth,
	int RefreshRate
)
{
	return Graphics_D3D9_RestoreOrChangeSetupGraphSystem_PF( Change, ScreenSizeX, ScreenSizeY, ColorBitDepth, RefreshRate ) ;
}

// `pfoCXLǂ擾
extern int Graphics_Hardware_CheckValid_PF( void )
{
	return Graphics_D3D9_Hardware_CheckValid_PF() ;
}



























// ˑ`ݒ֌W

// VF[_[`ł̕`ݒ肷
extern	int		Graphics_Hardware_SetRenderTargetToShader_PF( int TargetIndex, int DrawScreen, int SurfaceIndex )
{
	return Graphics_Hardware_D3D9_SetRenderTargetToShader_PF(  TargetIndex,  DrawScreen,  SurfaceIndex ) ;
}

// SetDrawBright ̈
extern	int		Graphics_Hardware_SetDrawBrightToOneParam_PF( DWORD Bright )
{
	return Graphics_Hardware_D3D9_SetDrawBrightToOneParam_PF( Bright ) ;
}

// `uh[hZbg
extern	int		Graphics_Hardware_SetDrawBlendMode_PF( int BlendMode, int BlendParam )
{
	return Graphics_Hardware_D3D9_SetDrawBlendMode_PF(  BlendMode,  BlendParam ) ;
}

// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int		Graphics_Hardware_SetDrawAlphaTest_PF( int TestMode, int TestParam )
{
	return Graphics_Hardware_D3D9_SetDrawAlphaTest_PF(  TestMode,  TestParam ) ;
}

// `惂[hZbg
extern	int		Graphics_Hardware_SetDrawMode_PF( int DrawMode )
{
	return Graphics_Hardware_D3D9_SetDrawMode_PF(  DrawMode ) ;
}

// `PxZbg
extern	int		Graphics_Hardware_SetDrawBright_PF( int RedBright, int GreenBright, int BlueBright )
{
	return Graphics_Hardware_D3D9_SetDrawBright_PF(  RedBright,  GreenBright,  BlueBright ) ;
}

// SetBlendGraphParam ̉ϒp[^t
extern	int		Graphics_Hardware_SetBlendGraphParamBase_PF( IMAGEDATA *BlendImage, int BlendType, int *Param )
{
	return Graphics_Hardware_D3D9_SetBlendGraphParamBase_PF(  BlendImage,  BlendType, Param ) ;
}

// őٕ̒lZbg
extern	int		Graphics_Hardware_SetMaxAnisotropy_PF( int MaxAnisotropy )
{
	return Graphics_Hardware_D3D9_SetMaxAnisotropy_PF(  MaxAnisotropy ) ;
}

// [hϊpsZbg
extern	int		Graphics_Hardware_SetTransformToWorld_PF( const MATRIX *Matrix )
{
	return Graphics_Hardware_D3D9_SetTransformToWorld_PF( Matrix ) ;
}

// r[ϊpsZbg
extern	int		Graphics_Hardware_SetTransformToView_PF( const MATRIX *Matrix )
{
	return Graphics_Hardware_D3D9_SetTransformToView_PF( Matrix ) ;
}

// eϊpsZbg
extern	int		Graphics_Hardware_SetTransformToProjection_PF( const MATRIX *Matrix )
{
	return Graphics_Hardware_D3D9_SetTransformToProjection_PF( Matrix ) ;
}

// r[|[gsZbg
extern	int		Graphics_Hardware_SetTransformToViewport_PF( const MATRIX *Matrix )
{
	return Graphics_Hardware_D3D9_SetTransformToViewport_PF( Matrix ) ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_SetTextureAddressMode_PF( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage )
{
	return Graphics_Hardware_D3D9_SetTextureAddressMode_PF( Mode /* DX_TEXADDRESS_WRAP  */,  Stage ) ;
}

// eNX`AhX[hݒ肷
extern	int		Graphics_Hardware_SetTextureAddressModeUV_PF( int ModeU, int ModeV, int Stage )
{
	return Graphics_Hardware_D3D9_SetTextureAddressModeUV_PF(  ModeU,  ModeV,  Stage ) ;
}

// eNX`WϊsZbg
extern	int		Graphics_Hardware_SetTextureAddressTransformMatrix_PF( int UseFlag, MATRIX *Matrix, int Sampler )
{
	return Graphics_Hardware_D3D9_SetTextureAddressTransformMatrix_PF( UseFlag, Matrix, Sampler ) ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Hardware_SetFogEnable_PF( int Flag )
{
	return Graphics_Hardware_D3D9_SetFogEnable_PF(  Flag ) ;
}

// tHO[hݒ肷
extern	int		Graphics_Hardware_SetFogMode_PF( int Mode /* DX_FOGMODE_NONE  */ )
{
	return Graphics_Hardware_D3D9_SetFogMode_PF(  Mode /* DX_FOGMODE_NONE  */ ) ;
}

// tHOJ[ύX
extern	int		Graphics_Hardware_SetFogColor_PF( DWORD FogColor )
{
	return Graphics_Hardware_D3D9_SetFogColor_PF( FogColor ) ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_SetFogStartEnd_PF( float start, float end )
{
	return Graphics_Hardware_D3D9_SetFogStartEnd_PF(  start,  end ) ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Hardware_SetFogDensity_PF( float density )
{
	return Graphics_Hardware_D3D9_SetFogDensity_PF(  density ) ;
}

// [hϊpsZbg
extern	int		Graphics_Hardware_DeviceDirect_SetWorldMatrix_PF( const MATRIX *Matrix )
{
	return Graphics_D3D9_DeviceState_SetWorldMatrix( Matrix ) ;
}

// r[ϊpsZbg
extern	int		Graphics_Hardware_DeviceDirect_SetViewMatrix_PF( const MATRIX *Matrix )
{
	return Graphics_D3D9_DeviceState_SetViewMatrix( Matrix ) ;
}

// eϊpsZbg
extern	int		Graphics_Hardware_DeviceDirect_SetProjectionMatrix_PF( const MATRIX *Matrix )
{
	return Graphics_D3D9_DeviceState_SetProjectionMatrix( Matrix ) ;
}

// {f[^ɐݒ肳ĂtHOn[hEFAɔf
extern	int		Graphics_Hardware_ApplyLigFogToHardware_PF( void )
{
	return Graphics_Hardware_D3D9_ApplyLigFogToHardware_PF( ) ;
}

// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern	int		Graphics_Hardware_SetUseOldDrawModiGraphCodeFlag_PF( int Flag )
{
	return Graphics_Hardware_D3D9_SetUseOldDrawModiGraphCodeFlag_PF( Flag ) ;
}

// `ɐlނǂ̃tOXV
extern	int		Graphics_Hardware_RefreshAlphaChDrawMode_PF( void )
{
	return Graphics_Hardware_D3D9_RefreshAlphaChDrawMode_PF() ;
}























// ˑݒ֌W

// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int		Graphics_Hardware_SetUseHardwareVertexProcessing_PF( int Flag )
{
	return Graphics_Hardware_D3D9_SetUseHardwareVertexProcessing_PF( Flag ) ;
}

// sNZPʂŃCeBOsǂݒ肷Av ShaderModel 3.0( TRUE:sNZPʂ̃CeBOs  FALSE:_Pʂ̃CeBOs( ftHg ) )
extern	int		Graphics_Hardware_SetUsePixelLighting_PF( int Flag )
{
	return Graphics_Hardware_D3D9_SetUsePixelLighting_PF( Flag ) ;
}

// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_SetGraphicsDeviceRestoreCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	return Graphics_Hardware_D3D9_SetGraphicsDeviceRestoreCallbackFunction_PF( Callback, CallbackData ) ;
}

// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern	int		Graphics_Hardware_SetGraphicsDeviceLostCallbackFunction_PF( void (* Callback )( void *Data ), void *CallbackData )
{
	return Graphics_Hardware_D3D9_SetGraphicsDeviceLostCallbackFunction_PF( Callback, CallbackData ) ;
}

// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		Graphics_Hardware_SetUseNormalDrawShader_PF( int Flag )
{
	return Graphics_Hardware_D3D9_SetUseNormalDrawShader_PF( Flag ) ;
}

// rfI̗eʂ𓾂
extern	int		Graphics_Hardware_GetVideoMemorySize_PF( int *AllSize, int *FreeSize )
{
	return Graphics_Hardware_D3D9_GetVideoMemorySize_PF( AllSize, FreeSize ) ;
}

// Vistaȍ~ Windows Aero 𖳌ɂ邩ǂZbgATRUE:ɂ  FALSE:Lɂ( DxLib_Init ̑OɌĂԕKv܂ )
extern	int		Graphics_SetAeroDisableFlag_PF( int Flag )
{
	return Graphics_D3D9_SetAeroDisableFlag_PF( Flag ) ;
}























// ˑʊ֌W

// ݒɊÂĎgpyobt@Zbg
extern	int		Graphics_Hardware_SetupUseZBuffer_PF( void )
{
	return Graphics_Hardware_D3D9_SetupUseZBuffer_PF() ;
}

// ʂ̂yobt@̏Ԃ
extern	int		Graphics_Hardware_ClearDrawScreenZBuffer_PF( const RECT *ClearRect )
{
	return Graphics_Hardware_D3D9_ClearDrawScreenZBuffer_PF( ClearRect ) ;
}

// ʂ̏Ԃ
extern	int		Graphics_Hardware_ClearDrawScreen_PF( const RECT *ClearRect )
{
	return Graphics_Hardware_D3D9_ClearDrawScreen_PF( ClearRect ) ;
}

// `ʂ̃Zbg
extern	int		Graphics_Hardware_SetDrawScreen_PF( int DrawScreen, int OldScreenSurface, IMAGEDATA *NewTargetImage, IMAGEDATA *OldTargetImage, SHADOWMAPDATA *NewTargetShadowMap, SHADOWMAPDATA *OldTargetShadowMap )
{
	return Graphics_Hardware_D3D9_SetDrawScreen_PF(  DrawScreen,  OldScreenSurface, NewTargetImage, OldTargetImage, NewTargetShadowMap, OldTargetShadowMap ) ;
}

// SetDrawScreen ̍ŌŌĂ΂֐
extern	int		Graphics_Hardware_SetDrawScreen_Post_PF( int DrawScreen )
{
	return Graphics_Hardware_D3D9_SetDrawScreen_Post_PF(  DrawScreen ) ;
}

// `\̈̃Zbg
extern	int		Graphics_Hardware_SetDrawArea_PF( int x1, int y1, int x2, int y2 )
{
	return Graphics_Hardware_D3D9_SetDrawArea_PF(  x1,  y1,  x2,  y2 ) ;
}

// `obt@bN
extern	int		Graphics_Hardware_LockDrawScreenBuffer_PF( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, IMAGEDATA *TargetImage, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo )
{
	return Graphics_Hardware_D3D9_LockDrawScreenBuffer_PF( LockRect, BaseImage,  TargetScreen, TargetImage, TargetScreenSurface,  ReadOnly,  TargetScreenTextureNo ) ;
}

// `obt@AbN
extern	int		Graphics_Hardware_UnlockDrawScreenBuffer_PF( void )
{
	return Graphics_Hardware_D3D9_UnlockDrawScreenBuffer_PF() ;
}

// ʂ̓e\ʂɕ`悷
extern	int		Graphics_Hardware_ScreenCopy_PF( void )
{
	return Graphics_Hardware_D3D9_ScreenCopy_PF() ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_SaveDrawScreen_Begin_PF( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage )
{
	return Graphics_Hardware_D3D9_SaveDrawScreen_Begin_PF(  x1,  y1,  x2,  y2, BaseImage ) ;
}

// ݕ`ΏۂɂȂĂʂۑ
extern	int		Graphics_Hardware_SaveDrawScreen_Post_PF( void )
{
	return Graphics_Hardware_D3D9_SaveDrawScreen_Post_PF() ;
}

// fBXvC[hf[^̏ZbgAbv
extern	void	Graphics_SetupDisplayModeData_PF( int *Num, DISPLAYMODEDATA **Buffer )
{
	int i, ModeNum ;
	DEVMODE DevMode ;
	DISPLAYMODEDATA *Disp ;

	// ɃmۂĂ
	if( *Buffer )
	{
		HeapFree( GetProcessHeap(), 0, *Buffer ) ;
		*Buffer = NULL ;
	}

	// 𐔂
	*Num = 0 ;
	ModeNum = 0 ;
	for( ModeNum ;  ; ModeNum ++ )
	{
		_MEMSET( &DevMode, 0, sizeof( DevMode ) ) ;
		if( EnumDisplaySettings( NULL, ModeNum, &DevMode ) == 0 ) break ;

		// 16bit ȉ̃[h͏O
		if( DevMode.dmBitsPerPel >= 16 )
		{
			( *Num ) ++ ;
		}
	}

	// i[郁̈̊m
	*Buffer = ( DISPLAYMODEDATA * )HeapAlloc( GetProcessHeap(), 0, sizeof( DISPLAYMODEDATA ) * *Num ) ;
	if( *Buffer == NULL )
	{
		*Num = 0 ;
		return ;
	}

	// 擾
	Disp = *Buffer ;
	for( i = 0 ; i < ModeNum ; i ++ )
	{
		_MEMSET( &DevMode, 0, sizeof( DevMode ) ) ;
		EnumDisplaySettings( NULL, i, &DevMode ) ;
		if( DevMode.dmBitsPerPel >= 16 )
		{
			Disp->Width         = DevMode.dmPelsWidth ;
			Disp->Height        = DevMode.dmPelsHeight ;
			Disp->ColorBitDepth = DevMode.dmBitsPerPel ;
			Disp->RefreshRate   = DevMode.dmDisplayFrequency ;
			Disp ++ ;
		}
	}
}

// M҂
extern	int		Graphics_Hardware_WaitVSync_PF( int SyncNum )
{
	return Graphics_Hardware_D3D9_WaitVSync_PF( SyncNum ) ;
}

// ʂƕ\ʂ
extern	int		Graphics_ScreenFlipBase_PF( void )
{
	return Graphics_Hardware_D3D9_ScreenFlipBase_PF() ;
}

// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern	int		Graphics_BltRectBackScreenToWindow_PF( HWND Window, RECT BackScreenRect, RECT WindowClientRect )
{
	return Graphics_Hardware_D3D9_BltRectBackScreenToWindow_PF(  Window, BackScreenRect, WindowClientRect ) ;
}

// Cʂ̂yobt@̐ݒύX
extern	int		Graphics_Hardware_SetZBufferMode( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth )
{
	return Graphics_Hardware_D3D9_SetZBufferMode(  ZBufferSizeX,  ZBufferSizeY,  ZBufferBitDepth ) ;
}

// ʂ̃tV[A`GCAX[h̐ݒ
extern	int		Graphics_Hardware_SetFullSceneAntiAliasingMode( int Samples, int Quality )
{
	return Graphics_Hardware_D3D9_SetFullSceneAntiAliasingMode(  Samples,  Quality ) ;
}

// `yobt@̃Zbg
extern	int		Graphics_Hardware_SetDrawZBuffer( int DrawScreen, IMAGEDATA *Image )
{
	return Graphics_Hardware_D3D9_SetDrawZBuffer( DrawScreen, Image ) ;
}

// ݂̉ʂ̃tbV[g擾
extern	int		Graphics_GetRefreshRate_PF( void )
{
	int RefreshRate = -1 ;

	// tbV[g̎擾
	if( WinData.WindowsVersion >= DX_WINDOWSVERSION_NT31 )
	{
		HDC hdc ;
		
		hdc = GetDC( NS_GetMainWindowHandle() ) ;
		if( hdc )
		{
			RefreshRate = GetDeviceCaps( hdc, VREFRESH ) ;
			ReleaseDC( NS_GetMainWindowHandle(), hdc ) ;

			if( RefreshRate < 50 ) RefreshRate = -1 ;
		}
	}

	return RefreshRate ;
}






















// ˑ擾֌W

// GetColor  GetColor2 ŎgpJ[f[^擾
extern	const COLORDATA *	Graphics_Hardware_GetMainColorData_PF( void )
{
	return Graphics_Hardware_D3D9_GetMainColorData_PF(  ) ;
}

// fBXv[̃J[f[^|C^𓾂
extern	const COLORDATA *	Graphics_Hardware_GetDispColorData_PF( void )
{
	return Graphics_Hardware_D3D9_GetDispColorData_PF(  ) ;
}

// wW̐F擾
extern	int					Graphics_Hardware_GetPixel_PF( int x, int y )
{
	return Graphics_Hardware_D3D9_GetPixel_PF(  x,  y ) ;
}


























// ˑ摜֌W

// YUVT[tFXg Theora ̓eOtBbNXnh̃eNX`ɓ]
extern	int		Graphics_Hardware_UpdateGraphMovie_TheoraYUV_PF( MOVIEGRAPH *Movie, IMAGEDATA *Image )
{
	return Graphics_Hardware_D3D9_UpdateGraphMovie_TheoraYUV_PF( Movie, Image ) ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_GraphLock_PF( IMAGEDATA *Image, COLORDATA **ColorDataP )
{
	return Graphics_Hardware_D3D9_GraphLock_PF( Image, ColorDataP ) ;
}

// OtBbN̈̃bN
extern	int		Graphics_Hardware_GraphUnlock_PF( IMAGEDATA *Image )
{
	return Graphics_Hardware_D3D9_GraphUnlock_PF( Image ) ;
}

// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern	int		Graphics_Hardware_CopyGraphZBufferImage_PF( IMAGEDATA *DestImage, IMAGEDATA *SrcImage )
{
	return Graphics_Hardware_D3D9_CopyGraphZBufferImage_PF( DestImage, SrcImage ) ;
}

// 摜f[^̏
extern	int		Graphics_Hardware_InitGraph_PF( void )
{
	return Graphics_Hardware_D3D9_InitGraph_PF( ) ;
}

// OtBbN̐FœhԂ
extern	int		Graphics_Hardware_FillGraph_PF( IMAGEDATA *Image, int Red, int Green, int Blue, int Alpha, int ASyncThread )
{
	return Graphics_Hardware_D3D9_FillGraph_PF( Image,  Red,  Green,  Blue,  Alpha,  ASyncThread ) ;
}

// `\摜obNobt@ẅ̃OtBbN擾
extern	int		Graphics_Hardware_GetDrawScreenGraphBase_PF( IMAGEDATA *Image, IMAGEDATA *TargetImage, int TargetScreen, int TargetScreenSurface, int TargetScreenWidth, int TargetScreenHeight, int x1, int y1, int x2, int y2, int destX, int destY )
{
	return Graphics_Hardware_D3D9_GetDrawScreenGraphBase_PF( Image, TargetImage,  TargetScreen,  TargetScreenSurface,  TargetScreenWidth,  TargetScreenHeight,  x1,  y1,  x2,  y2,  destX,  destY ) ;
}

// Graphics_Image_BltBmpOrBaseImageToGraph3 ̋@ˑp֐
extern int Graphics_Hardware_BltBmpOrBaseImageToGraph3_PF(
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	const BASEIMAGE	*RgbBaseImage,
	const BASEIMAGE	*AlphaBaseImage,
	      int		RedIsAlphaFlag,
	      int		UseTransColorConvAlpha,
	      int		TargetOrig,
	      int		ASyncThread
)
{
	return Graphics_Hardware_D3D9_BltBmpOrBaseImageToGraph3_PF(
		SrcRect,
		DestX,
		DestY,
		GrHandle,
		RgbBaseImage,
		AlphaBaseImage,
		RedIsAlphaFlag,
		UseTransColorConvAlpha,
		TargetOrig,
		ASyncThread
	);
}

// {C[W̃tH[}bg DX_BASEIMAGE_FORMAT_NORMAL ɕϊKv邩ǂ`FbN
// ( RequiredRgbBaseImageConvFlag  RequiredAlphaBaseImageConvFlag ɓl  TRUE:ϊKv  FALSE:ϊKv͖ )
extern	int		Graphics_CheckRequiredNormalImageConv_BaseImageFormat_PF(
	IMAGEDATA_ORIG *Orig,
	int             RgbBaseImageFormat,
	int            *RequiredRgbBaseImageConvFlag,
	int             AlphaBaseImageFormat,
	int            *RequiredAlphaBaseImageConvFlag
)
{
	return Graphics_D3D9_CheckRequiredNormalImageConv_BaseImageFormat_PF(
		Orig,
		RgbBaseImageFormat,
		RequiredRgbBaseImageConvFlag,
		AlphaBaseImageFormat,
		RequiredAlphaBaseImageConvFlag
	) ;
}

// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
extern int Graphics_Hardware_CreateOrigTexture_PF( IMAGEDATA_ORIG *Orig, int ASyncThread )
{
	return Graphics_Hardware_D3D9_CreateOrigTexture_PF( Orig, ASyncThread ) ;
}

// IWi摜񒆂̃eNX`
extern int Graphics_Hardware_ReleaseOrigTexture_PF( IMAGEDATA_ORIG *Orig )
{
	return Graphics_Hardware_D3D9_ReleaseOrigTexture_PF( Orig ) ;
}

// w̃}`TvŎgpłőNIeBl擾
extern int Graphics_Hardware_GetMultiSampleQuality_PF( int Samples )
{
	return Graphics_Hardware_D3D9_GetMultiSampleQuality_PF( Samples ) ;
}
























// ˑ_obt@ECfbNXobt@֌W

// _obt@nh̒_obt@쐬
extern	int		Graphics_Hardware_VertexBuffer_Create_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int VertexSize, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	return Graphics_Hardware_D3D9_VertexBuffer_Create_PF( VertexBuffer,  VertexSize,  VertexNum,  VertexType ) ;
}

// _obt@nȟn
extern	int		Graphics_Hardware_VertexBuffer_Terminate_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer )
{
	return Graphics_Hardware_D3D9_VertexBuffer_Terminate_PF( VertexBuffer ) ;
}

// _obt@ɒ_f[^]
extern	int		Graphics_Hardware_VertexBuffer_SetData_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, int SetIndex, const void *VertexData, int VertexNum )
{
	return Graphics_Hardware_D3D9_VertexBuffer_SetData_PF( VertexBuffer, SetIndex, VertexData, VertexNum ) ;
}

// CfbNXobt@nh̃ZbgAbvs
extern	int		Graphics_Hardware_IndexBuffer_Create_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int IndexSize, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ )
{
	return Graphics_Hardware_D3D9_IndexBuffer_Create_PF( IndexBuffer, IndexSize,  IndexNum,  IndexType /* DX_INDEX_TYPE_16BIT  */ ) ;
}

// CfbNXobt@nȟn
extern	int		Graphics_Hardware_IndexBuffer_Terminate_PF( INDEXBUFFERHANDLEDATA *IndexBuffer )
{
	return Graphics_Hardware_D3D9_IndexBuffer_Terminate_PF( IndexBuffer ) ;
}

// CfbNXobt@ɃCfbNXf[^]
extern	int		Graphics_Hardware_IndexBuffer_SetData_PF( INDEXBUFFERHANDLEDATA *IndexBuffer, int SetIndex, const void *IndexData, int IndexNum )
{
	return Graphics_Hardware_D3D9_IndexBuffer_SetData_PF( IndexBuffer,  SetIndex, IndexData,  IndexNum ) ;
}





















// ˑCg֌W

// CeBOsǂݒ肷
extern	int		Graphics_Hardware_Light_SetUse_PF( int Flag )
{
	return Graphics_Hardware_D3D9_Light_SetUse_PF( Flag ) ;
}

// O[oArGgCgJ[ݒ肷
extern	int		Graphics_Hardware_Light_GlobalAmbient_PF( COLOR_F *Color )
{
	return Graphics_Hardware_D3D9_Light_GlobalAmbient_PF( Color ) ;
}

// Cgp[^Zbg
extern	int		Graphics_Hardware_Light_SetState_PF( int LightNumber, LIGHTPARAM *LightParam )
{
	return Graphics_Hardware_D3D9_Light_SetState_PF(  LightNumber, LightParam ) ;
}

// Cg̗LAύX
extern	int		Graphics_Hardware_Light_SetEnable_PF( int LightNumber, int EnableState )
{
	return Graphics_Hardware_D3D9_Light_SetEnable_PF(  LightNumber,  EnableState ) ;
}

























// ˑVhE}bv֌W

// VhE}bvf[^ɕKvȃeNX`쐬
extern	int		Graphics_Hardware_ShadowMap_CreateTexture_PF( SHADOWMAPDATA *ShadowMap, int ASyncThread )
{
	return Graphics_Hardware_D3D9_ShadowMap_CreateTexture_PF( ShadowMap, ASyncThread ) ;
}

// VhE}bvf[^ɕKvȃeNX`
extern	int		Graphics_Hardware_ShadowMap_ReleaseTexture_PF( SHADOWMAPDATA *ShadowMap )
{
	return Graphics_Hardware_D3D9_ShadowMap_ReleaseTexture_PF( ShadowMap ) ;
}

// _VF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_ShadowMap_RefreshVSParam_PF( void )
{
	Graphics_Hardware_D3D9_ShadowMap_RefreshVSParam_PF(  ) ;
}

// sNZVF[_[ɐݒ肷VhE}bv̏XV
extern	void	Graphics_Hardware_ShadowMap_RefreshPSParam_PF( void )
{
	Graphics_Hardware_D3D9_ShadowMap_RefreshPSParam_PF(  ) ;
}

// VhE}bvւ̕`̏s
extern	int		Graphics_Hardware_ShadowMap_DrawSetup_PF( SHADOWMAPDATA *ShadowMap )
{
	return Graphics_Hardware_D3D9_ShadowMap_DrawSetup_PF( ShadowMap ) ;
}

// VhE}bvւ̕`I
extern	int		Graphics_Hardware_ShadowMap_DrawEnd_PF( SHADOWMAPDATA *ShadowMap )
{
	return Graphics_Hardware_D3D9_ShadowMap_DrawEnd_PF( ShadowMap ) ;
}

// `ŎgpVhE}bvw肷( Xbg͂OPw\ )
extern int Graphics_Hardware_ShadowMap_SetUse_PF( int SlotIndex, SHADOWMAPDATA *ShadowMap )
{
	return Graphics_Hardware_D3D9_ShadowMap_SetUse_PF( SlotIndex, ShadowMap ) ;
}
























// ˑVF[_[֌W

// VF[_[nh
extern	int		Graphics_Hardware_Shader_Create_PF( int ShaderHandle, int IsVertexShader, void *Image, int ImageSize, int ImageAfterFree, int ASyncThread )
{
	return Graphics_Hardware_D3D9_Shader_Create_PF(  ShaderHandle,  IsVertexShader, Image,  ImageSize,  ImageAfterFree,  ASyncThread ) ;
}

// VF[_[nȟn
extern	int		Graphics_Hardware_Shader_TerminateHandle_PF( SHADERHANDLEDATA *Shader )
{
	return Graphics_Hardware_D3D9_Shader_TerminateHandle_PF( Shader ) ;
}

// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern	int		Graphics_Hardware_Shader_GetValidShaderVersion_PF( void )
{
	return Graphics_Hardware_D3D9_Shader_GetValidShaderVersion_PF() ;
}

// w̖O萔gpVF[_[萔̔ԍ擾
extern	int		Graphics_Hardware_Shader_GetConstIndex_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return Graphics_Hardware_D3D9_Shader_GetConstIndex_PF( ConstantName, Shader ) ;
}

// w̖O萔gpVF[_[萔̐擾
extern	int		Graphics_Hardware_Shader_GetConstCount_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return Graphics_Hardware_D3D9_Shader_GetConstCount_PF( ConstantName, Shader ) ;
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	const FLOAT4 *Graphics_Hardware_Shader_GetConstDefaultParamF_PF( const TCHAR *ConstantName, SHADERHANDLEDATA *Shader )
{
	return Graphics_Hardware_D3D9_Shader_GetConstDefaultParamF_PF( ConstantName, Shader ) ;
}

// VF[_[萔ݒ肷
extern	int		Graphics_Hardware_Shader_SetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea )
{
	return Graphics_Hardware_D3D9_Shader_SetConst_PF( TypeIndex,  SetIndex,  ConstantIndex, Param,  ParamNum,  UpdateUseArea ) ;
}

// ẅ̃VF[_[萔Zbg
extern	int		Graphics_Hardware_Shader_ResetConst_PF( int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum )
{
	return Graphics_Hardware_D3D9_Shader_ResetConst_PF(  TypeIndex,  SetIndex,  ConstantIndex,  ParamNum ) ;
}

#ifndef DX_NON_MODEL
// Rcfp̃VF[_[R[h̏s
extern	int		Graphics_Hardware_Shader_ModelCode_Init_PF( void )
{
	return Graphics_Hardware_D3D9_Shader_ModelCode_Init_PF() ;
}
#endif // DX_NON_MODEL



























// ˑ`֌W

// _obt@ɗ܂_f[^_O
extern	int		Graphics_Hardware_RenderVertex( int ASyncThread )
{
	return Graphics_D3D9_RenderVertex( ASyncThread ) ;
}

// n[hEGAANZ[^gp DrawBillboard3D
extern	int		Graphics_Hardware_DrawBillboard3D_PF( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int DrawFlag, RECT *DrawArea )
{
	return Graphics_D3D9_DrawBillboard3D( Pos,  cx,  cy,  Size,  Angle, Image, BlendImage,  TransFlag,  TurnFlag,  DrawFlag, DrawArea ) ;
}

// n[hEGAANZ[^gp DrawModiBillboard3D
extern	int		Graphics_Hardware_DrawModiBillboard3D_PF( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int DrawFlag, RECT *DrawArea )
{
	return Graphics_D3D9_DrawModiBillboard3D(  Pos,  x1,  y1,  x2,  y2,  x3,  y3,  x4,  y4, Image, BlendImage,  TransFlag,  DrawFlag, DrawArea ) ;
}

// n[hEGAANZ[^gp DrawGraph
extern	int		Graphics_Hardware_DrawGraph_PF( int x, int y, float xf, float yf, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	return Graphics_D3D9_DrawGraph( x, y, xf, yf, Image, BlendImage, TransFlag, IntFlag ) ;
}

// n[hEGAANZ[^gp DrawExtendGraph
extern	int		Graphics_Hardware_DrawExtendGraph_PF( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int IntFlag )
{
	return Graphics_D3D9_DrawExtendGraph(  x1,  y1,  x2,  y2,  x1f,  y1f,  x2f,  y2f, Image, BlendImage,  TransFlag,  IntFlag ) ;
}

// n[hEGAANZ[^gp DrawRotaGraph
extern	int		Graphics_Hardware_DrawRotaGraph_PF( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, int TurnFlag, int IntFlag )
{
	return Graphics_D3D9_DrawRotaGraph(  x,  y,  xf,  yf,  ExRate,  Angle, Image, BlendImage,  TransFlag,  TurnFlag,  IntFlag ) ;
}

// n[hEGAANZ[^gp DrawModiGraph
extern	int		Graphics_Hardware_DrawModiGraph_PF( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	return Graphics_D3D9_DrawModiGraph(  x1,  y1,  x2,  y2,  x3,  y3,  x4,  y4, Image, BlendImage,  TransFlag, SimpleDrawFlag ) ;
}

// n[hEGAANZ[^gp DrawModiGraphF
extern	int		Graphics_Hardware_DrawModiGraphF_PF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA *Image, IMAGEDATA *BlendImage, int TransFlag, bool SimpleDrawFlag )
{
	return Graphics_D3D9_DrawModiGraphF(  x1,  y1,  x2,  y2,  x3,  y3,  x4,  y4, Image, BlendImage,  TransFlag,  SimpleDrawFlag ) ;
}

// n[hEGAANZ[^gp DrawFillBox
extern	int		Graphics_Hardware_DrawFillBox_PF( int x1, int y1, int x2, int y2, int Color )
{
	return Graphics_D3D9_DrawFillBox(  x1,  y1,  x2,  y2,  Color ) ;
}

// n[hEGAANZ[^gp DrawLineBox
extern	int		Graphics_Hardware_DrawLineBox_PF( int x1, int y1, int x2, int y2, int Color )
{
	return Graphics_D3D9_DrawLineBox(  x1,  y1,  x2,  y2,  Color ) ;
}


// n[hEGAANZ[^gp DrawLine
extern	int		Graphics_Hardware_DrawLine_PF( int x1, int y1, int x2, int y2, int Color )
{
	return Graphics_D3D9_DrawLine(  x1,  y1,  x2,  y2,  Color ) ;
}

// n[hEGAANZ[^gp DrawLine3D
extern	int		Graphics_Hardware_DrawLine3D_PF( VECTOR Pos1, VECTOR Pos2, int Color, int DrawFlag, RECT *DrawArea )
{
	return Graphics_D3D9_DrawLine3D(  Pos1,  Pos2,  Color,  DrawFlag, DrawArea ) ;
}

// n[hEGAANZ[^gp DrawCircle( w肠 )
extern	int		Graphics_Hardware_DrawCircle_Thickness_PF( int x, int y, int r, int Color, int Thickness )
{
	return Graphics_D3D9_DrawCircle_Thickness(  x,  y,  r,  Color,  Thickness ) ;
}

// n[hEGAANZ[^gp DrawOval( w肠 )
extern	int		Graphics_Hardware_DrawOval_Thickness_PF( int x, int y, int rx, int ry, int Color, int Thickness )
{
	return Graphics_D3D9_DrawOval_Thickness(  x,  y,  rx,  ry,  Color,  Thickness ) ;
}

// n[hEGAANZ[^gp DrawCircle
extern	int		Graphics_Hardware_DrawCircle_PF( int x, int y, int r, int Color, int FillFlag )
{
	return Graphics_D3D9_DrawCircle(  x,  y,  r,  Color,  FillFlag ) ;
}

// n[hEGAANZ[^gp DrawOval
extern	int		Graphics_Hardware_DrawOval_PF( int x, int y, int rx, int ry, int Color, int FillFlag )
{
	return Graphics_D3D9_DrawOval(  x,  y,  rx,  ry,  Color,  FillFlag ) ;
}

// n[hEGAANZ[^gp DrawTriangle
extern	int		Graphics_Hardware_DrawTriangle_PF( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag )
{
	return Graphics_D3D9_DrawTriangle(  x1,  y1,  x2,  y2,  x3,  y3,  Color,  FillFlag ) ;
}

// n[hEGAANZ[^gp DrawTriangle3D
extern	int		Graphics_Hardware_DrawTriangle3D_PF( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag, int DrawFlag, RECT *DrawArea )
{
	return Graphics_D3D9_DrawTriangle3D(  Pos1,  Pos2,  Pos3,  Color,  FillFlag,  DrawFlag, DrawArea ) ;
}

// n[hEGAANZ[^gp DrawQuadrangle
extern	int		Graphics_Hardware_DrawQuadrangle_PF( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag )
{
	return Graphics_D3D9_DrawQuadrangle(  x1,  y1,  x2,  y2,  x3,  y3,  x4,  y4,  Color,  FillFlag ) ;
}

// n[hEGAANZ[^gp DrawPixel
extern	int		Graphics_Hardware_DrawPixel_PF( int x, int y, int Color )
{
	return Graphics_D3D9_DrawPixel(  x,  y,  Color ) ;
}

// n[hEGAANZ[^gp DrawPixel3D
extern	int		Graphics_Hardware_DrawPixel3D_PF( VECTOR Pos, int Color, int DrawFlag, RECT *DrawArea )
{
	return Graphics_D3D9_DrawPixel3D(  Pos,  Color,  DrawFlag, DrawArea ) ;
}

// n[hEGAANZ[^gp DrawPixelSet
extern	int		Graphics_Hardware_DrawPixelSet_PF( const POINTDATA *PointData, int Num )
{
	return Graphics_D3D9_DrawPixelSet( PointData,  Num ) ;
}

// n[hEGAANZ[^gp DrawLineSet
extern	int		Graphics_Hardware_DrawLineSet_PF( const LINEDATA *LineData, int Num )
{
	return Graphics_D3D9_DrawLineSet( LineData,  Num ) ;
}


extern	int		Graphics_Hardware_DrawPrimitive_PF(                             const VERTEX_3D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_D3D9_DrawPrimitive( Vertex, VertexNum, PrimitiveType, Image,  TransFlag ) ;
}

extern	int		Graphics_Hardware_DrawIndexedPrimitive_PF(                      const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_D3D9_DrawIndexedPrimitive( Vertex,  VertexNum, Indices, IndexNum,  PrimitiveType, Image,  TransFlag ) ;
}

extern	int		Graphics_Hardware_DrawPrimitiveLight_PF(                        const VERTEX3D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_D3D9_DrawPrimitiveLight(                        Vertex,  VertexNum,                                     PrimitiveType, Image,  TransFlag ) ;
}

extern	int		Graphics_Hardware_DrawIndexedPrimitiveLight_PF(                 const VERTEX3D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_D3D9_DrawIndexedPrimitiveLight(                 Vertex, VertexNum, Indices,  IndexNum,  PrimitiveType, Image,  TransFlag ) ;
}

extern	int		Graphics_Hardware_DrawPrimitiveLight_UseVertexBuffer_PF(        VERTEXBUFFERHANDLEDATA *VertexBuffer,                                      int PrimitiveType,                 int StartVertex, int UseVertexNum, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_D3D9_DrawPrimitiveLight_UseVertexBuffer(        VertexBuffer,                                       PrimitiveType,                  StartVertex,  UseVertexNum, Image,  TransFlag ) ;
}

extern	int		Graphics_Hardware_DrawIndexedPrimitiveLight_UseVertexBuffer_PF( VERTEXBUFFERHANDLEDATA *VertexBuffer, INDEXBUFFERHANDLEDATA *IndexBuffer,  int PrimitiveType, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_D3D9_DrawIndexedPrimitiveLight_UseVertexBuffer( VertexBuffer, IndexBuffer,   PrimitiveType,  BaseVertex,  StartVertex,  UseVertexNum,  StartIndex,  UseIndexNum, Image,  TransFlag ) ;
}

extern	int		Graphics_Hardware_DrawPrimitive2D_PF(                                 VERTEX_2D *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo )
{
	return Graphics_D3D9_DrawPrimitive2D(                                 Vertex,  VertexNum,                                     PrimitiveType, Image,  TransFlag,  BillboardFlag,  Is3D,  TurnFlag,  TextureNo ) ;
}

extern	int		Graphics_Hardware_DrawPrimitive2DUser_PF(                       const VERTEX2D  *Vertex, int VertexNum,                                    int PrimitiveType, IMAGEDATA *Image, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	return Graphics_D3D9_DrawPrimitive2DUser(                       Vertex,  VertexNum,                                     PrimitiveType, Image,  TransFlag,  Is3D,  TurnFlag,  TextureNo ) ;
}

extern	int		Graphics_Hardware_DrawIndexedPrimitive2DUser_PF(                const VERTEX2D  *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA *Image, int TransFlag )
{
	return Graphics_D3D9_DrawIndexedPrimitive2DUser(                Vertex,  VertexNum, Indices,  IndexNum,  PrimitiveType, Image,  TransFlag ) ;
}

// VF[_[gĂQc|S`悷
extern	int		Graphics_Hardware_DrawPolygon2DToShader_PF(          const VERTEX2DSHADER *Vertex, int PolygonNum )
{
	return Graphics_D3D9_DrawPolygon2DToShader(          Vertex,  PolygonNum ) ;
}

// VF[_[gĂRc|S`悷
extern	int		Graphics_Hardware_DrawPolygon3DToShader_PF(          const VERTEX3DSHADER *Vertex, int PolygonNum )
{
	return Graphics_D3D9_DrawPolygon3DToShader(          Vertex,  PolygonNum ) ;
}

// VF[_[gĂQc|S`悷( _CfbNXgp )
extern	int		Graphics_Hardware_DrawPolygonIndexed2DToShader_PF(   const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	return Graphics_D3D9_DrawPolygonIndexed2DToShader(   Vertex,  VertexNum, Indices,  PolygonNum ) ;
}

// VF[_[gĂRc|S`悷( _CfbNXgp )
extern	int		Graphics_Hardware_DrawPolygonIndexed3DToShader_PF(   const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	return Graphics_D3D9_DrawPolygonIndexed3DToShader(   Vertex,  VertexNum, Indices,  PolygonNum ) ;
}

// VF[_[gĂQcv~eBu`悷
extern	int		Graphics_Hardware_DrawPrimitive2DToShader_PF(        const VERTEX2DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	return Graphics_D3D9_DrawPrimitive2DToShader(        Vertex,  VertexNum,                                               PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;
}

// VF[_[gĂRcv~eBu`悷
extern	int		Graphics_Hardware_DrawPrimitive3DToShader_PF(        const VERTEX3DSHADER *Vertex, int VertexNum,                                              int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	return Graphics_D3D9_DrawPrimitive3DToShader(        Vertex,  VertexNum,                                               PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;
}

// VF[_[gĂQcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_Hardware_DrawPrimitiveIndexed2DToShader_PF( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	return Graphics_D3D9_DrawPrimitiveIndexed2DToShader( Vertex,  VertexNum, Indices,  IndexNum,  PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;
}

// VF[_[gĂRcv~eBu`悷( _CfbNXgp )
extern	int		Graphics_Hardware_DrawPrimitiveIndexed3DToShader_PF( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	return Graphics_D3D9_DrawPrimitiveIndexed3DToShader( Vertex,  VertexNum, Indices,  IndexNum,  PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;
}


// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_Hardware_DrawPrimitive3DToShader_UseVertexBuffer_PF(         int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	return Graphics_D3D9_DrawPrimitive3DToShader_UseVertexBuffer(          VertexBufHandle,                      PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_Hardware_DrawPrimitiveIndexed3DToShader_UseVertexBuffer_PF(  int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	return Graphics_D3D9_DrawPrimitiveIndexed3DToShader_UseVertexBuffer(   VertexBufHandle,  IndexBufHandle,  PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int		Graphics_Hardware_DrawPrimitive3DToShader_UseVertexBuffer2_PF(        int VertexBufHandle,                     int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum )
{
	return Graphics_D3D9_DrawPrimitive3DToShader_UseVertexBuffer2(         VertexBufHandle,                      PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */,  StartVertex,  UseVertexNum ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int		Graphics_Hardware_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2_PF( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum )
{
	return Graphics_D3D9_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2(  VertexBufHandle,  IndexBufHandle,  PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */,  BaseVertex,  StartVertex,  UseVertexNum,  StartIndex,  UseIndexNum ) ;
}

// w_狫EFƂ܂œhԂ
extern	int		Graphics_Hardware_Paint_PF( int x, int y, int FillColor, int BoundaryColor )
{
	return Graphics_Hardware_D3D9_Paint_PF(  x,  y,  FillColor,  BoundaryColor ) ;
}






























#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

